//usb.c


static USBmbw[ ( MAX_PIPE_NO + 1 )];


const USB_U16 BitSet[16] = {	0x0001, 0x0002, 0x0004, 0x0008,
								0x0010, 0x0020, 0x0040, 0x0080,
								0x0100, 0x0200, 0x0400, 0x0800,
								0x1000, 0x2000, 0x4000, 0x8000 };

USB_U32 USBDataCount[MAX_PIPE_NO + 1];		/* PIPEn Buffer counter */
USB_U32 USBRcvDataCount[MAX_PIPE_NO + 1];	/* PIPEn receive data counter */
USB_U8  *USBDataPointer[MAX_PIPE_NO + 1];	/* PIPEn Buffer pointer(8bit) */

USB_U16	ConfigNum;

USB_U16	PipeIgnore[ MAX_PIPE_NO + 1 ];			/* Ignore count */
USB_U16	PipeTbl[ MAX_PIPE_NO + 1 ];				/* C/D FIFO | DIR | EPnum */
USB_U16	PipeFlag[ MAX_PIPE_NO + 1 ];			/* data flag */
USB_U32	PipeDataSize[ MAX_PIPE_NO + 1 ];		/* data size */

USB_DMA	USBDmaInfo[2];							/* DMA Setting Infomation */
USB_U16	USBDmaPipe[2];							/* DMA Transfar Pipe */
USB_U16	USBDmaVal[2];							/* VAL(FIFOCTR) set flag after dma end */
USB_U16 USBDmaStatus[2];						/* DMA Transfer Flag */



/* ******** global for Applications	******************************************/
/* Idle/Setup Stage */

void (*pbRequest0[13])(USB_U16 Reqtype, USB_U16 Value, USB_U16 Index, USB_U16 Length) = {
	P_Resrv_0,				P_Resrv_0,				P_Resrv_0,
	P_Resrv_0,				P_Resrv_0,				P_Resrv_0,
	P_Resrv_0,				P_Resrv_0,				P_Resrv_0,
	P_Resrv_0,				P_Resrv_0,				P_Resrv_0,
	P_Resrv_0
};



/* Control Read Data Stage */

void (*pbRequest1[13])(USB_U16 Reqtype, USB_U16 Value, USB_U16 Index, USB_U16 Length) = {
	P_GetStatus,			P_Resrv_123,			P_Resrv_123,
	P_Resrv_123,			P_Resrv_123,			P_Resrv_123,
	P_GetDescriptor,		P_Resrv_123,			P_GetConfiguration,
	P_Resrv_123,			P_GetInterface,			P_Resrv_123,
	P_SynchFrame
};

/* Control Write Data Stage */
void (*pbRequest2[13])(USB_U16 Reqtype, USB_U16 Value, USB_U16 Index, USB_U16 Length) = {
	P_Resrv_123,			P_Resrv_123,			P_Resrv_123,
	P_Resrv_123,			P_Resrv_123,			P_Resrv_123,
	P_Resrv_123,			P_SetDescriptor,		P_Resrv_123,
	P_Resrv_123,			P_Resrv_123,			P_Resrv_123,
	P_Resrv_123
};

/* Control Write No Data Status Stage */
void (*pbRequest3[13])(USB_U16 Reqtype, USB_U16 Value, USB_U16 Index, USB_U16 Length) = {
	P_Resrv_123,			P_ClearFeature,			P_Resrv_123,
	P_SetFeature,			P_Resrv_123,			P_SetAddress,
	P_Resrv_123,			P_Resrv_123,			P_Resrv_123,
	P_SetConfiguration,		P_Resrv_123,			P_SetInterface,
	P_Resrv_123
};

/* Control Read Status Stage */
void (*pbRequest4[13])(USB_U16 Reqtype, USB_U16 Value, USB_U16 Index, USB_U16 Length) = {
	P_Resrv_4,				P_Resrv_4,				P_Resrv_4,
	P_Resrv_4,				P_Resrv_4,				P_Resrv_4,
	P_Resrv_4,				P_Resrv_4,				P_Resrv_4,
	P_Resrv_4,				P_Resrv_4,				P_Resrv_4,
	P_Resrv_4
};

/* Control Write Status Stage */
void (*pbRequest5[13])(USB_U16 Reqtype, USB_U16 Value, USB_U16 Index, USB_U16 Length) = {
	P_Resrv_5,				P_Resrv_5,				P_Resrv_5,
	P_Resrv_5,				P_Resrv_5,				P_Resrv_5,
	P_Resrv_5,				P_Resrv_5,				P_Resrv_5,
	P_Resrv_5,				P_Resrv_5,				P_Resrv_5,
	P_Resrv_5
};

USB_U16	 Alternate[ALT_NO];					/* Alternate */
USB_U16	 RemoteWakeupFlag ;					/* Remote Wakeup Enable Flag */
USB_U16	 TestModeFlag ;						/* Test Mode Flag */
USB_U16  TestModeSelectors;					/* Test Mode Selectors */

USB_U16	 ReqType;							/* request type */
USB_U16	 ReqTypeType;						/* request type TYPE */
USB_U16	 ReqTypeRecip;						/* request type RECIPIENT */
USB_U16	 ReqRequest;						/* request */
USB_U16  ReqValue;							/* value */
USB_U16  ReqIndex;							/* index */
USB_U16  ReqLength;							/* length */

USB_U16	 EPTableIndex[MAX_EP_NO + 1];		/* Index of Endpoint Information table */





USB_U16  TestModeSelectors;






USB_U8 P1_Buff[P1_BUF_SIZE] = {
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,
	0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,
	0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
	0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF,
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,
	0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,
	0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
	0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

USB_U8 P2_Buff[P2_BUF_SIZE] = {
	0x0F,0x0E,0x0D,0x0C,0x0B,0x0A,0x09,0x08,0x07,0x06,0x05,0x04,0x03,0x02,0x01,0x00,
	0x1F,0x1E,0x1D,0x1C,0x1B,0x1A,0x19,0x18,0x17,0x16,0x15,0x14,0x13,0x12,0x11,0x10,
	0x2F,0x2E,0x2D,0x2C,0x2B,0x2A,0x29,0x28,0x27,0x26,0x25,0x24,0x23,0x22,0x21,0x20,
	0x3F,0x3E,0x3D,0x3C,0x3B,0x3A,0x39,0x38,0x37,0x36,0x35,0x34,0x33,0x32,0x31,0x30,
	0x4F,0x4E,0x4D,0x4C,0x4B,0x4A,0x49,0x48,0x47,0x46,0x45,0x44,0x43,0x42,0x41,0x40,
	0x5F,0x5E,0x5D,0x5C,0x5B,0x5A,0x59,0x58,0x57,0x56,0x55,0x54,0x53,0x52,0x51,0x50,
	0x6F,0x6E,0x6D,0x6C,0x6B,0x6A,0x69,0x68,0x67,0x66,0x65,0x64,0x63,0x62,0x61,0x60,
	0x7F,0x7E,0x7D,0x7C,0x7B,0x7A,0x79,0x78,0x77,0x76,0x75,0x74,0x73,0x72,0x71,0x70,
	0x8F,0x8E,0x8D,0x8C,0x8B,0x8A,0x89,0x88,0x87,0x86,0x85,0x84,0x83,0x82,0x81,0x80,
	0x9F,0x9E,0x9D,0x9C,0x9B,0x9A,0x99,0x98,0x97,0x96,0x95,0x94,0x93,0x92,0x91,0x90,
	0xAF,0xAE,0xAD,0xAC,0xAB,0xAA,0xA9,0xA8,0xA7,0xA6,0xA5,0xA4,0xA3,0xA2,0xA1,0xA0,
	0xBF,0xBE,0xBD,0xBC,0xBB,0xBA,0xB9,0xB8,0xB7,0xB6,0xB5,0xB4,0xB3,0xB2,0xB1,0xB0,
	0xCF,0xCE,0xCD,0xCC,0xCB,0xCA,0xC9,0xC8,0xC7,0xC6,0xC5,0xC4,0xC3,0xC2,0xC1,0xC0,
	0xDF,0xDE,0xDD,0xDC,0xDB,0xDA,0xD9,0xD8,0xD7,0xD6,0xD5,0xD4,0xD3,0xD2,0xD1,0xD0,
	0xEF,0xEE,0xED,0xEC,0xEB,0xEA,0xE9,0xE8,0xE7,0xE6,0xE5,0xE4,0xE3,0xE2,0xE1,0xE0,
	0xFF,0xFE,0xFD,0xFC,0xFB,0xFA,0xF9,0xF8,0xF7,0xF6,0xF5,0xF4,0xF3,0xF2,0xF1,0xF0,
	0x0F,0x0E,0x0D,0x0C,0x0B,0x0A,0x09,0x08,0x07,0x06,0x05,0x04,0x03,0x02,0x01,0x00,
	0x1F,0x1E,0x1D,0x1C,0x1B,0x1A,0x19,0x18,0x17,0x16,0x15,0x14,0x13,0x12,0x11,0x10,
	0x2F,0x2E,0x2D,0x2C,0x2B,0x2A,0x29,0x28,0x27,0x26,0x25,0x24,0x23,0x22,0x21,0x20,
	0x3F,0x3E,0x3D,0x3C,0x3B,0x3A,0x39,0x38,0x37,0x36,0x35,0x34,0x33,0x32,0x31,0x30,
	0x4F,0x4E,0x4D,0x4C,0x4B,0x4A,0x49,0x48,0x47,0x46,0x45,0x44,0x43,0x42,0x41,0x40,
	0x5F,0x5E,0x5D,0x5C,0x5B,0x5A,0x59,0x58,0x57,0x56,0x55,0x54,0x53,0x52,0x51,0x50,
	0x6F,0x6E,0x6D,0x6C,0x6B,0x6A,0x69,0x68,0x67,0x66,0x65,0x64,0x63,0x62,0x61,0x60,
	0x7F,0x7E,0x7D,0x7C,0x7B,0x7A,0x79,0x78,0x77,0x76,0x75,0x74,0x73,0x72,0x71,0x70,
	0x8F,0x8E,0x8D,0x8C,0x8B,0x8A,0x89,0x88,0x87,0x86,0x85,0x84,0x83,0x82,0x81,0x80,
	0x9F,0x9E,0x9D,0x9C,0x9B,0x9A,0x99,0x98,0x97,0x96,0x95,0x94,0x93,0x92,0x91,0x90,
	0xAF,0xAE,0xAD,0xAC,0xAB,0xAA,0xA9,0xA8,0xA7,0xA6,0xA5,0xA4,0xA3,0xA2,0xA1,0xA0,
	0xBF,0xBE,0xBD,0xBC,0xBB,0xBA,0xB9,0xB8,0xB7,0xB6,0xB5,0xB4,0xB3,0xB2,0xB1,0xB0,
	0xCF,0xCE,0xCD,0xCC,0xCB,0xCA,0xC9,0xC8,0xC7,0xC6,0xC5,0xC4,0xC3,0xC2,0xC1,0xC0,
	0xDF,0xDE,0xDD,0xDC,0xDB,0xDA,0xD9,0xD8,0xD7,0xD6,0xD5,0xD4,0xD3,0xD2,0xD1,0xD0,
	0xEF,0xEE,0xED,0xEC,0xEB,0xEA,0xE9,0xE8,0xE7,0xE6,0xE5,0xE4,0xE3,0xE2,0xE1,0xE0,
	0xFF,0xFE,0xFD,0xFC,0xFB,0xFA,0xF9,0xF8,0xF7,0xF6,0xF5,0xF4,0xF3,0xF2,0xF1,0xF0
};

USB_U8 P3_Buff[P3_BUF_SIZE] = {
	0xFF,0xFE,0xFD,0xFC,0xFB,0xFA,0xF9,0xF8,0xF7,0xF6,0xF5,0xF4,0xF3,0xF2,0xF1,0xF0,
	0xEF,0xEE,0xED,0xEC,0xEB,0xEA,0xE9,0xE8,0xE7,0xE6,0xE5,0xE4,0xE3,0xE2,0xE1,0xE0,
	0xDF,0xDE,0xDD,0xDC,0xDB,0xDA,0xD9,0xD8,0xD7,0xD6,0xD5,0xD4,0xD3,0xD2,0xD1,0xD0,
	0xCF,0xCE,0xCD,0xCC,0xCB,0xCA,0xC9,0xC8,0xC7,0xC6,0xC5,0xC4,0xC3,0xC2,0xC1,0xC0,
	0xBF,0xBE,0xBD,0xBC,0xBB,0xBA,0xB9,0xB8,0xB7,0xB6,0xB5,0xB4,0xB3,0xB2,0xB1,0xB0,
	0xAF,0xAE,0xAD,0xAC,0xAB,0xAA,0xA9,0xA8,0xA7,0xA6,0xA5,0xA4,0xA3,0xA2,0xA1,0xA0,
	0x9F,0x9E,0x9D,0x9C,0x9B,0x9A,0x99,0x98,0x97,0x96,0x95,0x94,0x93,0x92,0x91,0x90,
	0x8F,0x8E,0x8D,0x8C,0x8B,0x8A,0x89,0x88,0x87,0x86,0x85,0x84,0x83,0x82,0x81,0x80,
	0x7F,0x7E,0x7D,0x7C,0x7B,0x7A,0x79,0x78,0x77,0x76,0x75,0x74,0x73,0x72,0x71,0x70,
	0x6F,0x6E,0x6D,0x6C,0x6B,0x6A,0x69,0x68,0x67,0x66,0x65,0x64,0x63,0x62,0x61,0x60,
	0x5F,0x5E,0x5D,0x5C,0x5B,0x5A,0x59,0x58,0x57,0x56,0x55,0x54,0x53,0x52,0x51,0x50,
	0x4F,0x4E,0x4D,0x4C,0x4B,0x4A,0x49,0x48,0x47,0x46,0x45,0x44,0x43,0x42,0x41,0x40,
	0x3F,0x3E,0x3D,0x3C,0x3B,0x3A,0x39,0x38,0x37,0x36,0x35,0x34,0x33,0x32,0x31,0x30,
	0x2F,0x2E,0x2D,0x2C,0x2B,0x2A,0x29,0x28,0x27,0x26,0x25,0x24,0x23,0x22,0x21,0x20,
	0x1F,0x1E,0x1D,0x1C,0x1B,0x1A,0x19,0x18,0x17,0x16,0x15,0x14,0x13,0x12,0x11,0x10,
	0x0F,0x0E,0x0D,0x0C,0x0B,0x0A,0x09,0x08,0x07,0x06,0x05,0x04,0x03,0x02,0x01,0x00,
	0xFF,0xFE,0xFD,0xFC,0xFB,0xFA,0xF9,0xF8,0xF7,0xF6,0xF5,0xF4,0xF3,0xF2,0xF1,0xF0,
	0xEF,0xEE,0xED,0xEC,0xEB,0xEA,0xE9,0xE8,0xE7,0xE6,0xE5,0xE4,0xE3,0xE2,0xE1,0xE0,
	0xDF,0xDE,0xDD,0xDC,0xDB,0xDA,0xD9,0xD8,0xD7,0xD6,0xD5,0xD4,0xD3,0xD2,0xD1,0xD0,
	0xCF,0xCE,0xCD,0xCC,0xCB,0xCA,0xC9,0xC8,0xC7,0xC6,0xC5,0xC4,0xC3,0xC2,0xC1,0xC0,
	0xBF,0xBE,0xBD,0xBC,0xBB,0xBA,0xB9,0xB8,0xB7,0xB6,0xB5,0xB4,0xB3,0xB2,0xB1,0xB0,
	0xAF,0xAE,0xAD,0xAC,0xAB,0xAA,0xA9,0xA8,0xA7,0xA6,0xA5,0xA4,0xA3,0xA2,0xA1,0xA0,
	0x9F,0x9E,0x9D,0x9C,0x9B,0x9A,0x99,0x98,0x97,0x96,0x95,0x94,0x93,0x92,0x91,0x90,
	0x8F,0x8E,0x8D,0x8C,0x8B,0x8A,0x89,0x88,0x87,0x86,0x85,0x84,0x83,0x82,0x81,0x80,
	0x7F,0x7E,0x7D,0x7C,0x7B,0x7A,0x79,0x78,0x77,0x76,0x75,0x74,0x73,0x72,0x71,0x70,
	0x6F,0x6E,0x6D,0x6C,0x6B,0x6A,0x69,0x68,0x67,0x66,0x65,0x64,0x63,0x62,0x61,0x60,
	0x5F,0x5E,0x5D,0x5C,0x5B,0x5A,0x59,0x58,0x57,0x56,0x55,0x54,0x53,0x52,0x51,0x50,
	0x4F,0x4E,0x4D,0x4C,0x4B,0x4A,0x49,0x48,0x47,0x46,0x45,0x44,0x43,0x42,0x41,0x40,
	0x3F,0x3E,0x3D,0x3C,0x3B,0x3A,0x39,0x38,0x37,0x36,0x35,0x34,0x33,0x32,0x31,0x30,
	0x2F,0x2E,0x2D,0x2C,0x2B,0x2A,0x29,0x28,0x27,0x26,0x25,0x24,0x23,0x22,0x21,0x20,
	0x1F,0x1E,0x1D,0x1C,0x1B,0x1A,0x19,0x18,0x17,0x16,0x15,0x14,0x13,0x12,0x11,0x10,
	0x0F,0x0E,0x0D,0x0C,0x0B,0x0A,0x09,0x08,0x07,0x06,0x05,0x04,0x03,0x02,0x01,0x00
};

USB_U8 P4_Buff[P4_BUF_SIZE] = {
	0x00,0x10,0x20,0x30,0x40,0x50,0x60,0x70,0x80,0x90,0xA0,0xB0,0xC0,0xD0,0xE0,0xF0,
	0x01,0x11,0x21,0x31,0x41,0x51,0x61,0x71,0x81,0x91,0xA1,0xB1,0xC1,0xD1,0xE1,0xF1,
	0x02,0x12,0x22,0x32,0x42,0x52,0x62,0x72,0x82,0x92,0xA2,0xB2,0xC2,0xD2,0xE2,0xF2,
	0x03,0x13,0x23,0x33,0x43,0x53,0x63,0x73,0x83,0x93,0xA3,0xB3,0xC3,0xD3,0xE3,0xF3,
	0x04,0x14,0x24,0x34,0x44,0x54,0x64,0x74,0x84,0x94,0xA4,0xB4,0xC4,0xD4,0xE4,0xF4,
	0x05,0x15,0x25,0x35,0x45,0x55,0x65,0x75,0x85,0x95,0xA5,0xB5,0xC5,0xD5,0xE5,0xF5,
	0x06,0x16,0x26,0x36,0x46,0x56,0x66,0x76,0x86,0x96,0xA6,0xB6,0xC6,0xD6,0xE6,0xF6,
	0x07,0x17,0x27,0x37,0x47,0x57,0x67,0x77,0x87,0x97,0xA7,0xB7,0xC7,0xD7,0xE7,0xF7,
	0x08,0x18,0x28,0x38,0x48,0x58,0x68,0x78,0x88,0x98,0xA8,0xB8,0xC8,0xD8,0xE8,0xF8,
	0x09,0x19,0x29,0x39,0x49,0x59,0x69,0x79,0x89,0x99,0xA9,0xB9,0xC9,0xD9,0xE9,0xF9,
	0x0A,0x1A,0x2A,0x3A,0x4A,0x5A,0x6A,0x7A,0x8A,0x9A,0xAA,0xBA,0xCA,0xDA,0xEA,0xFA,
	0x0B,0x1B,0x2B,0x3B,0x4B,0x5B,0x6B,0x7B,0x8B,0x9B,0xAB,0xBB,0xCB,0xDB,0xEB,0xFB,
	0x0C,0x1C,0x2C,0x3C,0x4C,0x5C,0x6C,0x7C,0x8C,0x9C,0xAC,0xBC,0xCC,0xDC,0xEC,0xFC,
	0x0D,0x1D,0x2D,0x3D,0x4D,0x5D,0x6D,0x7D,0x8D,0x9D,0xAD,0xBD,0xCD,0xDD,0xED,0xFD,
	0x0E,0x1E,0x2E,0x3E,0x4E,0x5E,0x6E,0x7E,0x8E,0x9E,0xAE,0xBE,0xCE,0xDE,0xEE,0xFE,
	0x0F,0x1F,0x2F,0x3F,0x4F,0x5F,0x6F,0x7F,0x8F,0x9F,0xAF,0xBF,0xCF,0xDF,0xEF,0xFF,
	0x00,0x10,0x20,0x30,0x40,0x50,0x60,0x70,0x80,0x90,0xA0,0xB0,0xC0,0xD0,0xE0,0xF0,
	0x01,0x11,0x21,0x31,0x41,0x51,0x61,0x71,0x81,0x91,0xA1,0xB1,0xC1,0xD1,0xE1,0xF1,
	0x02,0x12,0x22,0x32,0x42,0x52,0x62,0x72,0x82,0x92,0xA2,0xB2,0xC2,0xD2,0xE2,0xF2,
	0x03,0x13,0x23,0x33,0x43,0x53,0x63,0x73,0x83,0x93,0xA3,0xB3,0xC3,0xD3,0xE3,0xF3,
	0x04,0x14,0x24,0x34,0x44,0x54,0x64,0x74,0x84,0x94,0xA4,0xB4,0xC4,0xD4,0xE4,0xF4,
	0x05,0x15,0x25,0x35,0x45,0x55,0x65,0x75,0x85,0x95,0xA5,0xB5,0xC5,0xD5,0xE5,0xF5,
	0x06,0x16,0x26,0x36,0x46,0x56,0x66,0x76,0x86,0x96,0xA6,0xB6,0xC6,0xD6,0xE6,0xF6,
	0x07,0x17,0x27,0x37,0x47,0x57,0x67,0x77,0x87,0x97,0xA7,0xB7,0xC7,0xD7,0xE7,0xF7,
	0x08,0x18,0x28,0x38,0x48,0x58,0x68,0x78,0x88,0x98,0xA8,0xB8,0xC8,0xD8,0xE8,0xF8,
	0x09,0x19,0x29,0x39,0x49,0x59,0x69,0x79,0x89,0x99,0xA9,0xB9,0xC9,0xD9,0xE9,0xF9,
	0x0A,0x1A,0x2A,0x3A,0x4A,0x5A,0x6A,0x7A,0x8A,0x9A,0xAA,0xBA,0xCA,0xDA,0xEA,0xFA,
	0x0B,0x1B,0x2B,0x3B,0x4B,0x5B,0x6B,0x7B,0x8B,0x9B,0xAB,0xBB,0xCB,0xDB,0xEB,0xFB,
	0x0C,0x1C,0x2C,0x3C,0x4C,0x5C,0x6C,0x7C,0x8C,0x9C,0xAC,0xBC,0xCC,0xDC,0xEC,0xFC,
	0x0D,0x1D,0x2D,0x3D,0x4D,0x5D,0x6D,0x7D,0x8D,0x9D,0xAD,0xBD,0xCD,0xDD,0xED,0xFD,
	0x0E,0x1E,0x2E,0x3E,0x4E,0x5E,0x6E,0x7E,0x8E,0x9E,0xAE,0xBE,0xCE,0xDE,0xEE,0xFE,
	0x0F,0x1F,0x2F,0x3F,0x4F,0x5F,0x6F,0x7F,0x8F,0x9F,0xAF,0xBF,0xCF,0xDF,0xEF,0xFF
};

USB_U8 P5_Buff[P5_BUF_SIZE] = {
	0xF0,0xE0,0xD0,0xC0,0xB0,0xA0,0x90,0x80,0x70,0x60,0x50,0x40,0x30,0x20,0x10,0x00,
	0xF1,0xE1,0xD1,0xC1,0xB1,0xA1,0x91,0x81,0x71,0x61,0x51,0x41,0x31,0x21,0x11,0x01,
	0xF2,0xE2,0xD2,0xC2,0xB2,0xA2,0x92,0x82,0x72,0x62,0x52,0x42,0x32,0x22,0x12,0x02,
	0xF3,0xE3,0xD3,0xC3,0xB3,0xA3,0x93,0x83,0x73,0x63,0x53,0x43,0x33,0x23,0x13,0x03,
	0xF4,0xE4,0xD4,0xC4,0xB4,0xA4,0x94,0x84,0x74,0x64,0x54,0x44,0x34,0x24,0x14,0x04,
	0xF5,0xE5,0xD5,0xC5,0xB5,0xA5,0x95,0x85,0x75,0x65,0x55,0x45,0x35,0x25,0x15,0x05,
	0xF6,0xE6,0xD6,0xC6,0xB6,0xA6,0x96,0x86,0x76,0x66,0x56,0x46,0x36,0x26,0x16,0x06,
	0xF7,0xE7,0xD7,0xC7,0xB7,0xA7,0x97,0x87,0x77,0x67,0x57,0x47,0x37,0x27,0x17,0x07,
	0xF8,0xE8,0xD8,0xC8,0xB8,0xA8,0x98,0x88,0x78,0x68,0x58,0x48,0x38,0x28,0x18,0x08,
	0xF9,0xE9,0xD9,0xC9,0xB9,0xA9,0x99,0x89,0x79,0x69,0x59,0x49,0x39,0x29,0x19,0x09,
	0xFA,0xEA,0xDA,0xCA,0xBA,0xAA,0x9A,0x8A,0x7A,0x6A,0x5A,0x4A,0x3A,0x2A,0x1A,0x0A,
	0xFB,0xEB,0xDB,0xCB,0xBB,0xAB,0x9B,0x8B,0x7B,0x6B,0x5B,0x4B,0x3B,0x2B,0x1B,0x0B,
	0xFC,0xEC,0xDC,0xCC,0xBC,0xAC,0x9C,0x8C,0x7C,0x6C,0x5C,0x4C,0x3C,0x2C,0x1C,0x0C,
	0xFD,0xED,0xDD,0xCD,0xBD,0xAD,0x9D,0x8D,0x7D,0x6D,0x5D,0x4D,0x3D,0x2D,0x1D,0x0D,
	0xFE,0xEE,0xDE,0xCE,0xBE,0xAE,0x9E,0x8E,0x7E,0x6E,0x5E,0x4E,0x3E,0x2E,0x1E,0x0E,
	0xFF,0xEF,0xDF,0xCF,0xBF,0xAF,0x9F,0x8F,0x7F,0x6F,0x5F,0x4F,0x3F,0x2F,0x1F,0x0F,
	0xF0,0xE0,0xD0,0xC0,0xB0,0xA0,0x90,0x80,0x70,0x60,0x50,0x40,0x30,0x20,0x10,0x00,
	0xF1,0xE1,0xD1,0xC1,0xB1,0xA1,0x91,0x81,0x71,0x61,0x51,0x41,0x31,0x21,0x11,0x01,
	0xF2,0xE2,0xD2,0xC2,0xB2,0xA2,0x92,0x82,0x72,0x62,0x52,0x42,0x32,0x22,0x12,0x02,
	0xF3,0xE3,0xD3,0xC3,0xB3,0xA3,0x93,0x83,0x73,0x63,0x53,0x43,0x33,0x23,0x13,0x03,
	0xF4,0xE4,0xD4,0xC4,0xB4,0xA4,0x94,0x84,0x74,0x64,0x54,0x44,0x34,0x24,0x14,0x04,
	0xF5,0xE5,0xD5,0xC5,0xB5,0xA5,0x95,0x85,0x75,0x65,0x55,0x45,0x35,0x25,0x15,0x05,
	0xF6,0xE6,0xD6,0xC6,0xB6,0xA6,0x96,0x86,0x76,0x66,0x56,0x46,0x36,0x26,0x16,0x06,
	0xF7,0xE7,0xD7,0xC7,0xB7,0xA7,0x97,0x87,0x77,0x67,0x57,0x47,0x37,0x27,0x17,0x07,
	0xF8,0xE8,0xD8,0xC8,0xB8,0xA8,0x98,0x88,0x78,0x68,0x58,0x48,0x38,0x28,0x18,0x08,
	0xF9,0xE9,0xD9,0xC9,0xB9,0xA9,0x99,0x89,0x79,0x69,0x59,0x49,0x39,0x29,0x19,0x09,
	0xFA,0xEA,0xDA,0xCA,0xBA,0xAA,0x9A,0x8A,0x7A,0x6A,0x5A,0x4A,0x3A,0x2A,0x1A,0x0A,
	0xFB,0xEB,0xDB,0xCB,0xBB,0xAB,0x9B,0x8B,0x7B,0x6B,0x5B,0x4B,0x3B,0x2B,0x1B,0x0B,
	0xFC,0xEC,0xDC,0xCC,0xBC,0xAC,0x9C,0x8C,0x7C,0x6C,0x5C,0x4C,0x3C,0x2C,0x1C,0x0C,
	0xFD,0xED,0xDD,0xCD,0xBD,0xAD,0x9D,0x8D,0x7D,0x6D,0x5D,0x4D,0x3D,0x2D,0x1D,0x0D,
	0xFE,0xEE,0xDE,0xCE,0xBE,0xAE,0x9E,0x8E,0x7E,0x6E,0x5E,0x4E,0x3E,0x2E,0x1E,0x0E,
	0xFF,0xEF,0xDF,0xCF,0xBF,0xAF,0x9F,0x8F,0x7F,0x6F,0x5F,0x4F,0x3F,0x2F,0x1F,0x0F
};

USB_U8 P6_Buff[P6_BUF_SIZE] = {
	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,
	0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,
	0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,
	0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,
	0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,
	0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,
	0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,
	0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,
	0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,
	0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,
	0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,
	0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,
	0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,
	0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,
	0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,
	0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,
	0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,0xF2,
	0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,0xF3,
	0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,0xF4,
	0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,0xF5,
	0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,0xF6,
	0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,0xF7,
	0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,
	0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,0xF9,
	0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,0xFA,
	0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,
	0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,
	0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,
	0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
};

USB_U8 P7_Buff[P7_BUF_SIZE] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,
	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
	0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
	0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
	0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,
	0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,
	0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,
	0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,
	0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,
	0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,
	0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,
	0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,
	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,
	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
	0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
	0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
	0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,
	0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,
	0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,
	0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,
	0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,
	0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,
	0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,
	0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,
	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0
};

USB_U8 P8_Buff[P8_BUF_SIZE] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,
	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
	0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
	0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
	0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,
	0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,
	0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,
	0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,
	0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,
	0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,
	0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,
	0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,
	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,
	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
	0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
	0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
	0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,
	0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,
	0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,
	0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,
	0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,
	0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,
	0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,
	0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,
	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0
};

USB_U8 P9_Buff[P9_BUF_SIZE] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,
	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
	0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
	0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
	0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,
	0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,
	0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,
	0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,
	0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,
	0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,
	0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,
	0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,
	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,
	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
	0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
	0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
	0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x50,
	0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,
	0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,
	0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,
	0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,
	0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,
	0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,0xD0,
	0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,
	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0
};


/*
 ******************************************************************************
 * Endpoint Configuration Data Format
 ******************************************************************************
 *	LINE1: Pipe Window Select Register (0x64)
 *		CPU Access PIPE					: PIPE1 to PIPE9
 *		Select FIFO port				: C_FIFO_USE / D0_FIFO_USE / D1_FIFO_USE
 *                                      : D0_FIFO_DMA / D1_FIFO_DMA
 *	LINE2: Pipe Configuration Register (0x66)
 *		Transfer Type					: ISO / INT / BULK
 *		Double Buffer Mode				: DBLB / OFF		(PIPE1-5 only)
 *		Continuous Transmit/Receive Mode: CNTMD / OFF		(PIPE1-5 only)
 *		Transfer Direction				: DIR_P_IN / DIR_P_OUT
 *		Endpoint Number					: EP1 to EP15
 *	LINE3: Pipe Buffer Configuration Register (0x68)
 *		Buffer Size						: BUF_SIZE(x)		(PIPE1-5: x:64 to 2048)
 *										:					(PIPE6-9: x:64)
 *		Buffer Top Number				: 4 to 79
 * 										:		(PIPE6:4, PIPE7:5, PIPE8:6, PIPE9:7)
 *	LINE4: Pipe Maxpacket Size Register (0x6A)
 *		Max Packet Size					: 0 to 1024
 *	LINE5: Pipe Cycle Configuration Register (0x6C)
 *		ISO Buffer Flush Mode			: IFIS / OFF
 *		ISO Interval Value				: 0 to 7
 ******************************************************************************
 */





/*
 *	|--- Configuration 1
 *	|		|--- Interface 1-0-0
 *	|		|		|--- Endpoint 1-0-0-0
 */


/* Configuration 1 */
USB_U16  EPtbl_1[] = {
///////////////////////////////////////////////////////////////////////
	/* Pipe Window Select Register (0x64) */
	PIPE1 | D0_FIFO_DMA,
	/* Pipe Configuration Register (0x66) */
	BULK | DBLBON | CNTMDON | DIR_P_OUT | EP1,
	/* Pipe Buffer Configuration Register (0x68) */
	BUF_SIZE(512) | 8,
	/* Pipe Maxpacket Size Register (0x6A) */
	512,
	/* Pipe Cycle Configuration Register (0x6C) */
	USB_OFF | 0,
///////////////////////////////////////////////////////////////////////
	/* Pipe Window Select Register (0x64) */
	PIPE2 | D1_FIFO_DMA,
	/* Pipe Configuration Register (0x66) */
	BULK | DBLBON | CNTMDON | DIR_P_IN | EP2,
	/* Pipe Buffer Configuration Register (0x68) */
	BUF_SIZE(512) | 24,
	/* Pipe Maxpacket Size Register (0x6A) */
	512,
	/* Pipe Cycle Configuration Register (0x6C) */
	USB_OFF | 0,
///////////////////////////////////////////////////////////////////////
	/* Pipe Window Select Register (0x64) */
	PIPE3 | C_FIFO_USE,
	/* Pipe Configuration Register (0x66) */
	BULK | DBLBON | CNTMDON | DIR_P_OUT | EP3,
	/* Pipe Buffer Configuration Register (0x68) */
	BUF_SIZE(512) | 40,
	/* Pipe Maxpacket Size Register (0x6A) */
	512,
	/* Pipe Cycle Configuration Register (0x6C) */
	USB_OFF | 0,
///////////////////////////////////////////////////////////////////////
	/* Pipe Window Select Register (0x64) */
	PIPE4 | C_FIFO_USE,
	/* Pipe Configuration Register (0x66) */
	BULK | DBLBON | CNTMDON | DIR_P_IN | EP4,
	/* Pipe Buffer Configuration Register (0x68) */
	BUF_SIZE(512) | 56,
	/* Pipe Maxpacket Size Register (0x6A) */
	512,
	/* Pipe Cycle Configuration Register (0x6C) */
	USB_OFF | 0,
///////////////////////////////////////////////////////////////////////
	/* Pipe Window Select Register (0x64) */
	PIPE5 | C_FIFO_USE,
	/* Pipe Configuration Register (0x66) */
	BULK | DBLBON | CNTMDON | DIR_P_OUT | EP5,
	/* Pipe Buffer Configuration Register (0x68) */
	BUF_SIZE(512) | 72,
	/* Pipe Maxpacket Size Register (0x6A) */
	512,
	/* Pipe Cycle Configuration Register (0x6C) */
	USB_OFF | 0,
///////////////////////////////////////////////////////////////////////
	/* Pipe Window Select Register (0x64) */
	PIPE6,
	/* Pipe Configuration Register (0x66) */
	INT | DIR_P_IN | EP6,
	/* Pipe Buffer Configuration Register (0x68) */
	BUF_SIZE(64) | 4,
	/* Pipe Maxpacket Size Register (0x6A) */
	64,
	/* Pipe Cycle Configuration Register (0x6C) */
	0,
///////////////////////////////////////////////////////////////////////
	/* Pipe Window Select Register (0x64) */
	PIPE7,
	/* Pipe Configuration Register (0x66) */
	INT | DIR_P_OUT | EP7,
	/* Pipe Buffer Configuration Register (0x68) */
	BUF_SIZE(64) | 5,
	/* Pipe Maxpacket Size Register (0x6A) */
	64,
	/* Pipe Cycle Configuration Register (0x6C) */
	0,
///////////////////////////////////////////////////////////////////////
	/* Pipe Window Select Register (0x64) */
	PIPE8,
	/* Pipe Configuration Register (0x66) */
	INT | DIR_P_IN | EP8,
	/* Pipe Buffer Configuration Register (0x68) */
	BUF_SIZE(64) | 6,
	/* Pipe Maxpacket Size Register (0x6A) */
	64,
	/* Pipe Cycle Configuration Register (0x6C) */
	0,
///////////////////////////////////////////////////////////////////////
	/* Pipe Window Select Register (0x64) */
	PIPE9,
	/* Pipe Configuration Register (0x66) */
	INT | DIR_P_OUT | EP9,
	/* Pipe Buffer Configuration Register (0x68) */
	BUF_SIZE(64) | 7,
	/* Pipe Maxpacket Size Register (0x6A) */
	64,
	/* Pipe Cycle Configuration Register (0x6C) */
	0,
};



const USB_U16  EPtbl_2[] = { 0 };				/* Configuration 2 */
const USB_U16  EPtbl_3[] = { 0 };				/* Configuration 3 */
const USB_U16  EPtbl_4[] = { 0 };				/* Configuration 4 */
const USB_U16  EPtbl_5[] = { 0 };				/* Configuration 5 */




const USB_U16 *EndPntPtr[] = {
	EPtbl_1,
	EPtbl_2,
	EPtbl_3,
	EPtbl_4,
	EPtbl_5
};




/************************
 *	Device Descriptor	*
 ************************/

/* Standard Device Descriptor */

USB_U8	DeviceDescriptor[18] = {
	18,												/*  0:bLength */
	DT_DEVICE,										/*  1:bDescriptorType */
	(USB_U8)( BcdUsb			& 0xff),			/*  2:bcdUSB_lo */
	(USB_U8)((BcdUsb >> 8)		& 0xff),			/*  3:bcdUSB_hi */
	0xff,											/*  4:bDeviceClass */
	0xff,											/*  5:bDeviceSubClass */
	0xff,											/*  6:bDeviceProtocol */
	64,												/*  7:bMaxPacketSize(for DCP) */
	(USB_U8)( VENDOR_ID			& 0xff),			/*  8:idVendor_lo */
	(USB_U8)((VENDOR_ID >> 8)	& 0xff),			/*  9:idVendor_hi */
	(USB_U8)( PRODUCT_ID		& 0xff),			/* 10:idProduct_lo */
	(USB_U8)((PRODUCT_ID >> 8)	& 0xff),			/* 11:idProduct_hi */
	(USB_U8)( ReleaseNo			& 0xff),			/* 12:bcdDevice_lo */
	(USB_U8)((ReleaseNo >> 8)	& 0xff),			/* 13:bcdDevice_hi */
	1,												/* 14:iManufacturer */
	2,												/* 15:iProduct */
	3,												/* 16:iSerialNumber */
	1												/* 17:bNumConfigurations */
};







/* Device Qualifier Descriptor */
USB_U8	QualifierDescriptor[10] = {
	10,												/*  0:bLength */
	DT_DEVICE_QUALIFIER,							/*  1:bDescriptorType */
	(USB_U8)( BcdUsb			& 0xff),			/*  2:bcdUSB_lo */
	(USB_U8)((BcdUsb >> 8)		& 0xff),			/*  3:bcdUSB_hi */
	0xff,											/*  4:bDeviceClass */
	0xff,											/*  5:bDeviceSubClass */
	0xff,											/*  6:bDeviceProtocol */
	64,												/*  7:bMaxPacketSize(for DCP) */
	1,												/*  8:bNumConfigurations */
	0												/*  9:bReserved */
};







/************************************************************
 *	Configuration Or Other_Speed_Configuration Descriptor	*
 ************************************************************/
/* For Full-Speed */
USB_U8	Configuration_Full_1[82] = {
	9,												/*  0:bLength */
	SOFTWARE_CHANGE,								/*  1:bDescriptorType */
	81,												/*  2:wTotalLength(L) */
	0,												/*  3:wTotalLength(H) */
	1,												/*  4:bNumInterfaces */
	1,												/*  5:bConfigurationValue */
	4,												/*  6:iConfiguration */
	(USB_U8)(CF_RESERVED | CF_SELF | RWUP_MODE),	/*  7:bmAttributes */
	(USB_U8)(100 / 2),								/*  8:bMaxPower (2mA unit) */

	/* Interface Descriptor */
		9,											/*  0:bLength */
		DT_INTERFACE,								/*  1:bDescriptor */
		0,											/*  2:bInterfaceNumber */
		0,											/*  3:bAlternateSetting */
		9,											/*  4:bNumEndpoints */
		0xff,										/*  5:bInterfaceClass */
		0xff,										/*  6:bInterfaceSubClass */
		0xff,										/*  7:bInterfaceProtocol */
		0,											/*  8:iInterface */

		/* Endpoint Descriptor 0 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_OUT | EP1),					/*  2:bEndpointAddress */
			EP_BULK,								/*  3:bmAttribute */
			64,										/*  4:wMaxPacketSize_lo */
			0,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 1 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_IN | EP2),					/*  2:bEndpointAddress */
			EP_BULK,								/*  3:bmAttribute */
			64,										/*  4:wMaxPacketSize_lo */
			0,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 2 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_OUT | EP3),					/*  2:bEndpointAddress */
			EP_BULK,								/*  3:bmAttribute */
			64,										/*  4:wMaxPacketSize_lo */
			0,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 3 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_IN | EP4),					/*  2:bEndpointAddress */
			EP_BULK,								/*  3:bmAttribute */
			64,										/*  4:wMaxPacketSize_lo */
			0,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 4 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_OUT | EP5),					/*  2:bEndpointAddress */
			EP_BULK,								/*  3:bmAttribute */
			64,										/*  4:wMaxPacketSize_lo */
			0,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 5 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_IN | EP6),					/*  2:bEndpointAddress */
			EP_INT,									/*  3:bmAttribute */
			64,										/*  4:wMaxPacketSize_lo */
			0,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 6 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_OUT | EP7),					/*  2:bEndpointAddress */
			EP_INT,									/*  3:bmAttribute */
			64,										/*  4:wMaxPacketSize_lo */
			0,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 7 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_IN | EP8),					/*  2:bEndpointAddress */
			EP_INT,									/*  3:bmAttribute */
			64,										/*  4:wMaxPacketSize_lo */
			0,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 8 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_OUT | EP9),					/*  2:bEndpointAddress */
			EP_INT,									/*  3:bmAttribute */
			64,										/*  4:wMaxPacketSize_lo */
			0,										/*  5:wMaxPacketSize_hi */
			1										/*  6:bInterval */
};






/* For Hi-Speed */
USB_U8	Configuration_Hi_1[82] = {
	9,												/*  0:bLength */
	SOFTWARE_CHANGE,								/*  1:bDescriptorType */
	81,												/*  2:wTotalLength(L) */
	0,												/*  3:wTotalLength(H) */
	1,												/*  4:bNumInterfaces */
	1,												/*  5:bConfigurationValue */
	5,												/*  6:iConfiguration */
	(USB_U8)(CF_RESERVED | CF_SELF | RWUP_MODE),	/*  7:bmAttributes */
	(USB_U8)(100 / 2),								/*  8:bMaxPower (2mA unit) */

	/* Interface Descriptor */
		9,											/*  0:bLength */
		DT_INTERFACE,								/*  1:bDescriptor */
		0,											/*  2:bInterfaceNumber */
		0,											/*  3:bAlternateSetting */
		9,											/*  4:bNumEndpoints */
		0xff,										/*  5:bInterfaceClass */
		0xff,										/*  6:bInterfaceSubClass */
		0xff,										/*  7:bInterfaceProtocol */
		0,											/*  8:iInterface */

		/* Endpoint Descriptor 0 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_OUT | EP1),					/*  2:bEndpointAddress */
			EP_BULK,								/*  3:bmAttribute */
			0,										/*  4:wMaxPacketSize_lo */
			2,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 1 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_IN | EP2),					/*  2:bEndpointAddress */
			EP_BULK,								/*  3:bmAttribute */
			0,										/*  4:wMaxPacketSize_lo */
			2,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 2 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_OUT | EP3),					/*  2:bEndpointAddress */
			EP_BULK,								/*  3:bmAttribute */
			0,										/*  4:wMaxPacketSize_lo */
			2,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 3 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_IN | EP4),					/*  2:bEndpointAddress */
			EP_BULK,								/*  3:bmAttribute */
			0,										/*  4:wMaxPacketSize_lo */
			2,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 4 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_OUT | EP5),					/*  2:bEndpointAddress */
			EP_BULK,								/*  3:bmAttribute */
			0,										/*  4:wMaxPacketSize_lo */
			2,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 5 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_IN | EP6),					/*  2:bEndpointAddress */
			EP_INT,									/*  3:bmAttribute */
			64,										/*  4:wMaxPacketSize_lo */
			0,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 6 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_OUT | EP7),					/*  2:bEndpointAddress */
			EP_INT,									/*  3:bmAttribute */
			64,										/*  4:wMaxPacketSize_lo */
			0,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 7 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_IN | EP8),					/*  2:bEndpointAddress */
			EP_INT,									/*  3:bmAttribute */
			64,										/*  4:wMaxPacketSize_lo */
			0,										/*  5:wMaxPacketSize_hi */
			1,										/*  6:bInterval */

		/* Endpoint Descriptor 8 */
			7,										/*  0:bLength */
			DT_ENDPOINT,							/*  1:bDescriptorType */
			(USB_U8)(EP_OUT | EP9),					/*  2:bEndpointAddress */
			EP_INT,									/*  3:bmAttribute */
			64,										/*  4:wMaxPacketSize_lo */
			0,										/*  5:wMaxPacketSize_hi */
			1										/*  6:bInterval */
};






/* Configuration */
USB_U8	Configuration_Full_2[2] = { 0, SOFTWARE_CHANGE };
USB_U8	Configuration_Full_3[2] = { 0, SOFTWARE_CHANGE };
USB_U8	Configuration_Full_4[2] = { 0, SOFTWARE_CHANGE };
USB_U8	Configuration_Full_5[2] = { 0, SOFTWARE_CHANGE };

/* Other_Speed_Configuration */
USB_U8	Configuration_Hi_2[2] = { 0, SOFTWARE_CHANGE };
USB_U8	Configuration_Hi_3[2] = { 0, SOFTWARE_CHANGE };
USB_U8	Configuration_Hi_4[2] = { 0, SOFTWARE_CHANGE };
USB_U8	Configuration_Hi_5[2] = { 0, SOFTWARE_CHANGE };

USB_U8 *ConPtr[] = {
	(USB_U8 *)SOFTWARE_CHANGE,
	(USB_U8 *)SOFTWARE_CHANGE,
	(USB_U8 *)SOFTWARE_CHANGE,
	(USB_U8 *)SOFTWARE_CHANGE,
	(USB_U8 *)SOFTWARE_CHANGE
};

USB_U8 *ConPtr_Other[] = {
	(USB_U8 *)SOFTWARE_CHANGE,
	(USB_U8 *)SOFTWARE_CHANGE,
	(USB_U8 *)SOFTWARE_CHANGE,
	(USB_U8 *)SOFTWARE_CHANGE,
	(USB_U8 *)SOFTWARE_CHANGE
};








/*************************************
 *	  String Descriptor				 *
 *************************************/
USB_U8	StringDescriptor0[4] = {			/* UNICODE 0x0409 English (United States) */
	4,												/*  0:bLength */
	DT_STRING,										/*  1:bDescriptorType */
	0x09, 0x04										/*  2:wLANGID[0] */
};


//Ж
USB_U8	StringDescriptor1[64*2] = {					/* iManufacturer */
	26*2+2,
	3,
	'J',0,
	'a',0,
	'p',0,
	'a',0,
	'n',0,
	' ',0,
	'M',0,
	'i',0,
	'c',0,
	'r',0,
	'o',0,
	' ',0,
	'S',0,
	'y',0,
	's',0,
	't',0,
	'e',0,
	'm',0,
	' ',0,
	'C',0,
	'o',0,
	'.',0,
	',',0,
	'L',0,
	't',0,
	'd',0,
};



//u
USB_U8	StringDescriptor2[64*2] = {					/* iProduct */
	8*2+2,
	3,
	'B',0,
	'A',0,
	'S',0,
	'E',0,
	'7',0,
	'6',0,
	'7',0,
	'0',0,
};



//VAԍ␻
USB_U8	StringDescriptor3[64*2] = {					/* iSerialNumber */
	9*2+2,
	3,
	'2',0,
	'0',0,
	'1',0,
	'1',0,
	'-',0,
	'2',0,
	'-',0,
	'1',0,
	'6',0,
};


//o[Wԍ
USB_U8	StringDescriptor4[64*2] = {					/* iConfiguration */
	7*2+2,
	3,
	'V',0,
	'e',0,
	'r',0,
	' ',0,
	'1',0,
	'.',0,
	'0',0,
};



//⏕Iȕ\
USB_U8	StringDescriptor5[64*2] = {					/* iConfiguration */
	7*2+2,
	3,
	'b',0,
	'y',0,
	' ',0,
	'R',0,
	'a',0,
	'b',0,
	'o',0
};




USB_U8 *StrPtr[] = {
	StringDescriptor0,
	StringDescriptor1,
	StringDescriptor2,
	StringDescriptor3,
	StringDescriptor4,
	StringDescriptor5
};










PIPE_INFO_ pipe[]={
{0,0},
{512,P1_Buff},		//PIPE1_OUT
{512,P2_Buff},		//PIPE2_IN
{512,P3_Buff},		//PIPE3_OUT
{512,P4_Buff},		//PIPE4_IN
{512,P5_Buff},		//PIPE5_OUT
{512,P6_Buff},		//PIPE6_IN
{512,P7_Buff},		//PIPE7_OUT
{512,P8_Buff},		//PIPE8_IN
{512,P9_Buff}		//PIPE9_OUT
};








///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////














/////////////////////////////////////////////////////////////////////////////
//w͈͓̃LbV̕ύXꂽf[^ASăɏ߂܂B


int io_cwb(
	unsigned long start,	//JnAhX
	unsigned long end			//IAhX
){ 

	return 0;
}






//////////////////////////////////////////////////////////////////////
//Delay 1msec

void usb_delay_1ms(void)
{
	volatile int i;
	volatile unsigned long tmp;

	/*
	 * Wait 1ms (Please change for your MCU).
	 */
	for( i = 0; i < 20000; ++i ){
		tmp = DUMMY_ACCESS;
	}
}











//////////////////////////////////////////////////////////////////////
//Delay msec
//Argument   : USB_U32 msec ; Wait Time (msec)

void usb_delay_xms(USB_U32 msec)
{
	volatile unsigned short i;

	for( i = 0; i < msec; ++i ) {
		usb_delay_1ms();
	}
}







//////////////////////////////////////////////////////////////////////
//Delay 10micro-second
//Argument   : USB_U32 usec ; Wait Time(x 10usec)

void usb_delay_10us(USB_U32 usec)
{
	volatile int i;
	volatile unsigned long tmp;

	/*
	 * Wait 10us (Please change for your MCU)
	 */

	for( i = 0; i < 200 * usec ; ++i ){
		tmp = DUMMY_ACCESS;
	}
}

























//////////////////////////////////////////////////////////////////////
// Enable Buffer Ready Interrupt
//Argument   : USB_U16 pipe           ; pipe Number

void usb_enable_brdy_int(USB_U16 pipe)
{
	USB_U16 tmp;
	USB_U16 buf;

	tmp = USB0.INTENB0.WORD;						/* Value Save */
	USB0.INTENB0.WORD = (USB_U16)(tmp	& (USB_U16)~(BITBEMPE| BITNRDYE|BITBRDYE));
	buf = USB0.BRDYENB.WORD;
	buf |= BitSet[pipe];
	USB0.BRDYENB.WORD = buf;
	USB0.INTENB0.WORD = tmp;						/* Interrupt Enable */
}










//////////////////////////////////////////////////////////////////////
//Disable Buffer Ready Interrupt
//Argument   : USB_U16 pipe        ; pipe Number

void usb_disable_brdy_int(USB_U16 pipe)
{
	USB_U16  tmp;
	USB_U16	buf;

	tmp = USB0.INTENB0.WORD;						/* Value Save */
	USB0.INTENB0.WORD = (USB_U16)(tmp	& (USB_U16)~(BITBEMPE| BITNRDYE|BITBRDYE));
	buf = USB0.BRDYENB.WORD;
	buf &= (USB_U16)~(BitSet[pipe]);
	USB0.BRDYENB.WORD = buf;
	USB0.INTENB0.WORD = tmp;						/* Interrupt Enable */
}









//////////////////////////////////////////////////////////////////////
// Enable Buffer Empty Interrupt
//Argument   : USB_U16 pipe           ; pipe Number

void usb_enable_bemp_int(USB_U16 pipe)
{
	USB_U16 tmp;
	USB_U16 buf;

	tmp = USB0.INTENB0.WORD;						/* Value Save */
	USB0.INTENB0.WORD = (USB_U16)(tmp	& (USB_U16)~(BITBEMPE| BITNRDYE|BITBRDYE));
	buf = USB0.BEMPENB.WORD;
	buf |= BitSet[pipe];
	USB0.BEMPENB.WORD = buf;
	USB0.INTENB0.WORD = tmp;						/* Interrupt Enable */
}






//////////////////////////////////////////////////////////////////////
//Disable Buffer Empty Interrupt
//Argument   : USB_U16 pipe           ; pipe Number

void usb_disable_bemp_int(USB_U16 pipe)
{
	USB_U16  tmp;
	USB_U16 buf;

	tmp = USB0.INTENB0.WORD;						/* Value Save */
	USB0.INTENB0.WORD = (USB_U16)(tmp	& (USB_U16)~(BITBEMPE| BITNRDYE|BITBRDYE));
	buf = USB0.BEMPENB.WORD;
	buf &= (USB_U16)~(BitSet[pipe]);
	USB0.BEMPENB.WORD = buf;
	USB0.INTENB0.WORD = tmp;						/* Interrupt Enable */
}






//////////////////////////////////////////////////////////////////////
//Enable Buffer Not Ready Interrupt
//Argument   : USB_U16 pipe             ; pipe Number

void usb_enable_nrdy_int(USB_U16 pipe)
{
	USB_U16  tmp;
	USB_U16	buf;

	tmp = USB0.INTENB0.WORD;						/* Value Save */
	USB0.INTENB0.WORD = (USB_U16)(tmp	& (USB_U16)~(BITBEMPE| BITNRDYE|BITBRDYE));
	buf = USB0.NRDYENB.WORD;
	buf |= BitSet[pipe];
	USB0.NRDYENB.WORD = buf;
	USB0.INTENB0.WORD = tmp;						/* Interrupt Enable */
}






//////////////////////////////////////////////////////////////////////
//Disable Buffer Not Ready Interrupt
//Argument   : USB_U16 pipe            ; pipe Number

void usb_disable_nrdy_int(USB_U16 pipe)
{
	USB_U16 tmp;
	USB_U16 buf;

	tmp = USB0.INTENB0.WORD;						/* Value Save */
	USB0.INTENB0.WORD = (USB_U16)(tmp	& (USB_U16)~(BITBEMPE| BITNRDYE|BITBRDYE));
	buf = USB0.NRDYENB.WORD;
	buf &= (USB_U16)~(BitSet[pipe]);
	USB0.NRDYENB.WORD = buf;
	USB0.INTENB0.WORD = tmp;						/* Interrupt Enable */
}






///////////////////////////////////////////////////////////////////////
//Check Current Speed
///////////////////////////////////////////////////////////////////////
//ReturnValue: HI_SPEED    : Hi-Speed
//           : FULL_SPEED  : Full-Speed
//           : LOW_SPEED   : Low-Speed
//           : NON_SPEED   : error

USB_U16 usb_is_hispeed(void)
{
	USB_U16 rhst,speed;

	rhst=USB0.DVSTCTR0.BIT.RHST;
	if(rhst==HSMODE){
		speed=HI_SPEED; //Hi-Speed mode
	}

	else
	if(rhst==FSMODE){
		speed=FULL_SPEED; //Full-Speed mode
	}

	else
	if(rhst==LSMODE){
		speed=LOW_SPEED; //Low-Speed mode

	}else{
		speed=NON_SPEED; //error
	}

	return speed;
}
///////////////////////////////////////////////////////////////////////
//Check Current Speed
///////////////////////////////////////////////////////////////////////









//////////////////////////////////////////////////////////////////////
//USBڑXs[hmF(DVSTCTRWX^RHSTrbg̒l߂lƂĕԂ܂)
//ReturnValue: DVSTCTRWX^RHSTrbg̒l(DVSTCTR).
//
//:DVSTCTRWX^ɂẮA
//SH7670O[vn[hEFA}jÃpCvRg[WX^QƂB

USB_U16 usb_get_bus_speed(void)
{
//	return (USB_U16)USB0.DVSTCTR.BIT.RHST;
return 0;

}





///////////////////////////////////////////////////////////////////////
//Check Hi-Speed enable bit
///////////////////////////////////////////////////////////////////////
//ReturnValue: USB_YES : Hi-Speed Enable
//           : USB_NO  : Hi-Speed Disable

USB_U16 usb_is_hispeed_enable(void)
{
	return USB_NO;
}
///////////////////////////////////////////////////////////////////////
//Check Hi-Speed enable bit
///////////////////////////////////////////////////////////////////////











//////////////////////////////////////////////////////////////////////
//Set pipe PID_BUF
//Argument   : USB_U16 pipe             ; pipe Number

void usb_set_pid_buf(USB_U16 pipe)
{
	USB_U16		pid;

	pid = usb_get_pid( pipe );
	if( pid == PID_STALL2 ){
		/* When it makes the BUF state from the PIDSTALL(11) state, */
		/* write 01 after writing 00 once.	*/
		usb_set_pid_nak( pipe );
	}

	switch( pipe ) {
	case PIPE0:
		USB0.DCPCTR.BIT.PID = PID_BUF;
		break;
	case PIPE1:
		USB0.PIPE1CTR.BIT.PID = PID_BUF;
		break;
	case PIPE2:
		USB0.PIPE2CTR.BIT.PID = PID_BUF;
		break;
	case PIPE3:
		USB0.PIPE3CTR.BIT.PID = PID_BUF;
		break;
	case PIPE4:
		USB0.PIPE4CTR.BIT.PID = PID_BUF;
		break;
	case PIPE5:
		USB0.PIPE5CTR.BIT.PID = PID_BUF;
		break;
	case PIPE6:
		USB0.PIPE6CTR.BIT.PID = PID_BUF;
		break;
	case PIPE7:
		USB0.PIPE7CTR.BIT.PID = PID_BUF;
		break;
	case PIPE8:
		USB0.PIPE8CTR.BIT.PID = PID_BUF;
		break;
	case PIPE9:
		USB0.PIPE9CTR.BIT.PID = PID_BUF;
		break;
	default:
		break;
	}
}








//////////////////////////////////////////////////////////////////////
//Set pipe PID_NAK
//Argument   : USB_U16 pipe            ; pipe Number

void usb_set_pid_nak(USB_U16 pipe)
{
	USB_U16		pid, pbusy;

	pid = usb_get_pid( pipe );
	if( pid == PID_STALL2 ){
		/* When it makes the NAK state from the PIDSTALL(11) state, */
		/* write 00 after writing 10 once.	*/
		usb_set_pid_stall( pipe );
	}

	switch( pipe ) {
	case PIPE0:
		USB0.DCPCTR.BIT.PID = PID_NAK;
		break;
	case PIPE1:
		USB0.PIPE1CTR.BIT.PID = PID_NAK;
		break;
	case PIPE2:
		USB0.PIPE2CTR.BIT.PID = PID_NAK;
		break;
	case PIPE3:
		USB0.PIPE3CTR.BIT.PID = PID_NAK;
		break;
	case PIPE4:
		USB0.PIPE4CTR.BIT.PID = PID_NAK;
		break;
	case PIPE5:
		USB0.PIPE5CTR.BIT.PID = PID_NAK;
		break;
	case PIPE6:
		USB0.PIPE6CTR.BIT.PID = PID_NAK;
		break;
	case PIPE7:
		USB0.PIPE7CTR.BIT.PID = PID_NAK;
		break;
	case PIPE8:
		USB0.PIPE8CTR.BIT.PID = PID_NAK;
		break;
	case PIPE9:
		USB0.PIPE9CTR.BIT.PID = PID_NAK;
		break;
	default:
		break;
	}

	if( pid == PID_BUF ){
		do {
			switch( pipe ) {
			case PIPE0:
				pbusy = USB0.DCPCTR.BIT.PBUSY;
				break;
			case PIPE1:
				pbusy = USB0.PIPE1CTR.BIT.PBUSY;
				break;
			case PIPE2:
				pbusy = USB0.PIPE2CTR.BIT.PBUSY;
				break;
			case PIPE3:
				pbusy = USB0.PIPE3CTR.BIT.PBUSY;
				break;
			case PIPE4:
				pbusy = USB0.PIPE4CTR.BIT.PBUSY;
				break;
			case PIPE5:
				pbusy = USB0.PIPE5CTR.BIT.PBUSY;
				break;
			case PIPE6:
				pbusy = USB0.PIPE6CTR.BIT.PBUSY;
				break;
			case PIPE7:
				pbusy = USB0.PIPE7CTR.BIT.PBUSY;
				break;
			case PIPE8:
				pbusy = USB0.PIPE8CTR.BIT.PBUSY;
				break;
			case PIPE9:
				pbusy = USB0.PIPE9CTR.BIT.PBUSY;
				break;
			default:
				pbusy	= 1;
				break;
			}
		} while( pbusy == 1 );
	}
}








//////////////////////////////////////////////////////////////////////
//Set pipe PID_TALL
//Argument   : USB_U16 pipe            ; pipe Number

void usb_set_pid_stall(USB_U16 pipe)
{
	USB_U16		pid;

	pid = usb_get_pid( pipe );
	if( pid == PID_BUF ){
		/* When it makes the STALL state from the PIDSTALL(01) state, */
		/* write 11.	*/

		switch( pipe ) {
		case PIPE0:
			USB0.DCPCTR.BIT.PID = PID_STALL2;
			break;
		case PIPE1:
			USB0.PIPE1CTR.BIT.PID = PID_STALL2;
			break;
		case PIPE2:
			USB0.PIPE2CTR.BIT.PID = PID_STALL2;
			break;
		case PIPE3:
			USB0.PIPE3CTR.BIT.PID = PID_STALL2;
			break;
		case PIPE4:
			USB0.PIPE4CTR.BIT.PID = PID_STALL2;
			break;
		case PIPE5:
			USB0.PIPE5CTR.BIT.PID = PID_STALL2;
			break;
		case PIPE6:
			USB0.PIPE6CTR.BIT.PID = PID_STALL2;
			break;
		case PIPE7:
			USB0.PIPE7CTR.BIT.PID = PID_STALL2;
			break;
		case PIPE8:
			USB0.PIPE8CTR.BIT.PID = PID_STALL2;
			break;
		case PIPE9:
			USB0.PIPE9CTR.BIT.PID = PID_STALL2;
			break;
		default:
			break;
		}
	}
	else{
		switch( pipe ) {
		case PIPE0:
			USB0.DCPCTR.BIT.PID = PID_STALL;
			break;
		case PIPE1:
			USB0.PIPE1CTR.BIT.PID = PID_STALL;
			break;
		case PIPE2:
			USB0.PIPE2CTR.BIT.PID = PID_STALL;
			break;
		case PIPE3:
			USB0.PIPE3CTR.BIT.PID = PID_STALL;
			break;
		case PIPE4:
			USB0.PIPE4CTR.BIT.PID = PID_STALL;
			break;
		case PIPE5:
			USB0.PIPE5CTR.BIT.PID = PID_STALL;
			break;
		case PIPE6:
			USB0.PIPE6CTR.BIT.PID = PID_STALL;
			break;
		case PIPE7:
			USB0.PIPE7CTR.BIT.PID = PID_STALL;
			break;
		case PIPE8:
			USB0.PIPE8CTR.BIT.PID = PID_STALL;
			break;
		case PIPE9:
			USB0.PIPE9CTR.BIT.PID = PID_STALL;
			break;
		default:
			break;
		}
	}
}








//////////////////////////////////////////////////////////////////////
//Clear pipe PID_STALL
//Argument   : USB_U16 pipe            ; pipe Number

void usb_clear_pid_stall(USB_U16 pipe)
{
	usb_set_pid_nak( pipe );
}







//////////////////////////////////////////////////////////////////////
//pCv̏ԂmF
//Argument   	:USB_U16 pipe pCvԍ
//ReturnValue	:PID
//PID_STALL		:STALL
//PID_BUF			:BUF
//PID_NAK			:NAK
//:STALLԁABUFԁANAKԂɂẮASH7670O[vn[hEFA}jÃpCvRg[WX^QƂB

USB_U16 usb_get_pid(USB_U16 pipe)
{
	USB_U16 pid;

	switch( pipe ) {
	case PIPE0:
		pid = USB0.DCPCTR.BIT.PID;
		break;
	case PIPE1:
		pid = USB0.PIPE1CTR.BIT.PID;
		break;
	case PIPE2:
		pid = USB0.PIPE2CTR.BIT.PID;
		break;
	case PIPE3:
		pid = USB0.PIPE3CTR.BIT.PID;
		break;
	case PIPE4:
		pid = USB0.PIPE4CTR.BIT.PID;
		break;
	case PIPE5:
		pid = USB0.PIPE5CTR.BIT.PID;
		break;
	case PIPE6:
		pid = USB0.PIPE6CTR.BIT.PID;
		break;
	case PIPE7:
		pid = USB0.PIPE7CTR.BIT.PID;
		break;
	case PIPE8:
		pid = USB0.PIPE8CTR.BIT.PID;
		break;
	case PIPE9:
		pid = USB0.PIPE9CTR.BIT.PID;
		break;
	default:
		pid = 0;
		break;
	}
	
	return pid;
}









//////////////////////////////////////////////////////////////////////
//CSPLIT status clear setting of sprit transaction 
//Argument    : USB_U16 pipe     ; Pipe number 
//
//When SQSET bit or SQCLR bit, and SQSET bit or SQCLR bit 
//in DCPCTR register are continuously changed (when the sequence
//toggle bit of data PID is continuously changed over two or more pipes), 
//the access cycle with 120 ns and more than 5 cycle bus clock is necessary.
// Do not set both SQCLR bit and SQSET bit to 1 at the same time. 
//In addition, both bits should be operated after PID is set to NAK. 
//However, when it is set to the isochronous transfer as the transfer type
//(TYPE=11), writing in SQSET bit is disabled.

void	usb_set_csclr( USB_U16 pipe )
{
	switch( pipe ) {
	case PIPE0:
//		USB0.DCPCTR.BIT.CSCLR = 1;
		break;
	case PIPE1:
//		USB0.PIPE1CTR.BIT.CSCLR = 1;
		break;
	case PIPE2:
//		USB0.PIPE2CTR.BIT.CSCLR = 1;
		break;
	case PIPE3:
//		USB0.PIPE3CTR.BIT.CSCLR = 1;
		break;
	case PIPE4:
//		USB0.PIPE4CTR.BIT.CSCLR = 1;
		break;
	case PIPE5:
//		USB0.PIPE5CTR.BIT.CSCLR = 1;
		break;
	case PIPE6:
//		USB0.PIPE6CTR.BIT.CSCLR = 1;
		break;
	case PIPE7:
//		USB0.PIPE7CTR.BIT.CSCLR = 1;
		break;
	case PIPE8:
//		USB0.PIPE8CTR.BIT.CSCLR = 1;
		break;
	case PIPE9:
//		USB0.PIPE9CTR.BIT.CSCLR = 1;
		break;
	default:
		break;
	}
}










//////////////////////////////////////////////////////////////////////
//Do SQCLR
//Argument   : USB_U16 pipe              ; Pipe Number

void usb_set_sqclr(USB_U16 pipe)
{
	switch( pipe ) {
	case PIPE0:
		USB0.DCPCTR.BIT.SQCLR = 1;
		break;
	case PIPE1:
		USB0.PIPE1CTR.BIT.SQCLR = 1;
		break;
	case PIPE2:
		USB0.PIPE2CTR.BIT.SQCLR = 1;
		break;
	case PIPE3:
		USB0.PIPE3CTR.BIT.SQCLR = 1;
		break;
	case PIPE4:
		USB0.PIPE4CTR.BIT.SQCLR = 1;
		break;
	case PIPE5:
		USB0.PIPE5CTR.BIT.SQCLR = 1;
		break;
	case PIPE6:
		USB0.PIPE6CTR.BIT.SQCLR = 1;
		break;
	case PIPE7:
		USB0.PIPE7CTR.BIT.SQCLR = 1;
		break;
	case PIPE8:
		USB0.PIPE8CTR.BIT.SQCLR = 1;
		break;
	case PIPE9:
		USB0.PIPE9CTR.BIT.SQCLR = 1;
		break;
	default:
		break;
	}
}












//////////////////////////////////////////////////////////////////////
//Pipe toggle bit set setting 
//Argument    : USB_U16 pipe   ; Pipe number 

void usb_set_sqset( USB_U16 pipe )
{
	switch( pipe ) {
	case PIPE0:
		USB0.DCPCTR.BIT.SQSET = 1;
		break;
	case PIPE1:
		USB0.PIPE1CTR.BIT.SQSET = 1;
		break;
	case PIPE2:
		USB0.PIPE2CTR.BIT.SQSET = 1;
		break;
	case PIPE3:
		USB0.PIPE3CTR.BIT.SQSET = 1;
		break;
	case PIPE4:
		USB0.PIPE4CTR.BIT.SQSET = 1;
		break;
	case PIPE5:
		USB0.PIPE5CTR.BIT.SQSET = 1;
		break;
	case PIPE6:
		USB0.PIPE6CTR.BIT.SQSET = 1;
		break;
	case PIPE7:
		USB0.PIPE7CTR.BIT.SQSET = 1;
		break;
	case PIPE8:
		USB0.PIPE8CTR.BIT.SQSET = 1;
		break;
	case PIPE9:
		USB0.PIPE9CTR.BIT.SQSET = 1;
		break;
	default:
		break;
	}
}











//////////////////////////////////////////////////////////////////////
//Obtaining pipe toggle bit 
//Argument    : USB_U16 pipe   ; Pipe number 

USB_U16 usb_get_sqmon( USB_U16 pipe )
{
	USB_U16 sqmon;
	
	switch( pipe ) {
	case PIPE0:
		sqmon = USB0.DCPCTR.BIT.SQMON;
		break;
	case PIPE1:
		sqmon = USB0.PIPE1CTR.BIT.SQMON;
		break;
	case PIPE2:
		sqmon = USB0.PIPE2CTR.BIT.SQMON;
		break;
	case PIPE3:
		sqmon = USB0.PIPE3CTR.BIT.SQMON;
		break;
	case PIPE4:
		sqmon = USB0.PIPE4CTR.BIT.SQMON;
		break;
	case PIPE5:
		sqmon = USB0.PIPE5CTR.BIT.SQMON;
		break;
	case PIPE6:
		sqmon = USB0.PIPE6CTR.BIT.SQMON;
		break;
	case PIPE7:
		sqmon = USB0.PIPE7CTR.BIT.SQMON;
		break;
	case PIPE8:
		sqmon = USB0.PIPE8CTR.BIT.SQMON;
		break;
	case PIPE9:
		sqmon = USB0.PIPE9CTR.BIT.SQMON;
		break;
	default:
		sqmon = 0;
		break;
	}
	return sqmon;
}










//////////////////////////////////////////////////////////////////////
//FIFO buffer initialization 
//Argument    : USB_U16 pipe    : Pipe

void	usb_aclrm( USB_U16 pipe )
{
	usb_set_aclrm( pipe );
	usb_clr_aclrm( pipe );
}











//////////////////////////////////////////////////////////////////////
//Enabling auto buffer clear mode 
//Argument    : USB_U16 pipe    : Pipe

void	usb_set_aclrm( USB_U16 pipe )
{
	switch( pipe ) {
		case PIPE0: 
			break;
		case PIPE1: 
			USB0.PIPE1CTR.BIT.ACLRM = 1;	
			break;
		case PIPE2: 
			USB0.PIPE2CTR.BIT.ACLRM = 1;	
			break;
		case PIPE3: 
			USB0.PIPE3CTR.BIT.ACLRM = 1;	
			break;
		case PIPE4: 
			USB0.PIPE4CTR.BIT.ACLRM = 1;	
			break;
		case PIPE5: 
			USB0.PIPE5CTR.BIT.ACLRM = 1;	
			break;
		case PIPE6: 
			USB0.PIPE6CTR.BIT.ACLRM = 1;	
			break;
		case PIPE7: 
			USB0.PIPE7CTR.BIT.ACLRM = 1;	
			break;
		case PIPE8: 
			USB0.PIPE8CTR.BIT.ACLRM = 1;	
			break;
		case PIPE9: 
			USB0.PIPE9CTR.BIT.ACLRM = 1;	
			break;
		default:
			break;
	}
}










//////////////////////////////////////////////////////////////////////
//Auto buffer clear mode is disabled 
//Argument    : USB_U16 pipe    : Pipe

void	usb_clr_aclrm( USB_U16 pipe )
{
	switch( pipe ) {
		case PIPE0: 
			break;
		case PIPE1: 
			USB0.PIPE1CTR.BIT.ACLRM = 0;	
			break;
		case PIPE2: 
			USB0.PIPE2CTR.BIT.ACLRM = 0;	
			break;
		case PIPE3: 
			USB0.PIPE3CTR.BIT.ACLRM = 0;	
			break;
		case PIPE4: 
			USB0.PIPE4CTR.BIT.ACLRM = 0;	
			break;
		case PIPE5: 
			USB0.PIPE5CTR.BIT.ACLRM = 0;	
			break;
		case PIPE6: 
			USB0.PIPE6CTR.BIT.ACLRM = 0;	
			break;
		case PIPE7: 
			USB0.PIPE7CTR.BIT.ACLRM = 0;	
			break;
		case PIPE8: 
			USB0.PIPE8CTR.BIT.ACLRM = 0;	
			break;
		case PIPE9: 
			USB0.PIPE9CTR.BIT.ACLRM = 0;	
			break;
		default:
			break;
	}
}













//////////////////////////////////////////////////////////////////////
//Do SQCLR
//Argument   : USB_U16 pipe             ; Pipe Number

USB_U16 usb_get_inbuf( USB_U16 pipe )
{
	USB_U16	inbuf;

	switch( pipe ) {
	case PIPE0:
		inbuf = 0;
		break;
	case PIPE1:
		inbuf = USB0.PIPE1CTR.BIT.INBUFM;
		break;
	case PIPE2:
		inbuf = USB0.PIPE2CTR.BIT.INBUFM;
		break;
	case PIPE3:
		inbuf = USB0.PIPE3CTR.BIT.INBUFM;
		break;
	case PIPE4:
		inbuf = USB0.PIPE4CTR.BIT.INBUFM;
		break;
	case PIPE5:
		inbuf = USB0.PIPE5CTR.BIT.INBUFM;
		break;
	case PIPE6:
		inbuf = 0;
		break;
	case PIPE7:
		inbuf = 0;
		break;
	case PIPE8:
		inbuf = 0;
		break;
	case PIPE9:
		inbuf = 0;
		break;
	default:
		inbuf = 0;
		break;
	}
	return inbuf;
}
































//////////////////////////////////////////////////////////////////////
//Initialize Memory

void usb_init_mem(void)
{
	USB_U16	i;

	ConfigNum = 0;					/* configuration Number */

	for( i = 0; i < (MAX_PIPE_NO + 1); ++i ) {
		PipeFlag[i]     = PIPE_IDLE;
		PipeDataSize[i] = 0;
	}
}













//////////////////////////////////////////////////////////////////////
//BRDY interrupt
//Argument   : USB_U16 Status       ; BRDYSTS Register Value
//           : USB_U16 Int_enbl     ; BRDYENB Register Value
//USBzXgf[^MBRDY荞݂܂B
//USB荞ݏBRDY荞ݏɂāAFIFOobt@̃f[^ǂݏosA
//f[^M܂B

void usb_brdy_int(USB_U16 status, USB_U16 int_enb)
{
	USB_U16 pipe,pipebit;

	for( pipe = PIPE1; pipe <= PIPE9; pipe++ ) {
			pipebit = BitSet[pipe];

		if( (status & pipebit) && (int_enb & pipebit) ) {
			USB0.BRDYSTS.WORD = (USB_U16)~pipebit;	/* BRDY Status Clear */
			USB0.BEMPSTS.WORD = (USB_U16)~pipebit;	/* BEMP Status Clear */
			USB0.PIPESEL.BIT.PIPESEL =  pipe;

			if((PipeTbl[pipe] & FIFO_USE) == D0_FIFO_DMA ){
				if(USBDmaStatus[USB_D0FIFO] == USB_DMA_BUSY){
					usb_dma_interrupt0();
				}
				usb_read_dma(pipe);
			}

			else if((PipeTbl[pipe] & FIFO_USE) == D1_FIFO_DMA ){
				if(USBDmaStatus[USB_D1FIFO] == USB_DMA_BUSY){
					usb_dma_interrupt1();
				}
				usb_read_dma(pipe);
			}

			else{
				if( USB0.PIPECFG.BIT.DIR  == 0 ) {
					usb_read_buffer(pipe);
				} 
				else {
					usb_write_buffer(pipe);
				}
			}
		}
	}
}







//////////////////////////////////////////////////////////////////////
//NRDY interrupt
//Argument   : USB_U16 status       ; NRDYSTS Register Value
//           : USB_U16 int_enb      ; NRDYENB Register Value

void usb_nrdy_int(USB_U16 status, USB_U16 int_enb)
{
	USB_U16 pid, pipe,bitcheck;

	bitcheck	= (USB_U16)(status & int_enb);

	USB0.NRDYSTS.WORD = (USB_U16)~status;
	for( pipe = PIPE1; pipe <= PIPE9; pipe++ ) {
		if( (bitcheck&BitSet[pipe])==BitSet[pipe] ) {	/* interrupt check */
			if(USB0.SYSCFG.BIT.DCFM == 1){
				/* USB Host */
				if(PipeFlag[pipe] == PIPE_WAIT){
					pid = usb_get_pid(pipe);
					if( ( pid == PID_STALL ) || ( pid == PID_STALL2 ) ){	/* STALL ? */
						PipeFlag[pipe] = PIPE_STALL;
					}
					else{
						PipeIgnore[pipe]++;				/* Ignore count */
						if(PipeIgnore[pipe] == PIPEERR){
							PipeFlag[pipe] = PIPE_NORES;
						}
						else{
							usb_set_pid_buf(pipe);		/* PIPE0 Send IN or OUT token */
						}
					}
				}
			}
			else{
				/* USB Function */
			}
		}
	}

}











//////////////////////////////////////////////////////////////////////
//BEMP interrupt
//Argument   : USB_U16 status       ; BEMPSTS Register Value
//           : USB_U16 int_enb      ; BEMPENB Register Value

void usb_bemp_int(USB_U16 status, USB_U16 int_enb)
{

	USB_U16 pid, pipe,bitcheck,inbuf;

	bitcheck	= (USB_U16)(status & int_enb);

	USB0.BEMPSTS.WORD = (USB_U16)~status;
	for( pipe = PIPE1; pipe <= PIPE9; pipe++ ) {
		if( (bitcheck&BitSet[pipe])==BitSet[pipe] ) {	/* interrupt check */
			pid = usb_get_pid(pipe);
			if( ( pid == PID_STALL ) || ( pid == PID_STALL2 ) ){	/* STALL ? */
				PipeFlag[pipe] = PIPE_STALL;
			}
			else{
				inbuf = usb_get_inbuf( pipe );
				if( inbuf == 0 ) {
					usb_disable_bemp_int( pipe );		/* Disable BEMP Interrupt */
					usb_set_pid_nak(pipe);
					PipeFlag[ pipe ] = PIPE_DONE;		/* End */
				}
			}
		}
	}
}























//////////////////////////////////////////////////////////////////////
//Get Buf size
//Argument   : USB_U16 ; pipe Number
//ReturnValue: Data Buffer Size

USB_U16 usb_get_buf_size(USB_U16 pipe)
{
	USB_U16 size, bufsize;

	if( pipe == PIPE0 ) {
		size = USB0.DCPMAXP.BIT.MXPS;				/* Max Packet Size */
	} 
	else {
		USB0.PIPESEL.BIT.PIPESEL = pipe;				/* pipe select */
		if(/* USB0.PIPECFG.BIT.CNTMD */USB0.PIPESEL.BIT.PIPESEL== 1 ) {			/* read CNTMD */
//			bufsize = USB0.PIPEBUF.BIT.BUFSIZE;
			size = (USB_U16)((bufsize + 1) * PIPExBUF);	/* Buffer Size */
		} 
		else {
			size = USB0.PIPEMAXP.BIT.MXPS;			/* Max Packet Size */
		}
	}
	return size;
}













//////////////////////////////////////////////////////////////////////
//Get max packet size
//Argument   : USB_U16 ; Pipe Number
//ReturnValue: Max Packet Size

USB_U16 usb_get_mxps(USB_U16 pipe)
{
	USB_U16 size;

	if( pipe == PIPE0 ) {
		size = USB0.DCPMAXP.BIT.MXPS;				/* Max Packet Size */
	} 
	else {
		USB0.PIPESEL.BIT.PIPESEL = pipe;			/* pipe select */
		size = USB0.PIPEMAXP.BIT.MXPS;			/* Max Packet Size */
	}
	return size;
}













//////////////////////////////////////////////////////////////////////
//Ŏw肵pCvɂf[^MJn(send data to host).
//Argument   : USB_U16  pipe    ; pCvԍ
//           : USB_U32 size     ; f[^TCY
//           : USB_U8  *data    ; f[^i[AhX

//ReturnValue: READEND          :? Read end
//           : READSHRT         :? short data
//           : READING          :? Continue of data read
//           : READOVER         :? buffer over
//           : FIFOERROR        : FIFO error

//WRITEEND	:FIFOobt@ւ̃f[^݊
//WRITESHRT	:V[gpPbgFIFOobt@ւ̃f[^݊
//WRITING		:FIFOobt@ւ̃f[^݌p
//FIFOERROR	:FIFOANZXG[
//
//USBzXgɑMf[^FIFOobt@ɏ݂܂B
//FIFOobt@ւ̃f[^݌Aw肳ꂽpCvf[^MԂɂ܂B
//USBzXgւ̃f[^MBEMP荞݂܂B
//USB荞ݏBEMP荞ݏɂāAf[^M܂B
//{֐̖߂lhFIFOobt@ւ̃f[^݌ph̏ꍇ́A
//USB荞ݏBEMP荞ݏɂāAFIFOobt@ւ̃f[^݂p܂B

USB_U16 usb_start_send_transfer(USB_U16 pipe, USB_U32 size, USB_U8 *data)
{
	USB_U16 status;

	USBDataCount[pipe]   = size;
	USBDataPointer[pipe] = (USB_U8 *)data;
	PipeFlag[pipe]       = PIPE_WAIT;

	USB0.BEMPSTS.WORD = (USB_U16)~(BitSet[pipe]);
	USB0.BRDYSTS.WORD = (USB_U16)~(BitSet[pipe]);

	usb_clear_transaction_counter( pipe );

	status = usb_write_buffer(pipe);
	if(status !=FIFOERROR){
		usb_set_pid_buf(pipe);						/* Set BUF */
	}

	return status;									/* End or Err or Continue */
}











//////////////////////////////////////////////////////////////////////
//Buffer Write
//Argument   : USB_U16 pipe     ; Pipe Number
//ReturnValue: WRITEEND          : Write end
//           : WRITESHRT         : short data
//           : WRITING           : Continue of data write
//           : WRITEDMA          : Write DMA
//           : FIFOERROR         : FIFO status

USB_U16 usb_write_buffer(USB_U16 pipe)
{
	USB_U16	status;
	USB_U16 usefifo;

	PipeIgnore[pipe]	= 0;			/* Ignore count clear */
	usefifo = (USB_U16)(PipeTbl[pipe] & FIFO_USE);
	switch(usefifo){
		case	D0_FIFO_USE:
			status	= usb_write_buffer_d0(pipe);
			break;
		case	D1_FIFO_USE:
			status	= usb_write_buffer_d1(pipe);
			break;
		case	D0_FIFO_DMA:
			status	= usb_write_dma_d0(pipe);
			break;
		case	D1_FIFO_DMA:
			status	= usb_write_dma_d1(pipe);
			break;
		default:
			status	= usb_write_buffer_c(pipe);
			break;
	};

	switch( status ){
	case	WRITING:					/* Continue of data write */
		usb_enable_brdy_int(pipe);		/* Enable Ready Interrupt */
		usb_enable_nrdy_int(pipe);		/* Error (NORES or STALL) */
		break;
	case	WRITEEND:					/* End of data write */
	case	WRITESHRT:					/* End of data write */
		usb_disable_brdy_int(pipe);		/* Disable Ready Interrupt */
		usb_enable_bemp_int(pipe);		/* Enable Empty Interrupt */
		usb_enable_nrdy_int(pipe);		/* Error (NORES or STALL) */
		break;
	case	WRITEDMA:					/* DMA write */
		usb_enable_nrdy_int(pipe);		/* Error (NORES or STALL) */
		break;
	case	FIFOERROR:					/* FIFO access status */
	default:
		usb_disable_brdy_int(pipe);		/* Disable Ready Interrupt */
		usb_disable_bemp_int(pipe);		/* Disable Empty Interrupt */
		PipeFlag[pipe] = PIPE_IDLE;
		break;
	}
	return	status;						/* End or Err or Continue */

}









//////////////////////////////////////////////////////////////////////
//Buffer Write CFIFO
//Argument   : USB_U16 pipe     ; Pipe Number
//ReturnValue: WRITEEND          : Write end
//           : WRITESHRT         : short data
//           : WRITING           : Continue of data write
//           : WRITEDMA          : Write DMA
//           : FIFOERROR         : FIFO status

USB_U16 usb_write_buffer_c(USB_U16 pipe)
{
	USB_U16	size, count, buffer, mxps;
	USB_U16	status, mbw;

	mbw = usb_get_mbw( USBDataCount[pipe], (USB_U32)USBDataPointer[pipe]);
	if(pipe==PIPE0) {
		buffer	= usb_change_fifo_port(pipe,CUSE,BITISEL, mbw);
	}
	else{
		buffer	= usb_change_fifo_port(pipe,CUSE,USB_NO, mbw);
	}
	if(buffer==FIFOERROR) {							/* FIFO access status */
		return	FIFOERROR;
	}
	size	= usb_get_buf_size(pipe);				/* Data buffer size */
	mxps	= usb_get_mxps(pipe);					/* Max Packet Size */

	if( USBDataCount[pipe] <= (USB_U32)size) {
		status = WRITEEND;							/* write continues */
		count = (USB_U16)USBDataCount[pipe];
		if ( count == 0 ) {
			status = WRITESHRT;						/* Null Packet is end of write */
		}
		if ( (count%mxps)!=0 ) {
			status = WRITESHRT;						/* Short Packet is end of write */
		}
	} 
	else {
		status = WRITING;							/* write continues */
		count = size;
	}

	usb_write_c_fifo(pipe,count);

	if( USBDataCount[pipe] < (USB_U32)size) {
		USBDataCount[pipe] = 0;
		if(USB0.CFIFOCTR.BIT.BVAL == 0){
			USB0.CFIFOCTR.WORD = BITBVAL;			/* Short Packet */
		}
	} 
	else {
		USBDataCount[pipe] -= count;
	}
	return	status;									/* End or Err or Continue */

}









//////////////////////////////////////////////////////////////////////
//Buffer Write D0FIFO
//Argument   : USB_U16 pipe     ; Pipe Number
//ReturnValue: WRITEEND          : Write end
//           : WRITESHRT         : short data
//           : WRITING           : Continue of data write
//           : WRITEDMA          : Write DMA
//           : FIFOERROR         : FIFO status

USB_U16 usb_write_buffer_d0(USB_U16 pipe)
{
	USB_U16 size, count, buffer, mxps;
	USB_U16 status, mbw;

	mbw = usb_get_mbw( USBDataCount[pipe], (USB_U32)USBDataPointer[pipe]);
	buffer = usb_change_fifo_port(pipe,D0USE,USB_NO, mbw);
	if(buffer==FIFOERROR) {							/* FIFO access status */
		return	FIFOERROR;
	}
	size = usb_get_buf_size(pipe);					/* Data buffer size */
	mxps = usb_get_mxps(pipe);						/* Max Packet Size */

	if( USBDataCount[pipe] <= (USB_U32)size) {
		status = WRITEEND;							/* write continues */
		count = (USB_U16)USBDataCount[pipe];
		if ( count == 0 ) {
			status = WRITESHRT;						/* Null Packet is end of write */
		}
		if ( (count%mxps)!=0 ) {
			status = WRITESHRT;						/* Short Packet is end of write */
		}
	} 
	else {
		status = WRITING;							/* write continues */
		count = size;
	}

	usb_write_d0_fifo(pipe,count);

	if( USBDataCount[pipe] < (USB_U32)size) {
		USBDataCount[pipe] = 0;
		if(USB0.D0FIFOCTR.BIT.BVAL == 0){
			USB0.D0FIFOCTR.WORD = BITBVAL;		/* Short Packet */
		}
	} 
	else {
		USBDataCount[pipe] -= count;
	}
	return	status;									/* End or Err or Continue */

}















//////////////////////////////////////////////////////////////////////
//Buffer Write D1FIFO
//Argument   : USB_U16 pipe     ; Pipe Number
//ReturnValue: WRITEEND          : Write end
//           : WRITESHRT         : short data
//           : WRITING           : Continue of data write
//           : WRITEDMA          : Write DMA
//           : FIFOERROR         : FIFO status

USB_U16 usb_write_buffer_d1(USB_U16 pipe)
{
	USB_U16 size, count, buffer, mxps;
	USB_U16 status, mbw;

	mbw = usb_get_mbw( USBDataCount[pipe], (USB_U32)USBDataPointer[pipe]);
	buffer = usb_change_fifo_port(pipe,D1USE,USB_NO, mbw);
	if(buffer==FIFOERROR) {							/* FIFO access status */
		return	FIFOERROR;
	}
	size = usb_get_buf_size(pipe);					/* Data buffer size */
	mxps = usb_get_mxps(pipe);						/* Max Packet Size */

	if( USBDataCount[pipe] <= (USB_U32)size) {
		status = WRITEEND;							/* write continues */
		count = (USB_U16)USBDataCount[pipe];
		if ( count == 0 ) {
			status = WRITESHRT;						/* Null Packet is end of write */
		}
		if ( (count%mxps)!=0 ) {
			status = WRITESHRT;						/* Short Packet is end of write */
		}
	} 
	else {
		status = WRITING;							/* write continues */
		count = size;
	}

	usb_write_d1_fifo(pipe,count);

	if( USBDataCount[pipe] < (USB_U32)size) {
		USBDataCount[pipe] = 0;
		if(USB0.D1FIFOCTR.BIT.BVAL == 0){
			USB0.D1FIFOCTR.WORD = BITBVAL;		/* Short Packet */
		}
	} 
	else {
		USBDataCount[pipe] -= count;
	}
	return	status;									/* End or Err or Continue */

}











//////////////////////////////////////////////////////////////////////
//Buffer DMA Write D0FIFO
//Argument   : USB_U16 pipe     ; Pipe Number
//ReturnValue: WRITEEND          : Write end
//           : WRITESHRT         : short data
//           : WRITING           : Continue of data write
//           : WRITEDMA          : Write DMA
//           : FIFOERROR         : FIFO status

static USB_U16 usb_write_dma_d0(USB_U16 pipe)
{
	USB_U32 size, count, buffer, mxps;
	USB_U16 status, mbw;

	mbw = usb_get_mbw( USBDataCount[pipe], (USB_U32)USBDataPointer[pipe]);
	buffer = usb_change_fifo_port(pipe,D0DMA,USB_NO, mbw);
	if(buffer==FIFOERROR) {							/* FIFO access status */
		return	FIFOERROR;
	}
	size  = usb_get_buf_size(pipe);					/* Data buffer size */
	mxps  = usb_get_mxps(pipe);						/* Max Packet Size */
	count = USBDataCount[pipe];
	if( count != 0){
		USBDmaPipe[USB_D0FIFO] = pipe;
		if((count % size ) != 0){
			USBDmaVal[USB_D0FIFO] = 1;
		}
		else{
			USBDmaVal[USB_D0FIFO] = 0;
		}
		USBDmaInfo[USB_D0FIFO].fifo 	= D0_FIFO_DMA;
		USBDmaInfo[USB_D0FIFO].dir 		= USB_BUF2FIFO;
		USBDmaInfo[USB_D0FIFO].buffer 	= (USB_U32)USBDataPointer[pipe];
		USBDmaInfo[USB_D0FIFO].bytes 	= count;
		USBDmaInfo[USB_D0FIFO].size		= usb_com_get_dmasize(count,
												(USB_U32)USBDmaInfo[USB_D0FIFO].buffer);
		usb_userdef_start_dma(&USBDmaInfo[USB_D0FIFO]);

		USBDataCount[pipe] = 0;
		USBDataPointer[pipe] += count;

		USB0.D0FIFOSEL.BIT.MBW = USBDmaInfo[USB_D0FIFO].size;

		/* DMA transfer enable */
		USB0.D0FIFOSEL.BIT.DREQE = 1;

		status = WRITEDMA;							/* DMA write  */
	}
	else{
		if( USB0.D0FIFOCTR.BIT.BVAL == 0 ) {
			USB0.D0FIFOCTR.BIT.BVAL =  1;			/* Short Packet */
		}
		status = WRITESHRT;							/* Short Packet is end of write */
	}

	return	status;									/* End or Err or Continue */
}






//////////////////////////////////////////////////////////////////////
//Buffer DMA Write D1FIFO
//Argument   : USB_U16 pipe     ; Pipe Number
//ReturnValue: WRITEEND          : Write end
//           : WRITESHRT         : short data
//           : WRITING           : Continue of data write
//           : WRITEDMA          : Write DMA
//           : FIFOERROR         : FIFO status

static USB_U16 usb_write_dma_d1(USB_U16 pipe)
{
	USB_U32 size, count, buffer, mxps;
	USB_U16 status, mbw;

	mbw = usb_get_mbw( USBDataCount[pipe], (USB_U32)USBDataPointer[pipe]);
	buffer = usb_change_fifo_port(pipe,D1DMA,USB_NO, mbw);
	if(buffer==FIFOERROR) {								/* FIFO access status */
		return	FIFOERROR;
	}
	size  = usb_get_buf_size(pipe);						/* Data buffer size */
	mxps  = usb_get_mxps(pipe);							/* Max Packet Size */
	count = USBDataCount[pipe];

	if( count != 0){
		USBDmaPipe[USB_D1FIFO] = pipe;
		if((count % size ) != 0){
			USBDmaVal[USB_D1FIFO] = 1;
		}
		else{
			USBDmaVal[USB_D1FIFO] = 0;
		}
		USBDmaInfo[USB_D1FIFO].fifo 	= D1_FIFO_DMA;
		USBDmaInfo[USB_D1FIFO].dir 		= USB_BUF2FIFO;
		USBDmaInfo[USB_D1FIFO].buffer 	= (USB_U32)USBDataPointer[pipe];
		USBDmaInfo[USB_D1FIFO].bytes 	= count;
		USBDmaInfo[USB_D1FIFO].size		= usb_com_get_dmasize(count,
												(USB_U32)USBDmaInfo[USB_D1FIFO].buffer);
		usb_userdef_start_dma(&USBDmaInfo[USB_D1FIFO]);

		USBDataCount[pipe] = 0;
		USBDataPointer[pipe] += count;

		USB0.D1FIFOSEL.BIT.MBW = USBDmaInfo[USB_D1FIFO].size;

		/* DMA transfer enable */
		USB0.D1FIFOSEL.BIT.DREQE = 1;

		status = WRITEDMA;							/* DMA write  */
	}
	else{
		if( USB0.D1FIFOCTR.BIT.BVAL == 0 ) {
			USB0.D1FIFOCTR.BIT.BVAL =  1;			/* Short Packet */
		}
		status = WRITESHRT;							/* Short Packet is end of write */
	}

	return	status;									/* End or Err or Continue */
}









//////////////////////////////////////////////////////////////////////
//Ŏw肵pCvɂf[^MJn(receive data from host).
//Argument   : USB_U16  pipe     ; pCvԍ
//           : USB_U32 size      ; f[^TCY
//           : USB_U8  *data     ; f[^i[AhX
//ReturnValue: void
//
//w肳ꂽpCvf[^MԂɂ܂B
//USBzXgf[^MBRDY荞݂܂B
//USB荞ݏBRDY荞ݏɂāAFIFOobt@̃f[^ǂݏosA
//f[^M܂B

void usb_start_recieve_transfer(USB_U16 pipe, USB_U32 size, USB_U8 *data)
{
	USB_U16 usefifo;

	usefifo = (USB_U16)(PipeTbl[pipe] & FIFO_USE);
	switch(usefifo){
		case	D0_FIFO_USE:
			usb_start_recieve_trns_d0(pipe, size, data);
			break;
		case	D1_FIFO_USE:
			usb_start_recieve_trns_d1(pipe, size, data);
			break;
		case	D0_FIFO_DMA:
			usb_start_recieve_dma_d0(pipe, size, data);
			break;
		case	D1_FIFO_DMA:
			usb_start_recieve_dma_d1(pipe, size, data);
			break;
		default:
			usb_start_recieve_trns_c(pipe, size, data);
			break;
	}
}











//////////////////////////////////////////////////////////////////////
//Receive Data start CFIFO
//Argument   : USB_U16  pipe     ; Pipe Number
//           : USB_U32 size      ; Data Size
//           : USB_U8  *data     ; Data data Address

static void usb_start_recieve_trns_c(USB_U16 pipe, USB_U32 size, USB_U8 *data)
{
	USB_U16 mbw;

	usb_set_pid_nak(pipe);							/* Set NAK */
	USBDataCount[pipe] = size;
	USBDataPointer[pipe] = (USB_U8 *)data;
	PipeIgnore[pipe]	= 0;						/* Ignore count clear */

	USBRcvDataCount[pipe] = size;
	PipeDataSize[pipe] = size;
	PipeFlag[pipe] = PIPE_WAIT;

	mbw = usb_get_mbw( size, (USB_U32)data);
	usb_set_curpipe(pipe, CUSE, USB_NO, mbw);
	USB0.CFIFOCTR.WORD = BITBCLR;					/* Buffer Clear */

	usb_set_transaction_counter( pipe, size );

	usb_set_pid_buf(pipe);							/* Set BUF */
	usb_enable_brdy_int(pipe);						/* Enable Ready Interrupt */
	usb_enable_nrdy_int(pipe);						/* Error (NORES or STALL) */
}











//////////////////////////////////////////////////////////////////////
//Receive Data start D0FIFO
//Argument   : USB_U16  pipe     ; Pipe Number
//           : USB_U32 size      ; Data Size
//           : USB_U8  *data     ; Data data Address

static void usb_start_recieve_trns_d0(USB_U16 pipe, USB_U32 size, USB_U8 *data)
{
	USB_U16 mbw;

	usb_set_pid_nak(pipe);							/* Set NAK */
	USBDataCount[pipe] = size;
	USBDataPointer[pipe] = (USB_U8 *)data;
	USBRcvDataCount[pipe] = size;
	PipeDataSize[pipe] = size;
	PipeFlag[pipe] = PIPE_WAIT;
	PipeIgnore[pipe]	= 0;						/* Ignore count clear */

	mbw = usb_get_mbw( size, ( USB_U32)data );
	usb_set_curpipe(pipe, D0USE, USB_NO, mbw);

	usb_set_transaction_counter( pipe, size );

	usb_set_pid_buf(pipe);							/* Set BUF */
	usb_enable_brdy_int(pipe);						/* Enable Ready Interrupt */
	usb_enable_nrdy_int(pipe);						/* Error (NORES or STALL) */
}













//////////////////////////////////////////////////////////////////////
//Receive Data start D1FIFO
//Argument   : USB_U16  pipe     ; Pipe Number
//           : USB_U32 size      ; Data Size
//           : USB_U8  *data     ; Data data Address

static void usb_start_recieve_trns_d1(USB_U16 pipe, USB_U32 size, USB_U8 *data)
{
	USB_U16 mbw;

	usb_set_pid_nak(pipe);							/* Set NAK */
	USBDataCount[pipe] = size;
	USBDataPointer[pipe] = (USB_U8 *)data;
	USBRcvDataCount[pipe] = size;
	PipeDataSize[pipe] = size;
	PipeFlag[pipe] = PIPE_WAIT;
	PipeIgnore[pipe]	= 0;						/* Ignore count clear */

	mbw = usb_get_mbw( size, ( USB_U32)data );
	usb_set_curpipe(pipe, D1USE, USB_NO, mbw);

	usb_set_transaction_counter( pipe, size );

	usb_set_pid_buf(pipe);							/* Set BUF */
	usb_enable_brdy_int(pipe);						/* Enable Ready Interrupt */
	usb_enable_nrdy_int(pipe);						/* Error (NORES or STALL) */
}












//////////////////////////////////////////////////////////////////////
//Receive Data DMA D0FIFO
//Argument   : USB_U16  pipe     ; Pipe Number
//           : USB_U32 size      ; Data Size
//           : USB_U8  *data     ; Data data Address

static void usb_start_recieve_dma_d0(USB_U16 pipe, USB_U32 size, USB_U8 *data)
{
	USB_U16 mbw;

	usb_set_pid_nak(pipe);							/* Set NAK */
	USBDataCount[pipe] = size;
	USBDataPointer[pipe] = (USB_U8 *)data;
	USBRcvDataCount[pipe] = size;
	PipeDataSize[pipe] = size;
	PipeFlag[pipe] = PIPE_WAIT;
	PipeIgnore[pipe]	= 0;						/* Ignore count clear */

	mbw = usb_get_mbw( size, (USB_U32)data);
	usb_set_curpipe(pipe, D0USE, USB_NO, mbw);

	usb_set_transaction_counter( pipe, size );

	usb_set_pid_buf(pipe);							/* Set BUF */
	usb_enable_brdy_int(pipe);						/* Enable Ready Interrupt */
	usb_enable_nrdy_int(pipe);						/* Error (NORES or STALL) */
}












//////////////////////////////////////////////////////////////////////
//Receive Data DMA D0FIF1
//Argument   : USB_U16  pipe     ; Pipe Number
//           : USB_U32 size      ; Data Size
//           : USB_U8  *data     ; Data data Address

static void usb_start_recieve_dma_d1(USB_U16 pipe, USB_U32 size, USB_U8 *data)
{
	USB_U16 mbw;

	usb_set_pid_nak(pipe);							/* Set NAK */
	USBDataCount[pipe] = size;
	USBDataPointer[pipe] = (USB_U8 *)data;
	USBRcvDataCount[pipe] = size;
	PipeDataSize[pipe] = size;
	PipeFlag[pipe] = PIPE_WAIT;
	PipeIgnore[pipe]	= 0;						/* Ignore count clear */

	mbw = usb_get_mbw( size, (USB_U32)data);
	usb_set_curpipe(pipe, D1USE, USB_NO, mbw );

	usb_set_transaction_counter( pipe, size );

	usb_set_pid_buf(pipe);							/* Set BUF */
	usb_enable_brdy_int(pipe);						/* Enable Ready Interrupt */
	usb_enable_nrdy_int(pipe);						/* Error (NORES or STALL) */
}












//////////////////////////////////////////////////////////////////////
//Buffer Read
//Argument   : USB_U16 pipe     ; Pipe Number
//ReturnValue: READEND          : Read end
//           : READSHRT         : short data
//           : READING          : Continue of data read
//           : READOVER         : buffer over
//           : FIFOERROR        : FIFO status

USB_U16 usb_read_buffer(USB_U16 pipe)
{
	USB_U16	status;

	PipeIgnore[pipe]	= 0;							/* Ignore count clear */
	if( (PipeTbl[pipe] & FIFO_USE) == D0_FIFO_USE ) {
		status	= usb_read_buffer_d0(pipe);
	} 
	else if( (PipeTbl[pipe] & FIFO_USE) == D1_FIFO_USE ) {
		status	= usb_read_buffer_d1(pipe);
	} 
	else {
		status	= usb_read_buffer_c(pipe);
	}

	switch( status ) {
	case	READING:									/* Continue of data read */
		break;
	case	READEND:									/* End of data read */
	case	READSHRT:									/* End of data read */
		usb_disable_brdy_int(pipe);
		PipeFlag[pipe] = PIPE_DONE;
		PipeDataSize[pipe] -= USBDataCount[pipe];
		USBRcvDataCount[pipe] -= USBDataCount[pipe];	/* Data Count */
		break;
	case	READOVER:									/* buffer over */
		USB0.CFIFOCTR.WORD = BITBCLR;					/* Clear BVAL */
		usb_disable_brdy_int(pipe);						/* Disable Ready Interrupt */
		PipeFlag[pipe] = PIPE_IDLE;
		PipeDataSize[pipe] -= USBDataCount[pipe];
		USBRcvDataCount[pipe] -= USBDataCount[pipe];	/* Data Count */
		break;
	case	FIFOERROR:									/* FIFO access status */
	default:
		usb_disable_brdy_int(pipe);						/* Disable Ready Interrupt */
		PipeFlag[pipe] = PIPE_IDLE;
		break;
	}
	return	status;										/* End or Err or Continue */

}

















//////////////////////////////////////////////////////////////////////
//Buffer Read CFIFO
//Argument   : USB_U16 pipe     ; Pipe Number
//ReturnValue: READEND          : Read end
//           : READSHRT         : short data
//           : READING          : Continue of data read
//           : READOVER         : buffer over
//           : FIFOERROR        : FIFO status

USB_U16 usb_read_buffer_c(USB_U16 pipe)
{
	USB_U16 size, count, buffer, mxps, dtln;
	USB_U16 status, mbw;

	mbw = usb_get_mbw( USBDataCount[pipe], (USB_U32)USBDataPointer[pipe]);
	buffer = usb_change_fifo_port(pipe,CUSE,USB_NO, mbw );
	if(buffer==FIFOERROR) {							/* FIFO access status */
		return	FIFOERROR;
	}
	dtln = (USB_U16)(buffer & BITDTLN);
	size = usb_get_buf_size(pipe);					/* Data buffer size */
	mxps = usb_get_mxps(pipe);						/* Max Packet Size */

	if( USBDataCount[pipe] < dtln ) {				/* Buffer Over ? */
		status = READOVER;
		usb_set_pid_nak(pipe);						/* Set NAK */
		count = (USB_U16)USBDataCount[pipe];
	} 
	else if( USBDataCount[pipe] == dtln ) {			/* just Receive Size */
		status = READEND;
		usb_set_pid_nak(pipe);						/* Set NAK */
		count = dtln;
		if ( count == 0 ) {
			status = READSHRT;						/* Null Packet receive */
		}
		if ( (count%mxps)!=0 ) {
			status = READSHRT;						/* Short Packet receive */
		}
	} 
	else {											/* continus Receive data */
		status = READING;
		count = dtln;
		if ( count == 0 ) {
			status = READSHRT;						/* Null Packet receive */
			usb_set_pid_nak(pipe);					/* Set NAK */
		}
		if ( (count%mxps)!=0 ) {
			status = READSHRT;						/* Short Packet receive */
			usb_set_pid_nak(pipe);					/* Set NAK */
		}
	}

	if( count == 0 ) {								/* 0 length packet */
		USB0.CFIFOCTR.WORD = BITBCLR;				/* Clear BVAL */
	} 
	else {
		usb_read_c_fifo(pipe,count);
	}

	USBDataCount[pipe] -= count;
	return	status;									/* End or Err or Continue */
}










//////////////////////////////////////////////////////////////////////
//Buffer Read D0FIFO
//Argument   : USB_U16 pipe     ; Pipe Number
//ReturnValue: READEND          : Read end
//           : READSHRT         : short data
//           : READING          : Continue of data read
//           : READOVER         : buffer over
//           : FIFOERROR        : FIFO status

USB_U16 usb_read_buffer_d0(USB_U16 pipe)
{
	USB_U16	size, count, buffer, mxps, dtln;
	USB_U16	status, mbw;

	mbw = usb_get_mbw( USBDataCount[pipe], (USB_U32)USBDataPointer[pipe]);
	buffer	= usb_change_fifo_port(pipe,D0USE,USB_NO, mbw);
	if(buffer==FIFOERROR) {							/* FIFO access status */
		return	FIFOERROR;
	}
	dtln	= (USB_U16)(buffer & BITDTLN);
	size	= usb_get_buf_size(pipe);				/* Data buffer size */
	mxps	= usb_get_mxps(pipe);					/* Max Packet Size */

	if( USBDataCount[pipe] < dtln ) {				/* Buffer Over ? */
		status = READOVER;
		usb_set_pid_nak(pipe);						/* Set NAK */
		count = (USB_U16)USBDataCount[pipe];
	} 
	else if( USBDataCount[pipe] == dtln ) {			/* just Receive Size */
		status = READEND;
		usb_set_pid_nak(pipe);						/* Set NAK */
		count = dtln;
		if ( count == 0 ) {
			status = READSHRT;						/* Null Packet receive */
		}
		if ( (count%mxps)!=0 ) {
			status = READSHRT;						/* Short Packet receive */
		}
	} 
	else {											/* continus Receive data */
		status = READING;
		count = dtln;
		if ( count == 0 ) {
			status = READSHRT;						/* Null Packet receive */
			usb_set_pid_nak(pipe);					/* Set NAK */
		}
		if ( (count%mxps)!=0 ) {
			status = READSHRT;						/* Short Packet receive */
			usb_set_pid_nak(pipe);					/* Set NAK */
		}
	}

	if( count == 0 ) {								/* 0 length packet */
		USB0.D0FIFOCTR.WORD = BITBCLR;			/* Clear BVAL */
	} 
	else {
		usb_read_d0_fifo(pipe,count);
	}

	USBDataCount[pipe] -= count;
	return	status;									/* End or Err or Continue */
}













//////////////////////////////////////////////////////////////////////
//Buffer Read D1FIFO
//Argument   : USB_U16 pipe     ; Pipe Number
//ReturnValue: READEND          : Read end
//           : READSHRT         : short data
//           : READING          : Continue of data read
//           : READOVER         : buffer over
//           : FIFOERROR        : FIFO status

USB_U16 usb_read_buffer_d1(USB_U16 pipe)
{
	USB_U16	size, count, buffer, mxps, dtln;
	USB_U16	status, mbw;

	mbw = usb_get_mbw( USBDataCount[pipe], (USB_U32)USBDataPointer[pipe]);
	buffer	= usb_change_fifo_port(pipe,D1USE,USB_NO, mbw );
	if(buffer==FIFOERROR) {							/* FIFO access status */
		return	FIFOERROR;
	}
	dtln	= (USB_U16)(buffer & BITDTLN);
	size	= usb_get_buf_size(pipe);				/* Data buffer size */
	mxps	= usb_get_mxps(pipe);					/* Max Packet Size */

	if( USBDataCount[pipe] < dtln ) {				/* Buffer Over ? */
		status = READOVER;
		usb_set_pid_nak(pipe);						/* Set NAK */
		count = (USB_U16)USBDataCount[pipe];
	} 
	else if( USBDataCount[pipe] == dtln ) {			/* just Receive Size */
		status = READEND;
		usb_set_pid_nak(pipe);						/* Set NAK */
		count = dtln;
		if ( count == 0 ) {
			status = READSHRT;						/* Null Packet receive */
		}
		if ( (count%mxps)!=0 ) {
			status = READSHRT;						/* Short Packet receive */
		}
	} 
	else {											/* continus Receive data */
		status = READING;
		count = dtln;
		if ( count == 0 ) {
			status = READSHRT;						/* Null Packet receive */
			usb_set_pid_nak(pipe);					/* Set NAK */
		}
		if ( (count%mxps)!=0 ) {
			status = READSHRT;						/* Short Packet receive */
			usb_set_pid_nak(pipe);					/* Set NAK */
		}
	}

	if( count == 0 ) {								/* 0 length packet */
		USB0.D1FIFOCTR.WORD = BITBCLR;			/* Clear BVAL */
	} 
	else {
		usb_read_d1_fifo(pipe,count);
	}

	USBDataCount[pipe] -= count;
	return	status;									/* End or Err or Continue */
}
















//////////////////////////////////////////////////////////////////////
//Buffer Read
//Argument   : USB_U16 pipe     ; Pipe Number
//ReturnValue: READEND          : Read end
//           : READSHRT         : short data
//           : READING          : Continue of data read
//           : READOVER         : buffer over
//           : FIFOERROR        : FIFO status

USB_U16 usb_read_dma(USB_U16 pipe)
{
	USB_U16	status;

	PipeIgnore[pipe]	= 0;							/* Ignore count clear */
	if( (PipeTbl[pipe] & FIFO_USE) == D0_FIFO_DMA ) {
		status	= usb_read_dma_d0(pipe);
	} 
	else {
		status	= usb_read_dma_d1(pipe);
	}

	switch( status ) {
	case	READING:									/* Continue of data read */
		break;
	case	READEND:									/* End of data read */
	case	READSHRT:									/* End of data read */
		usb_disable_brdy_int(pipe);
		PipeDataSize[pipe] -= USBDataCount[pipe];
		USBRcvDataCount[pipe] -= USBDataCount[pipe];	/* Data Count */
		USBDataCount[pipe] = 0;
		break;
	case	READOVER:									/* buffer over */
		usb_disable_brdy_int(pipe);						/* Disable Ready Interrupt */
		PipeDataSize[pipe] -= USBDataCount[pipe];
		USBRcvDataCount[pipe] -= USBDataCount[pipe];	/* Data Count */
		USBDataCount[pipe] = 0;
		break;
	case	FIFOERROR:									/* FIFO access status */
	default:
		usb_disable_brdy_int(pipe);						/* Disable Ready Interrupt */
		PipeFlag[pipe] = PIPE_IDLE;
		break;
	}
	return	status;										/* End or Err or Continue */
}











//////////////////////////////////////////////////////////////////////
//Buffer Read DMA D0FIFO
//Argument   : USB_U16 pipe     ; Pipe Number
//ReturnValue: READEND          : Read end
//           : READSHRT         : short data
//           : READING          : Continue of data read
//           : READOVER         : buffer over
//           : FIFOERROR        : FIFO status

static USB_U16 usb_read_dma_d0(USB_U16 pipe)
{
	USB_U16	size, count, buffer, mxps, dtln;
	USB_U16	status, mbw;

	mbw = usb_get_mbw( USBDataCount[pipe], (USB_U32)USBDataPointer[pipe]);
	buffer	= usb_change_fifo_port(pipe,D0USE,USB_NO, mbw );
	if(buffer==FIFOERROR) {							/* FIFO access status */
		return	FIFOERROR;
	}
	dtln	= (USB_U16)(buffer & BITDTLN);
	size	= usb_get_buf_size(pipe);				/* Data buffer size */
	mxps	= usb_get_mxps(pipe);					/* Max Packet Size */

	if( USBDataCount[pipe] < dtln ) {				/* Buffer Over ? */
		status = READOVER;
		count = (USB_U16)USBDataCount[pipe];
	} 
	else if( USBDataCount[pipe] == dtln ) {			/* just Receive Size */
		status = READEND;
		count = dtln;
		if ( count == 0 ) {
			status = READSHRT;						/* Null Packet receive */
		}
		if ( (count%mxps)!=0 ) {
			status = READSHRT;						/* Short Packet receive */
		}
	} 
	else {											/* continus Receive data */
		status = READING;
		count = dtln;
		if ( count == 0 ) {
			status = READSHRT;						/* Null Packet receive */
		}
		if ( (count%mxps)!=0 ) {
			status = READSHRT;						/* Short Packet receive */
		}
	}

	if( count == 0 ) {								/* 0 length packet */
		USB0.D0FIFOCTR.WORD = BITBCLR;			/* Clear BVAL */
	} 
	else {
		USBDmaPipe[USB_D0FIFO]			= pipe;
		USBDmaVal[USB_D0FIFO]			= 0;
		USBDmaInfo[USB_D0FIFO].fifo		= D0_FIFO_DMA;
		USBDmaInfo[USB_D0FIFO].dir		= USB_FIFO2BUF;
		USBDmaInfo[USB_D0FIFO].buffer	= (USB_U32)USBDataPointer[pipe];
		USBDmaInfo[USB_D0FIFO].size	= usb_com_get_dmasize((USB_U32)USBDataCount[pipe],
												(USB_U32)USBDmaInfo[USB_D0FIFO].buffer);
		if(USBDmaInfo[USB_D0FIFO].size == 0){
			USBDmaInfo[USB_D0FIFO].bytes 	= count;
		}
		else if(USBDmaInfo[USB_D0FIFO].size == 1){
			USBDmaInfo[USB_D0FIFO].bytes 	= ((count+1)/2)*2;
		}
		else if(USBDmaInfo[USB_D0FIFO].size == 2){
			USBDmaInfo[USB_D0FIFO].bytes 	= ((count+3)/4)*4;
		}

		USBDmaStatus[USB_D0FIFO] = USB_DMA_BUSY;

		usb_userdef_start_dma(&USBDmaInfo[USB_D0FIFO]);

		USB0.D0FIFOSEL.BIT.MBW = USBDmaInfo[USB_D0FIFO].size;
		/* DMA transfer enable */
		USB0.D0FIFOSEL.BIT.DREQE = 1;
	}

	USBDataCount[pipe] -= count;
	return	status;									/* End or Err or Continue */
}













//////////////////////////////////////////////////////////////////////
//Buffer Read DMA D1FIFO
//Argument   : USB_U16 pipe     ; Pipe Number
//ReturnValue: READEND          : Read end
//           : READSHRT         : short data
//           : READING          : Continue of data read
//           : READOVER         : buffer over
//           : FIFOERROR        : FIFO status

static USB_U16 usb_read_dma_d1(USB_U16 pipe)
{
	USB_U16	size, count, buffer, mxps, dtln;
	USB_U16	status, mbw;

	mbw = usb_get_mbw( USBDataCount[pipe], (USB_U32)USBDataPointer[pipe]);
	buffer	= usb_change_fifo_port(pipe,D1USE,USB_NO, mbw);
	if(buffer==FIFOERROR) {							/* FIFO access status */
		return	FIFOERROR;
	}
	dtln	= (USB_U16)(buffer & BITDTLN);
	size	= usb_get_buf_size(pipe);				/* Data buffer size */
	mxps	= usb_get_mxps(pipe);					/* Max Packet Size */

	if( USBDataCount[pipe] < dtln ) {				/* Buffer Over ? */
		status = READOVER;
		count = (USB_U16)USBDataCount[pipe];
	} 
	else if( USBDataCount[pipe] == dtln ) {			/* just Receive Size */
		status = READEND;
		count = dtln;
		if ( count == 0 ) {
			status = READSHRT;						/* Null Packet receive */
		}
		if ( (count%mxps)!=0 ) {
			status = READSHRT;						/* Short Packet receive */
		}
	} 
	else {											/* continus Receive data */
		status = READING;
		count = dtln;
		if ( count == 0 ) {
			status = READSHRT;						/* Null Packet receive */
		}
		if ( (count%mxps)!=0 ) {
			status = READSHRT;						/* Short Packet receive */
		}
	}

	if( count == 0 ) {								/* 0 length packet */
		USB0.D1FIFOCTR.WORD = BITBCLR;			/* Clear BVAL */
	} 
	else {
		USBDmaPipe[USB_D1FIFO] = pipe;
		USBDmaVal[USB_D1FIFO] = 0;
		USBDmaInfo[USB_D1FIFO].fifo 	= D1_FIFO_DMA;
		USBDmaInfo[USB_D1FIFO].dir 		= USB_FIFO2BUF;
		USBDmaInfo[USB_D1FIFO].buffer 	= (USB_U32)USBDataPointer[pipe];
		USBDmaInfo[USB_D1FIFO].size	= usb_com_get_dmasize((USB_U32)USBDataCount[pipe],
												(USB_U32)USBDmaInfo[USB_D1FIFO].buffer);
		if(USBDmaInfo[USB_D1FIFO].size == 0){
			USBDmaInfo[USB_D1FIFO].bytes 	= count;
		}
		else if(USBDmaInfo[USB_D1FIFO].size == 1){
			USBDmaInfo[USB_D1FIFO].bytes 	= ((count+1)/2)*2;
		}
		else if(USBDmaInfo[USB_D1FIFO].size == 2){
			USBDmaInfo[USB_D1FIFO].bytes 	= ((count+3)/4)*4;
		}

		USBDmaStatus[USB_D1FIFO] = USB_DMA_BUSY;

		usb_userdef_start_dma(&USBDmaInfo[USB_D1FIFO]);

		USB0.D1FIFOSEL.BIT.MBW = USBDmaInfo[USB_D1FIFO].size;
		/* DMA transfer enable */
		USB0.D1FIFOSEL.BIT.DREQE = 1;
	}

	USBDataCount[pipe] -= count;
	return	status;									/* End or Err or Continue */
}














//////////////////////////////////////////////////////////////////////
//pipe Change
//Argument   : USB_U16  pipe     ; Pipe Number
//           : USB_U16 fifosel   ; Select FIFO
//           : USB_U16 isel      ; FIFO Access Direction
//           : USB_U16 mbw       ; FIFO Port Access Bit Width
//ReturnValue: FIFOERROR         : Error
//           : Others            : CFIFOCTR/D0FIFOCTR/D1FIFOCTR Register Value

USB_U16 usb_change_fifo_port(USB_U16 pipe, USB_U16 fifosel, USB_U16 isel, USB_U16 mbw )
{
	USB_U16 buffer;
	int i;
	volatile int j;			/* 1:5nsec wait count @200MHz */

	usb_set_curpipe(pipe,fifosel,isel, mbw );

	for(i=0;i<4;i++) {
		switch(fifosel){
		case	CUSE:
			buffer = USB0.CFIFOCTR.WORD;
			break;
		case	D0USE:
		case	D0DMA:
			buffer = USB0.D0FIFOCTR.WORD;
			break;
		case	D1USE:
		case	D1DMA:
			buffer = USB0.D1FIFOCTR.WORD;
			break;
		default:
			buffer	= 0;
			break;
		}
		if((USB_U16)(buffer & BITFRDY) == BITFRDY) {
			return	buffer;
		}
		j = 25;
		while(j-- > 0){
		/* wait */
		}
	}
	return	FIFOERROR;
}














//////////////////////////////////////////////////////////////////////
//set current pipe
//Argument   : USB_U16  pipe     ; Pipe Number
//           : USB_U16 fifosel   ; Select FIFO
//           : USB_U16 isel      ; FIFO Access Direction
//           : USB_U16 mbw       ; FIFO Port Access Bit Width

void usb_set_curpipe(USB_U16 pipe, USB_U16 fifosel, USB_U16 isel, USB_U16 mbw )
{
	USB_U16	buffer;
	int i;
	volatile int j;			/* 1:5nsec wait count @200MHz */

	USBmbw[ pipe ] = mbw;

	switch(fifosel){
	case	CUSE:
		buffer = USB0.CFIFOSEL.WORD;
		buffer &= (USB_U16)~(BITISEL | BITCURPIPE );
		buffer |= (USB_U16)(~isel & BITISEL );
		USB0.CFIFOSEL.WORD = buffer;			/* ISEL = ~isel CURPIPE=0 */
		for(i=0;i<4;i++) {
			if( ( USB0.CFIFOSEL.WORD & (BITISEL | BITCURPIPE ) ) == 
								( buffer & ( BITISEL | BITCURPIPE ) ) ){
				break;
			}
			j = 100;
			while(j-- > 0){
				/* wait */
			}
		}
		buffer &= (USB_U16)~(BITISEL | BITCURPIPE | BITMBW );
		buffer |= (USB_U16)(isel | pipe | mbw );
		USB0.CFIFOSEL.WORD = buffer;				/* ISEL= isel, CURPIPE=pipe */
		for(i=0;i<4;i++) {
			if( ( USB0.CFIFOSEL.WORD & (BITISEL | BITCURPIPE ) ) == 
								( buffer & ( BITISEL | BITCURPIPE ) ) ){
				break;
			}
			j = 100;
			while(j-- > 0){
				/* wait */
			}
		}
		break;
	case	D0USE:
	case	D0DMA:
		buffer = USB0.D0FIFOSEL.WORD;
		buffer &= (USB_U16)~(BITCURPIPE );
		USB0.D0FIFOSEL.WORD = buffer;			/* CURPIPE=0 */
		for(i=0;i<4;i++) {
			if( ( USB0.D0FIFOSEL.WORD & BITCURPIPE ) == ( buffer & BITCURPIPE ) ){
				break;
			}
			j = 100;
			while(j-- > 0){
				/* wait */
			}
		}
		buffer &= (USB_U16)~(BITCURPIPE | BITMBW );
		buffer |= (USB_U16)(pipe | mbw );
		USB0.D0FIFOSEL.WORD = buffer;
		for(i=0;i<4;i++) {
			if( ( USB0.D0FIFOSEL.WORD & BITCURPIPE ) == ( buffer & BITCURPIPE ) ){
				break;
			}
			j = 100;
			while(j-- > 0){
				/* wait */
			}
		}
		break;
	case	D1USE:
	case	D1DMA:
		buffer = USB0.D1FIFOSEL.WORD;
		buffer &= (USB_U16)~( BITCURPIPE );
		USB0.D1FIFOSEL.WORD = buffer;			/* CURPIPE=0 */
		for(i=0;i<4;i++) {
			if( ( USB0.D1FIFOSEL.WORD & BITCURPIPE ) == ( buffer & BITCURPIPE ) ){
				break;
			}
			j = 100;
			while(j-- > 0){
				/* wait */
			}
		}
		buffer &= (USB_U16)~( BITCURPIPE | BITMBW );
		buffer |= (USB_U16)( pipe | mbw );
		USB0.D1FIFOSEL.WORD = buffer;
		for(i=0;i<4;i++) {
			if( ( USB0.D1FIFOSEL.WORD & BITCURPIPE ) == ( buffer & BITCURPIPE ) ){
				break;
			}
			j = 100;
			while(j-- > 0){
				/* wait */
			}
		}
		break;
	default:
		break;
	}
	/* Cautions !!!
	 * Depending on the external bus speed of CPU, you may need to wait for 450ns here.
	 * For details, please look at the data sheet.	 */
	j = 100;
	while(j-- > 0){
		/* wait */
	}
}












//////////////////////////////////////////////////////////////////////
//CFIFO write
//Argument   : USB_U16  pipe     ; Pipe Number
//           : USB_U16 count     ; Data Size(Byte)

static void usb_write_c_fifo(USB_U16 pipe,USB_U16 count)
{
	register USB_U16 even;
	
	if(USBmbw[ pipe ] == BITMBW_8){
		for( even = count; even; --even ) {
//			USB0.CFIFO = *USBDataPointer[pipe];
			USBDataPointer[pipe] += 1;
		}
	}
	else if(USBmbw[ pipe ] == BITMBW_16){
		for( even = (USB_U16)(count/2); even; --even ) {
			USB0.CFIFO.WORD = *((USB_U16 *)USBDataPointer[pipe]);
			USBDataPointer[pipe] += 2;
		}
	}
	else{
		for( even = (USB_U16)(count/4); even; --even ) {
//			USB0.CFIFO = *((USB_U32 *)USBDataPointer[pipe]);
			USBDataPointer[pipe] += 4;
		}
	}
}








//////////////////////////////////////////////////////////////////////
// CFIFO read
//Argument   : USB_U16  pipe     ; Pipe Number
//           : USB_U16 count     ; Data Size(Byte)

static void usb_read_c_fifo(USB_U16 pipe,USB_U16 count)
{
	register USB_U16	even;
	
	if(USBmbw[ pipe ] == BITMBW_8){
		for( even = count; even; --even ) {
//			*USBDataPointer[pipe] = USB0.CFIFO;
			USBDataPointer[pipe] += 1;
		}
	}
	else if(USBmbw[ pipe ] == BITMBW_16){
		for( even = (USB_U16)((count+1)/2); even; --even ) {
			*((USB_U16 *)USBDataPointer[pipe]) = USB0.CFIFO.WORD;
			USBDataPointer[pipe] += 2;
		}
	}
	else{
		for( even = (USB_U16)((count+3)/4); even; --even ) {
//			*((USB_U32 *)USBDataPointer[pipe]) = USB0.CFIFO;
			USBDataPointer[pipe] += 4;
		}
	}
}







//////////////////////////////////////////////////////////////////////
//D0FIFO write
//Argument   : USB_U16  pipe     ; Pipe Number
//           : USB_U16 count     ; Data Size(Byte)

static void usb_write_d0_fifo(USB_U16 pipe,USB_U16 count)
{
	register USB_U16	even;
	
	if(USBmbw[ pipe ] == BITMBW_8){
		for( even = count; even; --even ) {
//			USB0.D0FIFO = *USBDataPointer[pipe];
			USBDataPointer[pipe] += 1;
		}
	}
	else if(USBmbw[ pipe ] == BITMBW_16){
		for( even = (USB_U16)(count/2); even; --even ) {
			USB0.D0FIFO.WORD = *((USB_U16 *)USBDataPointer[pipe]);
			USBDataPointer[pipe] += 2;
		}
	}
	else{
		for( even = (USB_U16)(count/4); even; --even ) {
//			USB0.D0FIFO = *((USB_U32 *)USBDataPointer[pipe]);
			USBDataPointer[pipe] += 4;
		}
	}
}





//////////////////////////////////////////////////////////////////////
//D0FIFO read
//Argument   : USB_U16  Pipe     ; Pipe Number
//           : USB_U16 count     ; Data Size(Byte)

static void usb_read_d0_fifo(USB_U16 pipe,USB_U16 count)
{
	register USB_U16	even;
	
	if(USBmbw[ pipe ] == BITMBW_8){
		for( even = count; even; --even ) {
//			*USBDataPointer[pipe] = USB0.D0FIFO;
			USBDataPointer[pipe] += 1;
		}
	}
	else if(USBmbw[ pipe ] == BITMBW_16){
		for( even = (USB_U16)((count+1)/2); even; --even ) {
			*((USB_U16 *)USBDataPointer[pipe]) = USB0.D0FIFO.WORD;
			USBDataPointer[pipe] += 2;
		}
	}
	else{
		for( even = (USB_U16)((count+3)/4); even; --even ) {
//			*((USB_U32 *)USBDataPointer[pipe]) = USB0.D0FIFO;
			USBDataPointer[pipe] += 4;
		}
	}
}







//////////////////////////////////////////////////////////////////////
//D1FIFO write
//Argument   : USB_U16  pipe     ; Pipe Number
//           : USB_U16 count     ; Data Size(Byte)

static void usb_write_d1_fifo(USB_U16 pipe,USB_U16 count)
{
	register USB_U16	even;
	
	if(USBmbw[ pipe ] == BITMBW_8){
		for( even = count; even; --even ) {
//			USB0.D1FIFO = *USBDataPointer[pipe];
			USBDataPointer[pipe] += 1;
		}
	}
	else if(USBmbw[ pipe ] == BITMBW_16){
		for( even = (USB_U16)(count/2); even; --even ) {
			USB0.D1FIFO.WORD = *((USB_U16 *)USBDataPointer[pipe]);
			USBDataPointer[pipe] += 2;
		}
	}
	else{
		for( even = (USB_U16)(count/4); even; --even ) {
//			USB0.D1FIFO = *((USB_U32 *)USBDataPointer[pipe]);
			USBDataPointer[pipe] += 4;
		}
	}
}





//////////////////////////////////////////////////////////////////////
//D1FIFO read
//Argument   : USB_U16  pipe     ; Pipe Number
//           : USB_U16 count     ; Data Size(Byte)

static void usb_read_d1_fifo(USB_U16 pipe,USB_U16 count)
{
	register USB_U16 even;
	
	if( USBmbw[ pipe ] == BITMBW_8 ){
		for( even = count; even; --even ) {
//			*USBDataPointer[pipe] = USB0.D1FIFO;
			USBDataPointer[pipe] += 1;
		}
	}
	else if(USBmbw[ pipe ] == BITMBW_16){
		for( even = (USB_U16)((count+1)/2); even; --even ) {
			*((USB_U16 *)USBDataPointer[pipe]) = USB0.D1FIFO.WORD;
			USBDataPointer[pipe] += 2;
		}
	}
	else{
		for( even = (USB_U16)((count+3)/4); even; --even ) {
//			*((USB_U32 *)USBDataPointer[pipe]) = USB0.D1FIFO;
			USBDataPointer[pipe] += 4;
		}
	}
}

//////////////////////////////////////////////////////////////////////
//DMA Transfer Size
//Argument    : USB_U32 trncount   : transfer byte
//            : USB_U32 dtptr      : transfer data pointer
//ReturnValue : DMA transfer size    : 0   8bit
//            :                      : 1  16bit
//            :                      : 2  32bit

static USB_U32	usb_com_get_dmasize(USB_U32 trncount,USB_U32 dtptr)
{
	USB_U32 size;
	
	
	if( ((trncount & 0x0001) != 0) || ((dtptr & 0x00000001) != 0) ) {
		/*  When transfer byte count is odd 		*/
		/* or transfer data area is 8-bit alignment */
		size = 0;			/* 8bit */
	}
	else if( ((trncount & 0x0003) != 0) || ((dtptr & 0x00000003) != 0) ) {
		/* When the transfer byte count is multiples of 2 */
		/* or the transfer data area is 16-bit alignment */
		size = 1;			/* 16bit */
	}
	else {
		/* When the transfer byte count is multiples of 4 */
		/* or the transfer data area is 32-bit alignment */
		size = 2;			/* 32bit */
	}
	return size;
}








//////////////////////////////////////////////////////////////////////
// FIFO Transfer Size
//Argument    : USB_U32 trncount   : transfer byte
//            : USB_U32 dtptr      : transfer data pointer
//ReturnValue : FIFO transfer size   : BITMBW_8    8bit
//            :                      : BITMBW_16  16bit
//            :                      : BITMBW_32  32bit

USB_U16	usb_get_mbw(USB_U32 trncount,USB_U32 dtptr)
{
	USB_U32 size;
	USB_U16 mbw;
	
	size = usb_com_get_dmasize(trncount, dtptr);
	if( size == 0 ) {
		/* 8bit */
		mbw = BITMBW_8;
	}
	else if( size == 1 ) {
		/* 16bit */
		mbw = BITMBW_16;
	}
	else {
		/* 32bit */
		mbw = BITMBW_32;
	}
	return mbw;
}









//////////////////////////////////////////////////////////////////////
//Transaction counter setting 
//Argument    : USB_U16 pipe     ; Pipe number
//            : USB_U32 bsize    : Data transfer size

static void usb_set_transaction_counter( USB_U16 pipe, USB_U32 bsize )
{
	USB_U16	mxps;
	USB_U16 cnt;
	
	if( bsize  == 0 ){
		return;
	}

	mxps = usb_get_mxps( pipe );			/* Max Packet Size */

	if( ( bsize % mxps ) == 0 ){
		/* Trancnt */
		cnt =  ( USB_U16 )( bsize / mxps );
	} 
	else {
		cnt =  ( USB_U16 )( ( bsize / mxps ) + 1 );
	}

	switch	( pipe ) {
		case	PIPE1:
			USB0.PIPE1TRE.BIT.TRCLR = 1;
			USB0.PIPE1TRN = cnt;
			USB0.PIPE1TRE.BIT.TRENB = 1;
			break;
		case	PIPE2:
			USB0.PIPE2TRE.BIT.TRCLR = 1;
			USB0.PIPE2TRN = cnt;
			USB0.PIPE2TRE.BIT.TRENB = 1;
			break;
		case	PIPE3:
			USB0.PIPE3TRE.BIT.TRCLR = 1;
			USB0.PIPE3TRN = cnt;
			USB0.PIPE3TRE.BIT.TRENB = 1;
			break;
		case	PIPE4:
			USB0.PIPE4TRE.BIT.TRCLR = 1;
			USB0.PIPE4TRN = cnt;
			USB0.PIPE4TRE.BIT.TRENB = 1;
			break;
		case	PIPE5:
			USB0.PIPE5TRE.BIT.TRCLR = 1;
			USB0.PIPE5TRN = cnt;
			USB0.PIPE5TRE.BIT.TRENB = 1;
			break;
		default:
			break;
	}
}









//////////////////////////////////////////////////////////////////////
//Transaction counter clear
//Argument    : USB_U16 pipe     ; Pipe number

void  usb_clear_transaction_counter( USB_U16 pipe )
{
	switch	( pipe ) {
	case	PIPE1:
		USB0.PIPE1TRE.BIT.TRENB = 0;
		USB0.PIPE1TRE.BIT.TRCLR = 1;
		break;
	case	PIPE2:
		USB0.PIPE2TRE.BIT.TRENB = 0;
		USB0.PIPE2TRE.BIT.TRCLR = 1;
		break;
	case	PIPE3:
		USB0.PIPE3TRE.BIT.TRENB = 0;
		USB0.PIPE3TRE.BIT.TRCLR = 1;
		break;
	case	PIPE4:
		USB0.PIPE4TRE.BIT.TRENB = 0;
		USB0.PIPE4TRE.BIT.TRCLR = 1;
		break;
	case	PIPE5:
		USB0.PIPE5TRE.BIT.TRENB = 0;
		USB0.PIPE5TRE.BIT.TRCLR = 1;
		break;
	default:
		break;
	}

}









//////////////////////////////////////////////////////////////////////
//Stop Transfer (receive data from host).
//Argument   : USB_U16  pipe     ; Pipe Number

void usb_stop_transfer( USB_U16 pipe )
{
	USB_U16 usefifo;
	USB_U32	remain;

	usb_set_pid_nak( pipe );

	usefifo = (USB_U16)(PipeTbl[pipe] & FIFO_USE);
	switch(usefifo){
		case	D0USE:
			usb_clear_transaction_counter( pipe );
			USB0.D0FIFOCTR.WORD = BITBCLR;		/* Buffer Clear */
			break;
		case	D1USE:
			usb_clear_transaction_counter( pipe );
			USB0.D1FIFOCTR.WORD = BITBCLR;		/* Buffer Clear */
			break;
		case	D0DMA:
			remain = usb_userdef_stop_dma0();
			usb_dma_stop_d0( pipe, remain );
			usb_clear_transaction_counter( pipe );
			USB0.D0FIFOCTR.WORD = BITBCLR;		/* Buffer Clear */
			break;
		case	D1DMA:
			remain = usb_userdef_stop_dma1();
			usb_dma_stop_d1( pipe, remain );
			usb_clear_transaction_counter( pipe );
			USB0.D1FIFOCTR.WORD = BITBCLR;		/* Buffer Clear */
			break;
		default:
			usb_clear_transaction_counter( pipe );
			USB0.CFIFOCTR.WORD =  BITBCLR;		/* Buffer Clear */
			break;
	}
	usb_change_fifo_port( PIPE0,usefifo,USB_NO, BITMBW_16 );
	/* Because of obtaining the data receive byte count  */

	/* Interrupt of pipe set is disabled */
	usb_disable_brdy_int(pipe);
	usb_disable_nrdy_int(pipe);
	usb_disable_bemp_int(pipe);

	USB0.PIPESEL.WORD =  PIPE0;
	usb_aclrm(pipe);
	usb_set_csclr(pipe);
}












//////////////////////////////////////////////////////////////////////
//DxFIFO - Buffer data DMA transfer start
//Argument   : USB_DMA *dma   : DMA parameter

void	usb_userdef_start_dma(USB_DMA *dma)
{

	USB_U32			trncount;
	USB_U32 		src, dst;
	USB_U32			size;
	USB_U32			dir;
	USB_U32			ptr;

	trncount = dma->bytes;
	dir      = dma->dir;
	if(dir == USB_FIFO2BUF){
		/* DxFIFO determination */
		if(dma->fifo == D0_FIFO_DMA){
			src = (USB_U32)(&USB0.D0FIFO);
		}
		else{
			src = (USB_U32)(&USB0.D1FIFO);
		}
		dst = dma->buffer;
	}
	else{
		src = dma->buffer;
		/* DxFIFO determination */
		if(dma->fifo == D0_FIFO_DMA){
			dst = (USB_U32)(&USB0.D0FIFO);
		}
		else{
			dst = (USB_U32)(&USB0.D1FIFO);
		}
	}

	size = dma->size;

#ifdef CACHE_WRITEBACK
	ptr = (USB_U32)dma->buffer;
	if((ptr & 0x20000000ul) == 0 ){
		io_cwb((USB_U32)ptr,(USB_U32)(ptr)+trncount);
	}
#endif

	if(dma->fifo == D0_FIFO_DMA){
		usb_enable_dmac0(src, dst, trncount, size, dir, dma->fifo);
	}
	else{
		usb_enable_dmac1(src, dst, trncount, size, dir, dma->fifo);
	}
}









//////////////////////////////////////////////////////////////////////
//setting DMA for D0FIFO
//Argument   : USB_U32 src   : src address
//           : USB_U32 dst   : dst address
//           : USB_U32 count : transfer byte
//           : USB_U32 size  : transfer size
//           : USB_U32 dir   : direction
//           : USB_U32 fifo  : FIFO(D0FIFO or D1FIFO)

static void usb_enable_dmac0(USB_U32 src, USB_U32 dst, USB_U32 count,
							 USB_U32 size, USB_U32 dir, USB_U32 fifo)
{
/*
	if( count == 0 ){
		return;
	}
	DMAC.CHCR6.BIT.HE     = 0;		/* Half end flag clear */
	DMAC.CHCR6.BIT.TE     = 0;		/* Transfer end flag clear */

	/* ---- DMA6 channel control register setting ---- */
	DMAC.CHCR6.BIT.DE = 0;					/* DMA disable */
	/* ---- DMA6 source address register setting ---- */
	DMAC.SAR6 = (USB_U32)src;
	/* ---- DMA6 reload source address register setting ---- */
	DMAC.RSAR6 = 0;
	/* ---- DMA6 destination address register setting ---- */
	DMAC.DAR6 = (USB_U32)dst;
	/* ---- DMA6 reload destination address register setting ---- */
	DMAC.RDAR6 = 0;

	/* ---- DMA6 transfer count register setting ---- */
	if(size == 0){
		DMAC.DMATCR6 = count;
	}
	else if(size == 1){
		DMAC.DMATCR6 = count/2;
	}
	else if(size == 2){
		DMAC.DMATCR6 = count/4;
	}
	else{
		while(1){
			/* size error */
		}
	}

	/* ---- DMA6 reload transfer count register setting ---- */
	DMAC.RDMATCR6 = 0;

	/* ---- DMA6 channel control register setting ---- */
	DMAC.CHCR6.BIT.TC     = 0;		/* Transfer once by one time transfer request  */
	DMAC.CHCR6.BIT.RLDSAR = 0;		/* Reload function for SAR and DMATCR is disabled */
	DMAC.CHCR6.BIT.RLDDAR = 0;		/* Reload function for DAR and DMATCR is disabled */
	DMAC.CHCR6.BIT.TEMASK = 0;		/* DMA transfer is stop when TE bit is set */
	DMAC.CHCR6.BIT.HIE    = 0;		/* Half end interrupt request is disabled */
	if(dir == USB_FIFO2BUF){
		DMAC.CHCR6.BIT.DM     = 1;	/*  Destination address is added */
		DMAC.CHCR6.BIT.SM     = 0;	/* Source address is fixed */
	}
	else if(dir == USB_BUF2FIFO){
		DMAC.CHCR6.BIT.DM     = 0;	/* Destination address is fixed */
		DMAC.CHCR6.BIT.SM     = 1;	/* Source address is added */
	}
	else{
		while(1){
			/* direction error */
		}
	}

	DMAC.CHCR6.BIT.RS     = 8;		/* DMA expansion resource selector */
	DMAC.CHCR6.BIT.TB     = 0;		/* Cycle steal mode */
	DMAC.CHCR6.BIT.TS     = size; 	/* Long word unit  */
	DMAC.CHCR6.BIT.IE     = 1;		/* Interrupt request is enabled */

	/* ==== DMA6 factor select ==== */
	if(fifo == D0_FIFO_DMA){
		DMAC.DMARS3.BYTE.CH6 = 0x03;	/* Factor select USB0 D0FIFO */
	}
	else{
		DMAC.DMARS3.BYTE.CH6 = 0x07;	/* Factor select USB1 D1FIFO */
	}

	/* ==== DMA6 interrupt enabled ==== */
	INTC.IPR07.BIT._DMAC6 = 9;		/* Set to level 9 */

	/* ---- DMA6 completion interrupt enabled ---- */
	DMAC.CHCR6.BIT.DE     = 1;		/* DMA transfer is enabled */

	/* ---- DMA transfer enabled ---- */
	DMAC.DMAOR.BIT.DME = 1;
*/
}









//\[XAfBXg̃AhX̃[hRXɂ͂Ȃ̂Œ




///////////////////////////////////////////////////////////////////////
//setting DMA for D1FIFO
///////////////////////////////////////////////////////////////////////
//Argument   : USB_U32 src   : src address
//           : USB_U32 dst   : dst address
//           : USB_U32 count : transfer byte
//           : USB_U32 size  : transfer size
//           : USB_U32 dir   : direction
//           : USB_U32 fifo  : FIFO(D0FIFO or D1FIFO)

static void usb_enable_dmac1(
	USB_U32 src,
	USB_U32 dst,
	USB_U32 count,
	USB_U32 size,
	USB_U32 dir,
	USB_U32 fifo){

	if( count == 0 ){
		return;
	}

	DMAC1.DMINT.BIT.DTIE=0; //Transfer end flag clear
	DMAC1.DMCNT.BIT.DTE=0; //DMA disable
	DMAC1.DMAMD.BIT.SARA=(USB_U32)src;
	DMAC1.DMAMD.BIT.DARA=(USB_U32)dst;

	switch(size){
	case 0:DMAC1.DMCRA=count;break;
	case 1:DMAC1.DMCRA=count/2;break;
	case 2:DMAC1.DMCRA=count/4;break;
	default:
		printf("DMAC1TCYwG[!\r");
		break;
	}

	DMAC1.DMCRB=0; //reload transfer count register setting




/*
	/* ---- DMA7 channel control register setting ---- */
	DMAC.CHCR7.BIT.TC     = 0;		/* Transfer once by one time transfer request  */
	DMAC.CHCR7.BIT.RLDSAR = 0;		/* Reload function for SAR and DMATCR is disabled */
	DMAC.CHCR7.BIT.RLDDAR = 0;		/* Reload function for DAR and DMATCR is disabled */
	DMAC.CHCR7.BIT.TEMASK = 0;		/* DMA transfer is stop when TE bit is set */
	DMAC.CHCR7.BIT.HIE    = 0;		/* Half end interrupt request is disabled */
	if(dir == USB_FIFO2BUF){
		DMAC.CHCR7.BIT.DM     = 1;	/*  Destination address is added */
		DMAC.CHCR7.BIT.SM     = 0;	/* Source address is fixed */
	}
	else if(dir == USB_BUF2FIFO){
		DMAC.CHCR7.BIT.DM     = 0;	/* Destination address is fixed */
		DMAC.CHCR7.BIT.SM     = 1;	/* Source address is added */
	}
	else{
		while(1){
			/* direction error */
		}
	}

	DMAC.CHCR7.BIT.RS     = 8;		/* DMA expansion resource selector */
	DMAC.CHCR7.BIT.TB     = 0;		/* Cycle steal mode */
	DMAC.CHCR7.BIT.TS     = size; 	/* Long word unit  */
	DMAC.CHCR7.BIT.IE     = 1;		/* Interrupt request is enabled */

	/* ==== DMA7 factor select ==== */
	if(fifo == D0_FIFO_DMA){
		DMAC.DMARS3.BYTE.CH7 = 0x03;	/* Factor select USB0 D0FIFO */
	}
	else{
		DMAC.DMARS3.BYTE.CH7 = 0x07;	/* Factor select USB1 D1FIFO */
	}

	/* ==== DMA7 interrupt enabled ==== */
	INTC.IPR07.BIT._DMAC7 = 9;		/* Set to level 9 */

	/* ---- DMA7 completion interrupt enabled ---- */
	DMAC.CHCR7.BIT.DE     = 1;		/* DMA transfer is enabled */

	/* ---- DMA transfer enabled ---- */
	DMAC.DMAOR.BIT.DME = 1;
*/
}
///////////////////////////////////////////////////////////////////////
//setting DMA for D1FIFO
///////////////////////////////////////////////////////////////////////









//////////////////////////////////////////////////////////////////////
//Buffer to C0FIFO data write DMA stop
///////////////////////////////////////////////////////////////////////
//ReturnValue: USB_U32 return Transfer Cnouter register(DMATCRn) value
//           : regarding to the bus width.
USB_U32 usb_userdef_stop_dma0(void)
{
	USB_U32 size=0;

	if(DMAC0.DMCNT.BIT.DTE==1){
		DMAC0.DMCNT.BIT.DTE=0; //DMA transfer disabled */
		if(DMAC0.DMINT.BIT.DTIE !=1){
			DMAC0.DMINT.BIT.DTIE=0; //Transfer end flag clear */
		}
	}

	if(DMAC0.DMAMD.BIT.DM==1){
		//DataIn

	}else{
		//DataOut
	}

	switch(DMAC0.DMTMD.BIT.SZ){
	case 0:size=DMAC0.DMCRA;break; //8bit
	case 1:size=(DMAC0.DMCRA*2);break; //16bit
	case 2:size=(DMAC0.DMCRA*4);break; //32bit
	} 
	return size;
}
//////////////////////////////////////////////////////////////////////
//Buffer to C0FIFO data write DMA stop
///////////////////////////////////////////////////////////////////////











///////////////////////////////////////////////////////////////////////
//Buffer to C1FIFO data write DMA stop
///////////////////////////////////////////////////////////////////////
//ReturnValue: USB_U32 return Transfer Cnouter register(DMATCRn) value
//           : regarding to the bus width.
USB_U32 usb_userdef_stop_dma1(void)
{
	USB_U32 size=0;

	if(DMAC1.DMCNT.BIT.DTE==1){ //DMA ]?
		DMAC1.DMCNT.BIT.DTE=0; //DMA transfer disabled
		if(DMAC1.DMINT.BIT.DTIE != 1){//]I荞()?
			DMAC1.DMINT.BIT.DTIE=0; //֎~
		}
	}

	if(DMAC1.DMAMD.BIT.DM==1){
		//DataIn

	}else{

		//DataOut
	}

	switch(DMAC1.DMTMD.BIT.SZ){
	case 0:size=DMAC1.DMCRA;break; //8bit
	case 1:size=(DMAC1.DMCRA*2);break; //16bit
	case 2:size=(DMAC1.DMCRA*4);break; //32bit
	} 
	return size;
}
///////////////////////////////////////////////////////////////////////
//Buffer to C1FIFO data write DMA stop
///////////////////////////////////////////////////////////////////////









///////////////////////////////////////////////////////////////////////
//Clear DMA Interrupt Request
///////////////////////////////////////////////////////////////////////
void	usb_userdef_clear_dmaint0(void)
{
	IPR(DMAC,DMAC0I)=0;//DMA interrupt Control
}
///////////////////////////////////////////////////////////////////////
//Clear DMA Interrupt Request
///////////////////////////////////////////////////////////////////////









///////////////////////////////////////////////////////////////////////
//usb_userdef_clear_dmaint1
///////////////////////////////////////////////////////////////////////
void	usb_userdef_clear_dmaint1(void)
{
	IPR(DMAC,DMAC1I)=0;//DMA interrupt Control
}
///////////////////////////////////////////////////////////////////////
//usb_userdef_clear_dmaint1
///////////////////////////////////////////////////////////////////////














///////////////////////////////////////////////////////////////////////
//DMA interrupt handler
///////////////////////////////////////////////////////////////////////
void usb_dma_interrupt0(void)
{
	//DMA interrupt request clear
	usb_userdef_clear_dmaint0();
	usb_dmaint(USB_D0FIFO);
	USBDmaStatus[USB_D0FIFO]=USB_DMA_READY;
}
///////////////////////////////////////////////////////////////////////
//DMA interrupt handler
///////////////////////////////////////////////////////////////////////












///////////////////////////////////////////////////////////////////////
//DMA interrupt handler
///////////////////////////////////////////////////////////////////////
void usb_dma_interrupt1(void)
{
	//DMA interrupt request clear
	usb_userdef_clear_dmaint1();
	usb_dmaint(USB_D1FIFO);
	USBDmaStatus[USB_D1FIFO]=USB_DMA_READY;
}
///////////////////////////////////////////////////////////////////////
//DMA interrupt handler
///////////////////////////////////////////////////////////////////////












///////////////////////////////////////////////////////////////////////
//DMA Transfar end interrupt
///////////////////////////////////////////////////////////////////////
static void usb_dmaint(USB_U16 fifo) 
{
	USB_U16	pipe;

	pipe=USBDmaPipe[fifo];

	if(USBDmaInfo[fifo].dir==USB_BUF2FIFO){
		//buffer to fifo
		usb_dmaint_buf2fifo(pipe);

	}else{

		//fifo to buffer
		usb_dmaint_fifo2buf(pipe);
	}
}
///////////////////////////////////////////////////////////////////////
//DMA Transfar end interrupt
///////////////////////////////////////////////////////////////////////










///////////////////////////////////////////////////////////////////////
//DMA transer end ( fifo to buffer)
///////////////////////////////////////////////////////////////////////
//Argument    : USB_U16 pipeno     : pipe number

static void usb_dmaint_fifo2buf(USB_U16 pipe)
{
	USB_U16 useport;
	USB_U32 remain;

	useport=(USB_U16)(PipeTbl[pipe] & FIFO_USE);

	if(useport==D0_FIFO_DMA){
		//D0FIFO DMA stop
		remain=usb_userdef_stop_dma0();
		usb_dma_stop_d0(pipe,remain);
		if(USBDataCount[pipe]==0){
			USB0.D0FIFOCTR.WORD=BITBCLR;
			PipeFlag[pipe]=PIPE_DONE;
		}

	}else{

		//D1FIFO DMA stop
		remain=usb_userdef_stop_dma1();
		usb_dma_stop_d1(pipe,remain);
		if(USBDataCount[pipe]==0){
			USB0.D1FIFOCTR.WORD=BITBCLR;
			PipeFlag[pipe]=PIPE_DONE;
		}
	}
}
///////////////////////////////////////////////////////////////////////
//DMA transer end ( fifo to buffer)
///////////////////////////////////////////////////////////////////////








///////////////////////////////////////////////////////////////////////
// DMA transer end ( buffer to fifo)
///////////////////////////////////////////////////////////////////////
//Argument    : USB_U16 pipeno     : pipe number
static void usb_dmaint_buf2fifo(USB_U16 pipe)
{
	USB_U16 useport;
	USB_U32 remain;

	useport=(USB_U16)(PipeTbl[pipe] & FIFO_USE);

	if(useport==D0_FIFO_DMA){
		//D0FIFO DMA stop
		remain=usb_userdef_stop_dma0();
		usb_dma_stop_d0(pipe,remain);

		if(USBDmaVal[USB_D0FIFO] !=0){
			USB0.D0FIFOCTR.BIT.BVAL=1;
		}

	}else{

		//D1FIFO DMA stop
		remain=usb_userdef_stop_dma1();
		usb_dma_stop_d1(pipe,remain);
	
		if(USBDmaVal[USB_D1FIFO] !=0) {
			USB0.D1FIFOCTR.BIT.BVAL=1;
		}
	}

	usb_enable_bemp_int(pipe); //Enable Empty Interrupt
}
///////////////////////////////////////////////////////////////////////
// DMA transer end ( buffer to fifo)
///////////////////////////////////////////////////////////////////////















///////////////////////////////////////////////////////////////////////
//D0FIFO DMA stop
///////////////////////////////////////////////////////////////////////
//Argument    : USB_U16 pipe     : pipe number
//            : USB_U32 remain   : transfer byte

void	usb_dma_stop_d0( USB_U16 pipe, USB_U32 remain )
{
	PipeDataSize[pipe] -= remain;
	USB0.D0FIFOSEL.BIT.DREQE=0;
}
///////////////////////////////////////////////////////////////////////
//D0FIFO DMA stop
///////////////////////////////////////////////////////////////////////









///////////////////////////////////////////////////////////////////////
//D1FIFO DMA stop
///////////////////////////////////////////////////////////////////////
//Argument    : USB_U16 pipe     : pipe number
//            : USB_U32 remain   : transfer byte
void	usb_dma_stop_d1( USB_U16 pipe, USB_U32 remain )
{
	PipeDataSize[pipe]-=remain;
	USB0.D1FIFOSEL.BIT.DREQE=0;
}
///////////////////////////////////////////////////////////////////////
//D1FIFO DMA stop
///////////////////////////////////////////////////////////////////////







//////////////////////////////////////////////////////////////////////
//Change configuration
//Argument   : USB_U16 cfg_num      ; Configuration Number

void P_ChangeConfigCB(USB_U16 cfg_num)
{
	USB_U16	dummy;
	dummy	= cfg_num;
	/* User program */
}







//////////////////////////////////////////////////////////////////////
//Change interface
//Argument   : USB_U16 cfg_num      ; Configuration Number
//           : USB_U16 itf_num      ; Interface Number
//           : USB_U16 alt_num      ; Alternate Number

void P_ChangeInterfaceCB(USB_U16 cfg_num, USB_U16 itf_num, USB_U16 alt_num)
{
	USB_U16	dummy_cfg,dummy_itf, dummy_alt;
	dummy_cfg	= cfg_num;
	dummy_itf	= itf_num;
	dummy_alt	= alt_num;
	/* User program */
}









//////////////////////////////////////////////////////////////////////
//Class request (idle or setup stage).
//Argument   : USB_U16 type         ; bmRequestType
//           : USB_U16 req          ; bRequest
//           : USB_U16 value        ; wValue
//           : USB_U16 index        ; wIndex
//           : USB_U16 length       ; wLength

void P_Class0(USB_U16 type, USB_U16 req, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_req, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_req		= req;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/* User program */
}









//////////////////////////////////////////////////////////////////////
//Class request (control read data stage).
//Argument   : USB_U16 type         ; bmRequestType
//           : USB_U16 req          ; bRequest
//           : USB_U16 value        ; wValue
//           : USB_U16 index        ; wIndex
//           : USB_U16 length       ; wLength

void P_Class1(USB_U16 type, USB_U16 req, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_req, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_req		= req;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/* User program */
}







//////////////////////////////////////////////////////////////////////
//Class request (control write data stage).
//Argument   : USB_U16 type         ; bmRequestType
//           : USB_U16 req          ; bRequest
//           : USB_U16 value        ; wValue
//           : USB_U16 index        ; wIndex
//           : USB_U16 length       ; wLength

void P_Class2(USB_U16 type, USB_U16 req, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_req, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_req		= req;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/* User program */
}










//////////////////////////////////////////////////////////////////////
//Class request (control write nodata status stage).
//Argument   : USB_U16 type         ; bmRequestType
//           : USB_U16 req          ; bRequest
//           : USB_U16 value        ; wValue
//           : USB_U16 index        ; wIndex
//           : USB_U16 length       ; wLength

void P_Class3(USB_U16 type, USB_U16 req, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_req, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_req		= req;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/* User program */
}






//////////////////////////////////////////////////////////////////////
//Class request (control read status stage).
//Argument   : USB_U16 type         ; bmRequestType
//           : USB_U16 req          ; bRequest
//           : USB_U16 value        ; wValue
//           : USB_U16 index        ; wIndex
//           : USB_U16 length       ; wLength

void P_Class4(USB_U16 type, USB_U16 req, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_req, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_req		= req;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/* User program */
}






//////////////////////////////////////////////////////////////////////
//Class request (control write status stage).
//Argument   : USB_U16 type         ; bmRequestType
//           : USB_U16 req          ; bRequest
//           : USB_U16 value        ; wValue
//           : USB_U16 index        ; wIndex
//           : USB_U16 length       ; wLength

void P_Class5(USB_U16 type, USB_U16 req, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_req, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_req		= req;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/* User program */
}








//////////////////////////////////////////////////////////////////////
//Vendor request (idle or setup stage).
//Argument   : USB_U16 type         ; bmRequestType
//           : USB_U16 req          ; bRequest
//           : USB_U16 value        ; wValue
//           : USB_U16 index        ; wIndex
//           : USB_U16 length       ; wLength

void P_Vendor0(USB_U16 type, USB_U16 req, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_req, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_req		= req;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/* User program */
}








//////////////////////////////////////////////////////////////////////
//Vendor request (control read data stage).
//Argument   : USB_U16 type         ; bmRequestType
//           : USB_U16 req          ; bRequest
//           : USB_U16 value        ; wValue
//           : USB_U16 index        ; wIndex
//           : USB_U16 length       ; wLength

void P_Vendor1(USB_U16 type, USB_U16 req, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_req, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_req		= req;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/* User program */
}










//////////////////////////////////////////////////////////////////////
//Vendor request (control write data stage).
//Argument   : USB_U16 type         ; bmRequestType
//           : USB_U16 req          ; bRequest
//           : USB_U16 value        ; wValue
//           : USB_U16 index        ; wIndex
//           : USB_U16 length       ; wLength

void P_Vendor2(USB_U16 type, USB_U16 req, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_req, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_req		= req;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/* User program */
}







//////////////////////////////////////////////////////////////////////
//Vendor request (control write nodata status stage).
//Argument   : USB_U16 type         ; bmRequestType
//           : USB_U16 req          ; bRequest
//           : USB_U16 value        ; wValue
//           : USB_U16 index        ; wIndex
//           : USB_U16 length       ; wLength

void P_Vendor3(USB_U16 type, USB_U16 req, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_req, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_req		= req;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/* User program */
}









//////////////////////////////////////////////////////////////////////
//Vendor request (control read status stage).
//Argument   : USB_U16 type         ; bmRequestType
//           : USB_U16 req          ; bRequest
//           : USB_U16 value        ; wValue
//           : USB_U16 index        ; wIndex
//           : USB_U16 length       ; wLength

void P_Vendor4(USB_U16 type, USB_U16 req, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_req, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_req		= req;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/* User program */
}








//////////////////////////////////////////////////////////////////////
//Vendor request (control write status stage).
//Argument   : USB_U16 type         ; bmRequestType
//           : USB_U16 req          ; bRequest
//           : USB_U16 value        ; wValue
//           : USB_U16 index        ; wIndex
//           : USB_U16 length       ; wLength

void P_Vendor5(USB_U16 type, USB_U16 req, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_req, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_req		= req;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/* User program */
}































/////////////////////////////////////////////////////////////////////////
//USB荞݃nh
//USB荞ݏs܂B
//{֐USB荞ݏƂāA荞݃xN^ɓo^ĂB

void usb_interrupt(void)
{
	USB_U16 savepipe1,savepipe2;
	USB_U16 buffer;

	savepipe1 = USB0.CFIFOSEL.WORD;
	savepipe2 = USB0.PIPESEL.WORD;
	P_USBInterrupt();

	//Control transmission changes ISEL within interruption processing.
	//For this reason, write return of ISEL cannot be performed.

	buffer = USB0.CFIFOSEL.WORD;
	buffer &= (USB_U16)~(BITCURPIPE);
	buffer |= (USB_U16)(savepipe1 & BITCURPIPE);
	USB0.CFIFOSEL.WORD = buffer;
	USB0.PIPESEL.WORD = savepipe2;
}




















//////////////////////////////////////////////////////////////////////
//Control read start
//Argument   : USB_U16 size     ; f[^TCY
//           : USB_U8  *data    ; f[^i[AhX
//ReturnValue: WRITEEND         : FIFOobt@ւ̃f[^݊
//           : WRITESHRT        : V[gpPbgɂFIFOobt@ւ̃f[^݊
//           : WRITING          : FIFOobt@ւ̃f[^݌p
//           : FIFOERROR        : FIFOANZXG[
//
//Rg[[h]Ef[^Xe[WɂđMf[^
//FIFOobt@ɏ݂܂BFIFOobt@ւ̃f[^݌A
//DCPf[^MԂɂ܂BUSBzXgւ̃f[^MɁA
//BEMP荞݂܂B{֐̖߂lhFIFOobt@ւ̃f[^
//ph̏ꍇ́AUSB荞ݏBEMP荞ݏɂāA
//FIFOobt@ւ̃f[^݂p܂B

USB_U16 P_CtrlReadStart(USB_U32 size, USB_U8 *data)
{
	USB_U16 status,mbw;

	usb_set_pid_nak(PIPE0);									/* Set NAK */

	USBDataCount[PIPE0] = size;
	USBDataPointer[PIPE0] = data;

	mbw = usb_get_mbw( USBDataCount[PIPE0], (USB_U32)USBDataPointer[PIPE0]);
	usb_set_curpipe(PIPE0,CUSE,BITISEL,mbw);
	USB0.CFIFOCTR.WORD = BITBCLR;			/* Buffer Clear */

	status	= usb_write_buffer_c(PIPE0);

	/* Peripheral Control sequence */
	switch( status ){
	case	WRITESHRT:						/* End of data write */
	case	WRITEEND:						/* End of data write (not null) */
	case	WRITING:						/* Continue of data write */
		usb_enable_bemp_int(PIPE0);			/* Enable Empty Interrupt */
		usb_set_pid_buf(PIPE0);				/* Set BUF */
		break;
	case	FIFOERROR:						/* FIFO access error */
		break;
	default:
		break;
	}
	return	status;							/* End or Err or Continue */
}






//////////////////////////////////////////////////////////////////////
//Control write start
//Argument   : USB_U16 size         ; f[^TCY
//           : USB_U8  *data        ; f[^i[AhX
//
//Rg[Cg]Ef[^Xe[WɂāAf[^M鏀܂B
//USBW[DCPf[^MԂɂ܂B
//USBzXgf[^MBRDY荞݂܂B
//USB荞ݏBRDY荞ݏɂāAFIFOobt@̃f[^ǂݏos܂B

void P_CtrlWriteStart(USB_U32 size, USB_U8 *data)
{
	USB_U16	mbw;

	usb_set_pid_nak(PIPE0);									/* Set NAK */

	USBDataCount[PIPE0] = size;
	USBDataPointer[PIPE0] = data;

	mbw = usb_get_mbw( USBDataCount[PIPE0], (USB_U32)USBDataPointer[PIPE0]);
	usb_set_curpipe(PIPE0,CUSE,BITISEL,mbw);
	USB0.CFIFOCTR.WORD = BITBCLR;			/* Buffer Clear */

	usb_enable_brdy_int(PIPE0);
	usb_set_pid_buf(PIPE0);
}








//////////////////////////////////////////////////////////////////////
//BRDY interrupt
//Argument   : USB_U16 status       ; BRDYSTS Register Value
//            : USB_U16 intenb       ; BRDYENB Register Value
//USBzXgf[^MBRDY荞݂܂B
//USB荞ݏBRDY荞ݏɂāAFIFOobt@̃f[^ǂݏosA
//f[^M܂B

void P_BRDYInterrupt(USB_U16 status, USB_U16 intenb)
{
	volatile USB_U16	dumy_sts;

	if( (status & BITBRDY0) && (intenb & BITBRDY0) ) {
		USB0.BRDYSTS.WORD = (USB_U16)~BITBRDY0;
		USB0.CFIFOSEL.BIT.CURPIPE = PIPE0;
		switch( usb_read_buffer_c(PIPE0) ) {
		case	READING:						/* Continue of data read */
		case	READEND:						/* End of data read */
			usb_set_pid_buf(PIPE0);				/* PID = BUF */
			break;
		case	READSHRT:						/* End of data read */
			usb_disable_brdy_int(PIPE0);
			usb_set_pid_buf(PIPE0);				/* PID = BUF */
			break;
		case	READOVER:						/* FIFO access error */
			USB0.CFIFOCTR.WORD = BITBCLR;		/* Buffer Clear */
			usb_disable_brdy_int(PIPE0);
			usb_set_pid_stall(PIPE0);			/* Req Error */
			break;
		case	FIFOERROR:						/* FIFO access error */
		default:
			usb_disable_brdy_int(PIPE0);
			usb_set_pid_stall(PIPE0);			/* Req Error */
			break;
		}
	} 
	else {
		usb_brdy_int(status, intenb);
	}
	/* 荞ݗvNÃ_~[[h3 */
	dumy_sts = USB0.BRDYSTS.WORD;
	dumy_sts = USB0.BRDYSTS.WORD;
	dumy_sts = USB0.BRDYSTS.WORD;
}








//////////////////////////////////////////////////////////////////////
//NRDY interrupt
//Argument   : USB_U16 status       ; NRDYSTS Register Value
//           : USB_U16 intenb       ; NRDYENB Register Value

void P_NRDYInterrupt(USB_U16 status, USB_U16 intenb)
{
	volatile USB_U16	dumy_sts;

	if( (status & BITNRDY0) && (intenb & BITNRDY0) ) {
		USB0.NRDYSTS.WORD = (USB_U16)~BITNRDY0;
	} 
	else {
		usb_nrdy_int(status, intenb);
	}
	/* 荞ݗvNÃ_~[[h3 */
	dumy_sts = USB0.NRDYSTS.WORD;
	dumy_sts = USB0.NRDYSTS.WORD;
	dumy_sts = USB0.NRDYSTS.WORD;
}











//////////////////////////////////////////////////////////////////////
//BEMP interrupt
//Argument   : USB_U16 status       ; BEMPSTS Register Value
//           : USB_U16 intenb       ; BEMPENB Register Value

void P_BEMPInterrupt(USB_U16 status, USB_U16 intenb)
{
	volatile USB_U16	dumy_sts;

	if( (status & BITBEMP0) && (intenb & BITBEMP0) ) {
		USB0.BEMPSTS.WORD = (USB_U16)~BITBEMP0;
		USB0.CFIFOSEL.BIT.CURPIPE = PIPE0;
		usb_write_buffer_c(PIPE0);
	} 
	else {
		usb_bemp_int(status, intenb);
	}
	/* 荞ݗvNÃ_~[[h3 */
	dumy_sts = USB0.BEMPSTS.WORD;
	dumy_sts = USB0.BEMPSTS.WORD;
	dumy_sts = USB0.BEMPSTS.WORD;
}





///////////////////////////////////////////////////////////////////////
//Reset default control pipe
///////////////////////////////////////////////////////////////////////
void P_ResetDCP(void)
{
	USB0.DCPCFG.WORD=0; //DCP Configuration Register  (0x5C)
	USB0.DCPMAXP.WORD=DeviceDescriptor[7]; //DCP Maxpacket Size Register (0x5E)

	//xFIFOSEL initialization
	USB0.CFIFOSEL.WORD=(USB_U16)(BITMBW_16);
	USB0.D0FIFOSEL.WORD=(USB_U16)(BITMBW_16);
	USB0.D1FIFOSEL.WORD=(USB_U16)(BITMBW_16);
}
///////////////////////////////////////////////////////////////////////
//Reset default control pipe
///////////////////////////////////////////////////////////////////////













//////////////////////////////////////////////////////////////////////
//Reset endpoint
//USB_U16 num          ; Configuration Number

void P_ResetEP(USB_U16 num)
{
	USB_U16		pipe, ep, index, buf;
	USB_U16		*tbl;

	/* Pipe Setting */
	tbl = (USB_U16 *)(EndPntPtr[num-1]);

	for( ep = 1; ep <= MAX_EP_NO; ++ep ) {
		if( EPTableIndex[ep] != EP_ERROR ) {
			index = (USB_U16)(EPL * EPTableIndex[ep]);
			pipe = (USB_U16)(tbl[index+0] & BITCURPIPE);		/* Pipe Number */

			PipeTbl[pipe] = (USB_U16)(((tbl[index+1] & BITDIR) << 3) | 
										ep | 
										(tbl[index+0] & FIFO_USE));

			if((tbl[index+1] & BITDIR) == DIR_P_OUT){
				tbl[index+1]	|= SHTNAKON;
			}

			/* Interrupt Disable */
			buf = USB0.BRDYENB.WORD;
			buf &= (USB_U16)~(BitSet[pipe]);
			USB0.BRDYENB.WORD = buf;				/* Ready Interrupt Disable */
			buf = USB0.NRDYENB.WORD;
			buf &= (USB_U16)~(BitSet[pipe]);
			USB0.NRDYENB.WORD = buf;				/* NotReady Interrupt Disable */
			buf = USB0.BEMPENB.WORD;
			buf &= (USB_U16)~(BitSet[pipe]);
			USB0.BEMPENB.WORD = buf;				/* Empty/SizeErr Interrupt Disable */

			usb_set_pid_nak(pipe);					/* PID = NAK */

			/* CurrentPIPE Clear */
			if( USB0.CFIFOSEL.BIT.CURPIPE == pipe ){
				USB0.CFIFOSEL.BIT.CURPIPE = 0;
			}
			if( USB0.D0FIFOSEL.BIT.CURPIPE == pipe ){
				USB0.D0FIFOSEL.BIT.CURPIPE = 0;
			}
			if( USB0.D1FIFOSEL.BIT.CURPIPE == pipe ){
				USB0.D1FIFOSEL.BIT.CURPIPE = 0;
			}

			/* PIPE Configuration */
			USB0.PIPESEL.WORD = pipe;
			USB0.PIPECFG.WORD = tbl[index+1];
//			USB0.PIPEBUF.WORD = tbl[index+2];
			USB0.PIPEMAXP.WORD = tbl[index+3];
			USB0.PIPEPERI.WORD = tbl[index+4];

			/* Buffer Clear */
			usb_set_sqclr(pipe);							/* SQCLR=1 */
			usb_aclrm(pipe);

			/* init Global */
			PipeFlag[pipe]     = PIPE_IDLE;
			PipeDataSize[pipe] = 0;
		}
	}
}








//////////////////////////////////////////////////////////////////////
//Device descriptor table initialize
//Argument   : USB_U16 mode         ; FULL_SPEED
//           :                      ; HI_SPEED

void P_ResetDeviceDescriptor(USB_U16 mode)
{
	if( mode == HI_SPEED ) {
		/* Hi-Speed Mode */
		Configuration_Hi_1[1]	= DT_CONFIGURATION;
		Configuration_Hi_2[1]	= DT_CONFIGURATION;
		Configuration_Hi_3[1]	= DT_CONFIGURATION;
		Configuration_Hi_4[1]	= DT_CONFIGURATION;
		Configuration_Hi_5[1]	= DT_CONFIGURATION;
		Configuration_Full_1[1]	= DT_OTHER_SPEED_CONFIGURATION;
		Configuration_Full_2[1]	= DT_OTHER_SPEED_CONFIGURATION;
		Configuration_Full_3[1]	= DT_OTHER_SPEED_CONFIGURATION;
		Configuration_Full_4[1]	= DT_OTHER_SPEED_CONFIGURATION;
		Configuration_Full_5[1]	= DT_OTHER_SPEED_CONFIGURATION;
		ConPtr[0]				= Configuration_Hi_1;
		ConPtr[1]				= Configuration_Hi_2;
		ConPtr[2]				= Configuration_Hi_3;
		ConPtr[3]				= Configuration_Hi_4;
		ConPtr[4]				= Configuration_Hi_5;
		ConPtr_Other[0]			= Configuration_Full_1;
		ConPtr_Other[1]			= Configuration_Full_2;
		ConPtr_Other[2]			= Configuration_Full_3;
		ConPtr_Other[3]			= Configuration_Full_4;
		ConPtr_Other[4]			= Configuration_Full_5;
		EPtbl_1[3]				= 512;
		EPtbl_1[8]				= 512;
		EPtbl_1[13]				= 512;
		EPtbl_1[18]				= 512;
		EPtbl_1[23]				= 512;
	} 
	else {
		/* Full-Speed Mode */
		Configuration_Hi_1[1]	= DT_OTHER_SPEED_CONFIGURATION;
		Configuration_Hi_2[1]	= DT_OTHER_SPEED_CONFIGURATION;
		Configuration_Hi_3[1]	= DT_OTHER_SPEED_CONFIGURATION;
		Configuration_Hi_4[1]	= DT_OTHER_SPEED_CONFIGURATION;
		Configuration_Hi_5[1]	= DT_OTHER_SPEED_CONFIGURATION;
		Configuration_Full_1[1]	= DT_CONFIGURATION;
		Configuration_Full_2[1]	= DT_CONFIGURATION;
		Configuration_Full_3[1]	= DT_CONFIGURATION;
		Configuration_Full_4[1]	= DT_CONFIGURATION;
		Configuration_Full_5[1]	= DT_CONFIGURATION;
		ConPtr[0]				= Configuration_Full_1;
		ConPtr[1]				= Configuration_Full_2;
		ConPtr[2]				= Configuration_Full_3;
		ConPtr[3]				= Configuration_Full_4;
		ConPtr[4]				= Configuration_Full_5;
		ConPtr_Other[0]			= Configuration_Hi_1;
		ConPtr_Other[1]			= Configuration_Hi_2;
		ConPtr_Other[2]			= Configuration_Hi_3;
		ConPtr_Other[3]			= Configuration_Hi_4;
		ConPtr_Other[4]			= Configuration_Hi_5;
		EPtbl_1[3]				= 64;
		EPtbl_1[8]				= 64;
		EPtbl_1[13]				= 64;
		EPtbl_1[18]				= 64;
		EPtbl_1[23]				= 64;
	}
}




















//////////////////////////////////////////////////////////////////////
//USBfoCXԂmFAfoCXRtBK[hԂǂmF( Configured ).
//ReturnValue
//USB_YES		:foCXRtBK[hԂł
//USB_ERROR	:foCXRtBK[hԂł͂Ȃ

USB_U16 P_IsConfigured(void)
{
	USB_U16		dvst;

	dvst = P_GetDeviceState();			/* check device state from DVSQ		*/
	if( dvst == DVST_CONFIGURED ){
		return USB_YES;
	}
	return USB_NO;
}





//////////////////////////////////////////////////////////////////////
//USBfoCXԂmF( Configured ).
//ReturnValue: Device States
//DVST_POWERED			:foCXp[h
//DVST_DEFAULT			:foCXftHg
//DVST_ADDRESS			:foCXAhX
//DVST_CONFIGURED		:foCXRtBK[h
//DVST_SUSPEND			:foCXTXyh

USB_U16 P_GetDeviceState(void)
{
	USB_U16 dvsq,dvst;
	
	dvsq = USB0.INTSTS0.WORD;
	switch( dvsq & BITDVSQ ) {
	case DS_POWR:						/* Power state			*/	/* power-on		*/
		//printf("DVST_POWERED\r");
		dvst = DVST_POWERED;
		break;
	case DS_DFLT:						/* Default state  		*/	/* bus-reset	*/
		//printf("DVST_DEFAULT\r");
		dvst = DVST_DEFAULT;
		break;
	case DS_ADDS:						/* Address state  		*/
		//printf("DVST_ADDRESS\r");
		dvst = DVST_ADDRESS;
		break;
	case DS_CNFG:						/* Configured state  	*/
		//printf("DVST_CONFIGURED->USB_YES\r");
		dvst = DVST_CONFIGURED;
		break;
	case DS_SPD_POWR:					/* Power	  Suspend state */
	case DS_SPD_DFLT:					/* Default	  Suspend state */
	case DS_SPD_ADDR:					/* Address	  Suspend state */
	case DS_SPD_CNFG:					/* Configured Suspend state */
		//printf("DVST_SUSPEND\r");
		dvst = DVST_SUSPEND;
		break;
	default:							/* error */
		//printf("DVST_SUSPEND\r");
		dvst = DVST_SUSPEND;
		break;
	}
	return dvst;
}






//////////////////////////////////////////////////////////////////////
//Endpoint number to pipe number
//USB_U16 ep       ; Direction + Endpoint Number
//ReturnValue: EP_ERROR         : Error
//           : Others           : Pipe Number

USB_U16 P_EpToPipe(USB_U16 ep)
{
	USB_U16 pipe;

	for( pipe = 1; pipe <= MAX_PIPE_NO; pipe++ ) {
		if( (PipeTbl[pipe] & 0x00ff) == ep ){
			return pipe;
		}
	}
	return EP_ERROR;
}








//////////////////////////////////////////////////////////////////////
//Peripheral mode Sample Main

void P_Main()
{
//	if(!usb_enable)return;

	if(pipe[PIPE1_OUT].len !=0)	P_DataOUT(PIPE1_OUT, pipe[PIPE1_OUT].len , pipe[PIPE1_OUT].data );

	if(pipe[PIPE2_IN].len !=0)	P_DataIN (PIPE2_IN, pipe[PIPE2_IN].len, pipe[PIPE2_IN].data);

	if(pipe[PIPE3_OUT].len !=0)	P_DataOUT(PIPE3_OUT, pipe[PIPE3_OUT].len, pipe[PIPE3_OUT].data);

	if(pipe[PIPE4_IN].len !=0)	P_DataIN (PIPE4_IN, pipe[PIPE4_IN].len, pipe[PIPE4_IN].data);

	if(pipe[PIPE5_OUT].len !=0)	P_DataOUT(PIPE5_OUT, pipe[PIPE5_OUT].len, pipe[PIPE5_OUT].data);

	if(pipe[PIPE6_IN].len !=0)	P_DataIN (PIPE6_IN, pipe[PIPE6_IN].len, pipe[PIPE6_IN].data);

	if(pipe[PIPE7_OUT].len !=0)	P_DataOUT(PIPE7_OUT, pipe[PIPE7_OUT].len, pipe[PIPE7_OUT].data);

	if(pipe[PIPE8_IN].len !=0)	P_DataIN (PIPE8_IN, pipe[PIPE8_IN].len, pipe[PIPE8_IN].data);

	if(pipe[PIPE9_OUT].len !=0)	P_DataOUT(PIPE9_OUT, pipe[PIPE9_OUT].len, pipe[PIPE9_OUT].data);
}

















//////////////////////////////////////////////////////////////////////
//M(oNOUT)
//Peripheral User data receive
//Argument   : USB_U16 Pipe         ; Pipe Number
//           : USB_U32 Size         ; Data Size
//           : USB_U8  *Table       ; Data Table Address

void P_DataOUT(USB_U16 Pipe, USB_U32 Size, USB_U8 *Table)
{
	USB_U16			buffer;
	USB_U32			lp;
	unsigned char	*ptr;

	buffer = usb_get_pid(Pipe);
	if( ( buffer == PID_STALL ) || (buffer == PID_STALL2) ) {
		return;
	}

	switch( PipeFlag[Pipe] ) {
	case PIPE_IDLE:
		usb_start_recieve_transfer(Pipe, Size, Table);
		break;
	case PIPE_WAIT:
		break;
	case PIPE_DONE:
		PipeFlag[Pipe] = PIPE_IDLE;
		printf( "Recieve Pipe: %d size=%d Complete\n",Pipe, PipeDataSize[Pipe]);
		ptr = (unsigned char *)Table;
		printf( "\r");
		for( lp = 0; lp < PipeDataSize[Pipe]; lp = lp + 16 ){
			printf("%03X:", lp);
			printf(" %02X", *ptr);
			ptr++;
			printf(" %02X", *ptr);
			ptr++;
			printf(" %02X", *ptr);
			ptr++;
			printf(" %02X", *ptr);
			ptr++;
			printf(" %02X", *ptr);
			ptr++;
			printf(" %02X", *ptr);
			ptr++;
			printf(" %02X", *ptr);
			ptr++;
			printf(" %02X", *ptr);
			ptr++;

			printf(" %02X", *ptr);
			ptr++;
			printf(" %02X", *ptr);
			ptr++;
			printf(" %02X", *ptr);
			ptr++;
			printf(" %02X", *ptr);
			ptr++;
			printf(" %02X", *ptr);
			ptr++;
			printf(" %02X", *ptr);
			ptr++;
			printf(" %02X", *ptr);
			ptr++;
			printf(" %02X\r", *ptr);
			ptr++;
		}
		printf( "\r");
		break;

	case PIPE_STALL:
		break;
	case PIPE_NORES:
		break;
	}
}












//////////////////////////////////////////////////////////////////////
//M(oNIN)
//Peripheral User data send
//Argument   : USB_U16 Pipe         ; Pipe Number
//           : USB_U32 Size         ; Data Size
//           : USB_U8  *Table       ; Data Table Address

void P_DataIN(USB_U16 Pipe, USB_U32 Size, USB_U8 *Table)
{
	USB_U16		buffer;

	buffer = usb_get_pid(Pipe);
	if( ( buffer == PID_STALL ) || ( buffer == PID_STALL2 ) ) {
		return;
	}

	switch( PipeFlag[Pipe] ) {

	case PIPE_IDLE:
		usb_start_send_transfer(Pipe, Size, Table);
		break;

	case PIPE_WAIT:
		break;

	case PIPE_DONE:
		PipeFlag[Pipe] = PIPE_IDLE;
		printf( "Send Pipe: %d size=%d Complete\n",Pipe, Size);
		printf( "\r");
		printf( "\r");
		break;

	case PIPE_STALL:
		break;
	case PIPE_NORES:
		break;
	}
}








//////////////////////////////////////////////////////////////////////
//Get Configuration number
//ReturnValue: Number of possible configurations (bNumConfigurations).

USB_U16 P_GetConfigNum(void)
{
	return (USB_U16)DeviceDescriptor[DEV_NUM_CONFIG];
}






//////////////////////////////////////////////////////////////////////
//Get Interface number
//Argument   : USB_U16 Con_Num		; Configuration Number
//ReturnValue: Number of this interface (bNumInterfaces).

USB_U16 P_GetInterfaceNum(USB_U16 num)
{
	return (USB_U16)(*(ConPtr[num-1]+4));
}





//////////////////////////////////////////////////////////////////////
//Get Alternate setting number
//Argument   : USB_U16 Con_Num		; Configuration Number
//           : USB_U16 Int_Num		; Interface Number
//ReturnValue: Value used to select this alternate setting(bAlternateSetting).

USB_U16 P_GetAltNum(USB_U16 Con_Num, USB_U16 Int_Num)
{
	USB_U16	i;
	USB_U16	alt_num = 0;
	USB_U8	*ptr;
	USB_U16	length;

	ptr = (USB_U8 *)(ConPtr[Con_Num-1]);				/* ConfigurationDescriptor[0] */
	i = ptr[0];
	ptr += ptr[0];									/* InterfaceDescriptor[0] */
	length  = (USB_U16)(*(ConPtr[Con_Num-1]+2));
	length |= (USB_U16)((USB_U16)(*(ConPtr[Con_Num-1]+3)) << 8);
	for( ; i < length; ) {							/* Search Descriptor Table size */
		switch( ptr[1] ) {							/* Descriptor Type ? */
		case DT_INTERFACE:							/* Interface */
			if( Int_Num == ptr[2] ) {
				alt_num = (USB_U16)ptr[3];				/* Alternate Number count */
			}
			i += ptr[0];
			ptr += ptr[0];
			break;
		case DT_DEVICE:								/* Device */
		case DT_CONFIGURATION:						/* Configuration */
		case DT_STRING:								/* String */
		case DT_ENDPOINT:							/* Endpoint */
		default:									/* Class, Vendor, else */
			i += ptr[0];
			ptr += ptr[0];
			break;
		}
	}
	return alt_num;
}









//////////////////////////////////////////////////////////////////////
//Endpoint table initialize
//Argument   : USB_U16 Con_Num		; Configuration Number
//           : USB_U16 Int_Num		; Interface Number
//           : USB_U16 Alt_Num		; Alternate Setting
//ReturnValue: void

void P_InitEPTable(USB_U16 Con_Num, USB_U16 Int_Num, USB_U16 Alt_Num)
{
	USB_U8		*ptr;
	USB_U16		i, j, length;
	USB_U16		start, numbers, ep;

	ptr = (USB_U8 *)ConPtr[Con_Num-1];					/* ConfigurationDescriptor */
	i = *ptr;
	length = (USB_U16)((USB_U16)*(ptr + 3) << 8 | (USB_U16)*(ptr + 2));
	ptr += *ptr;
	start = 0;
	numbers = 0;
	j = 0;

	for( ; i < length; ) {
		switch( *(ptr + 1) ) {						/* Descriptor Type ? */
		case DT_INTERFACE:							/* Interface */
			if( (*(ptr + 2) == Int_Num) && (*(ptr + 3) == Alt_Num) ) {
				numbers = *(ptr + 4);
			} 
			else {
				start += *(ptr + 4);
			}
			i += *ptr;
			ptr += *ptr;
			break;
		case DT_ENDPOINT:							/* Endpoint */
			if( j < numbers ) {
				ep = (USB_U16)(*(ptr + 2) & 0x0f);
				EPTableIndex[ep] = (USB_U16)(start + j);
				++j;
			}
			i += *ptr;
			ptr += *ptr;
			break;
		case DT_DEVICE:								/* Device */
		case DT_CONFIGURATION:						/* Configuration */
		case DT_STRING:								/* String */
		default:									/* Class, Vendor, else */
			i += *ptr;
			ptr += *ptr;
			break;
		}
	}
}







//////////////////////////////////////////////////////////////////////
//Check remote wakeup bit (bmAttributes);
//ReturnValue: USB_ON	:	Support Remote Wakeup
//           : USB_OFF	:	not Support Remote Wakeup

USB_U16 P_CheckRemoteWakeup(void)
{
	USB_U8	atr;

	if( ConfigNum == 0 ){
		return USB_OFF;
	}

	atr = *(ConPtr[ConfigNum - 1] + 7);
	if( atr & CF_RWUP ){
		return USB_ON;
	}
	return USB_OFF;
}














//////////////////////////////////////////////////////////////////////
//Get Alternate setting number
//Argument   : USB_U16 Con_Num		; Configuration Number
//           : USB_U16 Int_Num		; Interface Number
//ReturnValue: Value used to select this alternate setting(bAlternateSetting).









//////////////////////////////////////////////////////////////////////
//Endpoint table initialize
//Argument   : USB_U16 Con_Num		; Configuration Number
//           : USB_U16 Int_Num		; Interface Number
//           : USB_U16 Alt_Num		; Alternate Setting
//ReturnValue: void
















//////////////////////////////////////////////////////////////////////
//Get Status
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_GetStatus(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	static USB_U8	tbl[2];
	USB_U16			ep;
	USB_U16			buffer;
	USB_U16			pipe;

	if( (value == 0) && (length == 2) ) {
		tbl[0] = 0;
		tbl[1] = 0;
		switch( type ) {
		case DEVICE:
			if( index == 0 ) {
				tbl[0] = P_GetCurrentPower(ConfigNum);	/* SelfPowered / BusPowered */
				if( RemoteWakeupFlag == USB_ON ){		/* Support Remote Wakeup ? */
					tbl[0] |= GS_REMOTEWAKEUP;
				}
				P_CtrlReadStart(2, tbl);
			} 
			else {
				usb_set_pid_stall(PIPE0);				/* Req Error */
			}
			break;
		case INTERFACE:
			if( P_IsConfigured() == USB_YES ) {
				if( index < P_GetInterfaceNum(ConfigNum) ) {
					P_CtrlReadStart(2, tbl);			/* Return 0 */
				} 
				else {
					usb_set_pid_stall(PIPE0);			/* Req Error */
				}
			} 
			else {
				usb_set_pid_stall(PIPE0);				/* Req Error */
			}
			break;
		case ENDPOINT:
			ep = (USB_U16)(index & EPNUMFIELD);			/* Endpoint Number */
			if( ep == 0 ) {								/* Endpoint 0 */
				if( USB0.DCPCTR.BIT.PID == PID_STALL ) {
				   tbl[0] = GS_HALT;					/* Halt set */
				}
				P_CtrlReadStart(2, tbl);
			} 
			else if( ep <= MAX_EP_NO ) {				/* EP1 to max */
				if( P_IsConfigured() == USB_YES ) {
					pipe = P_EpToPipe(index);
					if( pipe == EP_ERROR ) {
						usb_set_pid_stall(PIPE0);
					} 
					else {
						buffer = usb_get_pid(pipe);
						if( (buffer & PID_STALL) == PID_STALL ) {
							tbl[0] = GS_HALT;			/* Halt set */
						}
						P_CtrlReadStart(2, tbl);
					}
				} 
				else {
					usb_set_pid_stall(PIPE0);
				}
			} 
			else {
				usb_set_pid_stall(PIPE0);
			}
			break;
		default:
			usb_set_pid_stall(PIPE0);
			break;
		}
	} 
	else {
		usb_set_pid_stall(PIPE0);
	}
}








//////////////////////////////////////////////////////////////////////
//Get Descriptor
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_GetDescriptor(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16		len, idx;

	if( type == DEVICE ) {
		idx = (USB_U16)(value & DT_INDEX);
		switch( GET_DT_TYPE(value) ) {
		case DT_DEVICE:									/* device Descriptor */
			if( (index == 0) && (idx == 0) ) {
				if( length < DeviceDescriptor[0] ) {
					P_CtrlReadStart((USB_U32)length, DeviceDescriptor);
				} 
				else {
					P_CtrlReadStart((USB_U32)DeviceDescriptor[0], DeviceDescriptor);
				}
			} 
			else {
				usb_set_pid_stall(PIPE0);				/* Req Error */
			}
			break;
		case DT_CONFIGURATION:							/* Configuration Descriptor */
			if( index == 0 ) {
				len  = (USB_U16)(*(ConPtr[idx]+2));
				len |= (USB_U16)((USB_U16)(*(ConPtr[idx]+3)) << 8);
				if( length < len ) {					/* Descriptor > wLength */
					P_CtrlReadStart((USB_U32)length, ConPtr[idx]);
				} 
				else {
					P_CtrlReadStart((USB_U32)len, ConPtr[idx]);
				}
			} 
			else {
				usb_set_pid_stall(PIPE0);				/* Req Error */
			}
			break;
		case DT_STRING:									/* String Descriptor */
			len = (USB_U16)(*(StrPtr[idx]+0));
			if( length < len ) {
				P_CtrlReadStart((USB_U32)length, StrPtr[idx]);
			} 
			else {
				P_CtrlReadStart((USB_U32)len, StrPtr[idx]);
			}
			break;
		case DT_INTERFACE:								/* Interface Descriptor */
			usb_set_pid_stall(PIPE0);
			break;
		case DT_ENDPOINT:								/* Endpoint Descriptor */
			usb_set_pid_stall(PIPE0);
			break;
		case DT_DEVICE_QUALIFIER:
			if( (usb_is_hispeed_enable() == USB_YES) && 
				(index == 0) && (idx == 0) ) {
				if( length < QualifierDescriptor[0] ) {
					P_CtrlReadStart((USB_U32)length, QualifierDescriptor);
				} 
				else {
					P_CtrlReadStart((USB_U32)QualifierDescriptor[0], 
												QualifierDescriptor);
				}
			} 
			else {
				usb_set_pid_stall(PIPE0);				/* Req Error */
			}
			break;
		case DT_OTHER_SPEED_CONFIGURATION:
			if( (usb_is_hispeed_enable() == USB_YES) &&
				 index == 0 ) {
				len  = (USB_U16)(*(ConPtr_Other[idx]+2));
				len |= (USB_U16)((USB_U16)(*(ConPtr_Other[idx]+3)) << 8);
				if( length < len ) {					/* Descriptor > wLength */
					P_CtrlReadStart((USB_U32)length, ConPtr_Other[idx]);
				} 
				else {
					P_CtrlReadStart((USB_U32)len, ConPtr_Other[idx]);
				}
			} 
			else {
				usb_set_pid_stall(PIPE0);				/* Req Error */
			}
			break;
		case DT_INTERFACE_POWER:
			usb_set_pid_stall(PIPE0);					/* Not Support */
			break;
		default:
			usb_set_pid_stall(PIPE0);
			break;
		}
	} 
	else {
		usb_set_pid_stall(PIPE0);
	}
}









//////////////////////////////////////////////////////////////////////
//Get Configuration
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_GetConfiguration(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	static USB_U8 tbl[1];

	if( (type == DEVICE) && (value == 0) && (index == 0) && (length == 1) ) {
		tbl[0] = (USB_U8)ConfigNum;
		P_CtrlReadStart(1, tbl);
	} 
	else {
		usb_set_pid_stall(PIPE0);
	}
}







//////////////////////////////////////////////////////////////////////
//Get Interface
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_GetInterface(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	static USB_U8	tbl[1];

	if( (type == INTERFACE) && (value == 0) && (length == 1) ) {
		if( index < ALT_NO ) {
			tbl[0] = (USB_U8)Alternate[index];
			P_CtrlReadStart(1, tbl);						/* Start control read */
		} 
		else {
			usb_set_pid_stall(PIPE0);						/* Req Error */
		}
	} 
	else {
		usb_set_pid_stall(PIPE0);							/* Req Error */
	}
}








//////////////////////////////////////////////////////////////////////
//Get currently power
//Argument   : USB_U16 ConfigNum
//ReturnValue: GS_SELFPOWERD	: Device is currently self-powered
//           : GS_BUSPOWERD		: Device is currently bus-powered

USB_U8 P_GetCurrentPower(USB_U16 ConfigNum)
{
	/*
	 * Please answer the currently power of your system.
	 */

    USB_U8	tmp, current;
    USB_U16	conf;

	conf = ConfigNum;
	if( conf < 1 ){
		conf = 1;									/* Address state */
	}

	/* Standard Configuration Descriptor */
	tmp = *(ConPtr[(conf-1)]+7);
	if( tmp & CF_SELF ){
		current = GS_SELFPOWERD;
	}
	else{
		current = GS_BUSPOWERD;
	}

	/* check Currently Powered */

	return current;
}







//////////////////////////////////////////////////////////////////////
//Reserved (Idle/Setup Stage);
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_Resrv_0(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/*==== Reserved ====*/
}






//////////////////////////////////////////////////////////////////////
//Reserved (Control Read Data Stage, Control Write Data Stage,Control Write No Data Status Stage)
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_Resrv_123(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;

	/*==== Reserved ====*/
	usb_set_pid_stall(PIPE0);
}










//////////////////////////////////////////////////////////////////////
//Reserved (Control Read Status Stage).
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_Resrv_4(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/*==== Reserved ====*/
}











//////////////////////////////////////////////////////////////////////
//Reserved (Control Write Status Stage).
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_Resrv_5(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	/*==== Reserved ====*/
}








//////////////////////////////////////////////////////////////////////
//Clear Feature
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_ClearFeature(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 pipe, ep;

	if( length == 0 ) {
		switch( type ) {
		case DEVICE:
			if( value == DEVICE_REMOTE_WAKEUP && index == 0 ) {
				if( P_CheckRemoteWakeup() == USB_ON ) {
					RemoteWakeupFlag = USB_OFF;
					usb_set_pid_buf(PIPE0);					/* OK */
				} 
				else {
					/* Not Support RemoteWakeup */
					usb_set_pid_stall(PIPE0);				/* Req Error */
				}
			} 
			else {
				usb_set_pid_stall(PIPE0);					/* Not Spec */
			}
			break;
		case INTERFACE:
			usb_set_pid_stall(PIPE0);						/* Req Error */
			break;
		case ENDPOINT:
			ep = (USB_U16)(index & EPNUMFIELD);				/* Endpoint Number */
			if( value == ENDPOINT_HALT ) {
				if( ep == 0 ) {								/* EP0 */
					usb_set_pid_buf(PIPE0);					/* Clear STALL & Set BUF */
				} 
				else if( ep <= MAX_EP_NO ) {				/* EP1 to max */
					pipe = P_EpToPipe(index);
					if( pipe == EP_ERROR ) {
						usb_set_pid_stall(PIPE0);			/* Req Error */
					} 
					else {
						usb_set_pid_nak(pipe);				/* Clear STALL & Set NAK */
						usb_set_sqclr(pipe);				/* SQCLR=1 */
						usb_clear_pid_stall(pipe);
						usb_set_pid_buf(pipe);				/* Set BUF */
						usb_set_pid_buf(PIPE0);
					}
				} 
				else {
					usb_set_pid_stall(PIPE0);				/* Req Error */
				}
			} 
			else {
				usb_set_pid_stall(PIPE0);					/* Req Error */
			}
			break;
		default:
			usb_set_pid_stall(PIPE0);
			break;
		}
	} 
	else {
		usb_set_pid_stall(PIPE0);							/* Not Spec */
	}
}












//////////////////////////////////////////////////////////////////////
//Set Feature
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_SetFeature(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16		pipe, ep;

	if( length == 0 ) {
		switch( type ) {
		case DEVICE:
			switch( value ) {
			case DEVICE_REMOTE_WAKEUP:
				if( index == 0 ) {
					if( P_CheckRemoteWakeup() == USB_ON ) {
						RemoteWakeupFlag = USB_ON;
						usb_set_pid_buf(PIPE0);				/* OK */
					} 
					else {
						/* Not Support RemoteWakeup */
						usb_set_pid_stall(PIPE0);			/* Req Error */
					}
				} 
				else {
					usb_set_pid_stall(PIPE0);				/* Not Spec */
				}
				break;
			case TEST_MODE:
				if( usb_is_hispeed() == HI_SPEED ) {
					if( index < TEST_Reserved || TEST_VSTModes <= index ) {
						TestModeFlag = USB_YES;
						TestModeSelectors = index;
						usb_set_pid_buf(PIPE0);				/* OK */
					} 
					else {
						usb_set_pid_stall(PIPE0);			/* Not Spec */
					}
				} 
				else {
					usb_set_pid_stall(PIPE0);				/* Not Spec */
				}
				break;
			default:
				usb_set_pid_stall(PIPE0);					/* Not Spec */
				break;
			}
			break;
		case INTERFACE:
			usb_set_pid_stall(PIPE0);
			break;
		case ENDPOINT:
			ep = (USB_U16)(index & EPNUMFIELD);				/* Endpoint Number */
			if( value == ENDPOINT_HALT ) {
				if( ep == 0 ) {								/* EP0 */
					usb_set_pid_buf(PIPE0);
				} 
				else if( ep <= MAX_EP_NO ) {				/* EP1 to max */
					pipe = P_EpToPipe(index);
					if( pipe == EP_ERROR ) {
						usb_set_pid_stall(PIPE0);			/* Req Error */
					} 
					else {
						usb_set_pid_stall(pipe);			/* Set STALL */
						usb_set_pid_buf(PIPE0);				/* OK */
					}
				} 
				else {
					usb_set_pid_stall(PIPE0);				/* Req Error */
				}
			} 
			else {
				usb_set_pid_stall(PIPE0);					/* Not Spec */
			}
			break;

		default:
			usb_set_pid_stall(PIPE0);						/* Req Error */
			break;
		}
	} 
	else {
		usb_set_pid_stall(PIPE0);							/* Req Error */
	}
}










//////////////////////////////////////////////////////////////////////
//Set Address
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_SetAddress(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	if( type == DEVICE ) {
		if( (index == 0) && (length == 0) ) {
			if( value <= 127 ) {
				usb_set_pid_buf(PIPE0);						/* OK */
			} 
			else {
				usb_set_pid_stall(PIPE0);					/* Not Spec */
			}
		} 
		else {
			usb_set_pid_stall(PIPE0);						/* Not Spec */
		}
	} 
	else {
		usb_set_pid_stall(PIPE0);							/* Req Error */
	}
}









//////////////////////////////////////////////////////////////////////
//Set Descriptor
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_SetDescriptor(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;
	

	usb_set_pid_stall(PIPE0);								/* Not Spec */
}









//////////////////////////////////////////////////////////////////////
//Alternate table clear

void usb_clear_alt(void)
{
	int i;

	for( i = 0; i < ALT_NO; ++i ) {
		Alternate[i] = 0;							/* Alternate */
	}
}








//////////////////////////////////////////////////////////////////////
//Set Configuration
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_SetConfiguration(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 i, ifc;

	if( type == DEVICE ) {
		if( (value <= P_GetConfigNum()) && (index == 0) && (length == 0) ) {
			ConfigNum = value;							/* Configuration Number set */
			usb_clear_alt();							/* Alternate setting clear */
			usb_set_pid_buf(PIPE0);
			if( ConfigNum > 0 ) {
				clear_ep_table_index();
				ifc = P_GetInterfaceNum(ConfigNum);
				for( i = 0; i < ifc; ++i ) {
					P_InitEPTable(ConfigNum, i, 0);
				}
				clear_pipe_tbl();
				P_ResetEP(ConfigNum);
			}
			P_ChangeConfigCB(ConfigNum);
		}
		else {
			usb_set_pid_stall(PIPE0);					/* Req Error */
		}
	}
	else {
		usb_set_pid_stall(PIPE0);						/* Req Error */
	}
}







//////////////////////////////////////////////////////////////////////
//Set Interface
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_SetInterface(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	if( (P_IsConfigured() == USB_YES) && (type == INTERFACE) ) {	/* Configured ? */
		if( (index <= P_GetInterfaceNum(ConfigNum)) && (length == 0) ) {
			if( value <= P_GetAltNum(ConfigNum, index) ) {
				Alternate[index] = (USB_U16)(value & ALT_SET);
				usb_set_pid_buf(PIPE0);
				clear_ep_table_index();
				/* Search endpoint setting */
				P_InitEPTable(ConfigNum, index, Alternate[index]);
				P_ResetEP(ConfigNum);
				P_ChangeInterfaceCB(ConfigNum, index, Alternate[index]);
			} 
			else {
				usb_set_pid_stall(PIPE0);					/* Req Error */
			}
		} 
		else {
			usb_set_pid_stall(PIPE0);						/* Req Error */
		}
	} 
	else {
		usb_set_pid_stall(PIPE0);							/* Req Error */
	}
}








//////////////////////////////////////////////////////////////////////
//Set Frame
//Argument   : USB_U16 type		        ; Recipient (bmRequestType)
//           : USB_U16 value			; wValue
//           : USB_U16 index			; wIndex
//           : USB_U16 length		    ; wLength

void P_SynchFrame(USB_U16 type, USB_U16 value, USB_U16 index, USB_U16 length)
{
	USB_U16 dummy_type, dummy_value, dummy_index, dummy_length;
	dummy_type		= type;
	dummy_value		= value;
	dummy_index		= index;
	dummy_length	= length;

	usb_set_pid_stall(PIPE0);
}








//////////////////////////////////////////////////////////////////////
//Pipe table clear

static void clear_pipe_tbl(void)
{
	int i;

	for( i = 0; i < (MAX_PIPE_NO + 1); ++i ) {
		PipeTbl[i] = 0;
	}
}





//////////////////////////////////////////////////////////////////////
//Endpoint index table clear

static void clear_ep_table_index(void)
{
	int i;

	for( i = 0; i <= MAX_EP_NO; ++i ) {
		EPTableIndex[i] = EP_ERROR;
	}
}


























//////////////////////////////////////////////////////////////////////
//save request register

void P_SaveRequest(void)
{
	USB_U16 buf;

	USB0.INTSTS0.WORD = (USB_U16)~BITVALID;
	buf 				= USB0.USBREQ.WORD;
	ReqType      		= (USB_U16)(buf & bmRequestType);
	ReqTypeType  		= (USB_U16)(buf & bmRequestTypeType);
	ReqTypeRecip 		= (USB_U16)(buf & bmRequestTypeRecip);
	ReqRequest   		= (USB_U16)((buf & bRequest) >> 8);
	ReqValue 			= USB0.USBVAL;
	ReqIndex 			= USB0.USBINDX;
	ReqLength 			= USB0.USBLENG;
}



































//////////////////////////////////////////////////////////////////////
//Check VBUS status
//ReturnValue: USB_ON	:	VBUS ON
//           : USB_OFF	:	VBUS OFF

USB_U16 P_CheckVBUStaus(void)
{
	USB_U16	buf1, buf2, buf3;

	/* monitor VBUS pins					*/
	do {
		buf1 = USB0.INTSTS0.BIT.VBSTS;
		usb_delay_10us(1);
		buf2 = USB0.INTSTS0.BIT.VBSTS;
		usb_delay_10us(1);
		buf3 = USB0.INTSTS0.BIT.VBSTS;
	} while( (buf1 != buf2) || (buf2 != buf3) );

	if( buf1 == USB_OFF ){
		return USB_OFF;		/* detach		*/
	}
	return USB_ON;			/* attach		*/
}








//////////////////////////////////////////////////////////////////////
//USB attach

void P_USBAttachCB(void)
{

#if PRINT_MODE == PRINT_USE
	printf( "Attach to USB Host\n");
	printf( "\n");
	printf( "\n");
	printf( "\n");
	printf( "\n");
#endif

	/* FIFO Clear, etc ... */
	usb_delay_xms(10);

	USB0.SYSCFG.BIT.DPRPU = 1;				/* Pull-up D+ and open D-	 */
}












//////////////////////////////////////////////////////////////////////
//USB detach

void P_USBDetachCB(void)
{
	USB_U16 pipe;

#if PRINT_MODE == PRINT_USE
	#if	1
	printf( "Detach from USB Host\n");
	printf( "\n");
	printf( "\n");
	printf( "\n");
	printf( "\n");
	#endif
#endif

	/* Terminate all the pipes in which communications on port 	*/
	/* are currently carried out 								*/
	for( pipe = 0; pipe < (MAX_PIPE_NO + 1); ++pipe ) {
		if( PipeFlag[ pipe ] != PIPE_IDLE ){
			usb_stop_transfer( pipe );
		}
	}

	USB0.SYSCFG.BIT.DPRPU = 0;				/* open D+ and D-		*/

	USB0.SYSCFG.BIT.USBE  = 0;				/* soft reset module	*/
	USB0.SYSCFG.BIT.USBE  = 1;

	P_EnableINTModule();						/* Interrupt Enable 	*/

}








///////////////////////////////////////////////////////////////////////
//USB bus reset
///////////////////////////////////////////////////////////////////////
void P_USBBusResetCB(void)
{

	usb_init_mem();										/* memory clear */

	if( usb_is_hispeed() == HI_SPEED ){
		P_ResetDeviceDescriptor(HI_SPEED);			/* Device Descriptor reset */
	}
	else{
		P_ResetDeviceDescriptor(FULL_SPEED);		/* Device Descriptor reset */
	}
	P_ResetDCP();									/* Default Control PIPE reset */
}
///////////////////////////////////////////////////////////////////////
//USB bus reset
///////////////////////////////////////////////////////////////////////








//////////////////////////////////////////////////////////////////////
//USB resume

void P_USBResumeCB(void)
{
	/* NOP */

}









//////////////////////////////////////////////////////////////////////
//USB suspend

void P_USBSuspendCB(void)
{
	/* NOP */
}









//////////////////////////////////////////////////////////////////////
//USB testmode (Set_Feature).

void P_USBTestModeCB(void)
{
	switch( TestModeSelectors & TEST_SELECT ) {
	case TEST_J:
	case TEST_K:
	case TEST_SE0_NAK:
	case TEST_PACKET:
//		USB0.TESTMODE.BIT.UTST = (TestModeSelectors >> 8);
		break;
	case TEST_FORCE_ENABLE:
	default:
		break;
	}
}








//////////////////////////////////////////////////////////////////////
//USBW[Zbg
//////////////////////////////////////////////////////////////////////
void usb_reset_module(void)
{
	USB0.SYSCFG.BIT.SCKE=1; //USB0փNbN
	USB0.SYSCFG.BIT.DCFM=0; //t@NV@\
	USB0.SYSCFG.BIT.USBE=1; //USB0W[싖
	//dlɂ U[urbg b51ɐݒ肷
	USB0.SOFCFG.WORD=0x0020;
}
//////////////////////////////////////////////////////////////////////
//USBW[Zbg
//////////////////////////////////////////////////////////////////////









///////////////////////////////////////////////////////////////////////
//USB荞݃xݒ
///////////////////////////////////////////////////////////////////////
void usb_set_int_level(USB_U8 level)
{
	//荞ݗD揇
	IPR(USB0,D0FIFO0)=level;
	IPR(USB0,D1FIFO0)=level;
	IPR(USB0,USBI0)=level;
}
///////////////////////////////////////////////////////////////////////
//USB荞݃xݒ
///////////////////////////////////////////////////////////////////////













///////////////////////////////////////////////////////////////////////
//Initialize USB Module
///////////////////////////////////////////////////////////////////////
void P_InitModule(void)
{
	USB0.SYSCFG.BIT.DCFM=0; //USB function
	USB0.SYSCFG.WORD=BITSCKE; //USB clock operation enabled
	USB0.SYSCFG.BIT.USBE=1; //USB module operation enabled
	
	if(P_CheckVBUStaus()==USB_ON){ //monitor VBUS pin
		P_EnableINTModule(); //Interrupt Enable
		P_USBAttachCB(); //pull-up D+ and open D-

	}else{

		P_USBDetachCB(); //USB Detach with Interrupt Enable
	}
}
///////////////////////////////////////////////////////////////////////
//Initialize USB Module
///////////////////////////////////////////////////////////////////////







///////////////////////////////////////////////////////////////////////
//USB̊荞݂
///////////////////////////////////////////////////////////////////////
void P_EnableINTModule(void)
{
	USB_U16	buf;
	



	//荞݋
	//b08 BRDYE obt@fB荞݋
	//b09 NRDYE obt@mbgfB荞݋
	//b10 BEMPE obt@GveB荞݋
	//b11 CTRE Rg[]Xe[WJڊ荞݋
	//b12 DVSE foCXXe[gJڊ荞݋
	//b13 SOFE t[ԍXV荞݋
	//b14 RSME W[荞݋
	//b15 VBSE VBUS荞݋
	USB0.INTENB0.WORD=0x9D00;//1001 1101 0000 0000

	(void)USB0.INTSTS0.WORD;
	USB0.INTSTS0.WORD=0;

	//荞݃Xe[^X
	IR(USB0,D0FIFO0)=0;
	IR(USB0,D1FIFO0)=0;
	IR(USB0,USBI0)=0;

	//荞ݗD揇
	IPR(USB0,D0FIFO0)=6;
	IPR(USB0,D1FIFO0)=6;
	IPR(USB0,USBI0)=6;

	//荞ݗv
	IEN(USB0,D0FIFO0)=1;
	IEN(USB0,D1FIFO0)=1;
	IEN(USB0,USBI0)=1;

//	USB0.BRDYENB.WORD=0x03FF; //0000 0011 1111 1111
//	USB0.NRDYENB.WORD=0x03FF; //0000 0011 1111 1111
//	USB0.BEMPENB.WORD=0x03FF; //0000 0011 1111 1111

	buf=USB0.INTENB0.WORD;
	buf |=(BITVBSE|BITDVSE|BITCTRE|BITBEMP|BITNRDY|BITBRDY);
	USB0.INTENB0.WORD=buf;

	usb_enable_bemp_int(PIPE0);
}
///////////////////////////////////////////////////////////////////////
//USB̊荞݂
///////////////////////////////////////////////////////////////////////








///////////////////////////////////////////////////////////////////////
//D0FIFO0荞
///////////////////////////////////////////////////////////////////////
void USB0_D0FIFO0(void)
{
	printf("!USB0 D0FIFO0\r");
}
///////////////////////////////////////////////////////////////////////
//D0FIFO0荞
///////////////////////////////////////////////////////////////////////




///////////////////////////////////////////////////////////////////////
//D1FIFO0荞
///////////////////////////////////////////////////////////////////////
void USB0_D1FIFO0(void)
{
	printf("!USB0 D1FIFO0\r");
}
///////////////////////////////////////////////////////////////////////
//D1FIFO0荞
///////////////////////////////////////////////////////////////////////








///////////////////////////////////////////////////////////////////////
//P_USBInterrupt 
///////////////////////////////////////////////////////////////////////
void P_USBInterrupt(void)
{
	USB_U16	int_sts0, int_sts1, int_sts2, int_sts3;		/* interrupt status */
	USB_U16	int_enb0, int_enb2, int_enb3, int_enb4;		/* interrupt enable */
	volatile USB_U16	dumy_sts;


	int_sts0= USB0.INTSTS0.WORD;
	if( !(int_sts0 & (BITVBINT|BITRESM|BITSOFR|BITDVST|
						BITCTRT|BITBEMP|BITNRDY|BITBRDY)) ) {
		return;
	}

	printf("!USB0 INTSTS0=0x%04X\r",int_sts0);

	int_sts1=USB0.BRDYSTS.WORD;
	int_sts2=USB0.NRDYSTS.WORD;
	int_sts3=USB0.BEMPSTS.WORD;
	int_enb0=USB0.INTENB0.WORD;
	int_enb2=USB0.BRDYENB.WORD;
	int_enb3=USB0.NRDYENB.WORD;
	int_enb4=USB0.BEMPENB.WORD;

	if((int_sts0 & BITRESM)&&(int_enb0 & BITRSME)){
		printf("W[荞݃Xe[^X\r");
		USB0.INTSTS0.WORD=(USB_U16)~BITRESM;	//Status Clear
		USB0.INTENB0.BIT.RSME=0;				//RESM Interrupt Disable
		P_USBResumeCB();
	}

	else
	if((int_sts0 & BITVBINT) && (int_enb0 & BITVBSE)){
		printf("VBUS 荞݃Xe[^X\r");
		USB0.INTSTS0.WORD=(USB_U16)~BITVBINT;	//Status Clear
		if(P_CheckVBUStaus()==USB_ON){
			P_USBAttachCB();							//USB Attach(ڑ)
		} 
		else {
			P_USBDetachCB();							//USB Detach(ؒf)
		}
	}

	//t[ԍXV荞݃Xe[^X(1ms Ɍo)
	else
	if((int_sts0 & BITSOFR)&&(int_enb0 & BITSOFE)){
		USB0.INTSTS0.WORD=(USB_U16)~BITSOFR;
		//User program
	}

	//foCXXe[gJڊ荞݃Xe[^X
	else
	if((int_sts0 & BITDVST)&&(int_enb0 & BITDVSE)){
		USB0.INTSTS0.WORD=(USB_U16)~BITDVST;
		switch(int_sts0 & BITDVSQ){

		//bit 2`0
		case DS_POWR:						//Power state
			break;

		case DS_DFLT:						//Default state
			P_USBBusResetCB();
			break;
		case DS_ADDS:						//Address state 
			break;
		case DS_CNFG:						//Configured state
			break;

		//TXyhXe[g bit 3
		case DS_SPD_POWR:					//Power	  Suspend state
		case DS_SPD_DFLT:					//Default	  Suspend state
		case DS_SPD_ADDR:					//Address	  Suspend state
		case DS_SPD_CNFG:					//Configured Suspend state
			P_USBSuspendCB();
			break;
		default:								//error
			break;
		}
	}

	//Processing PIPE0 data
	else
	if((int_sts0 & BITBEMP)&&(int_enb0 & BITBEMP)&&	((int_sts3 & int_enb4) & BITBEMP0)){
		printf("obt@GveB\r");
		P_BEMPInterrupt(int_sts3, int_enb4);
	}

	//BRDYNRDYɋNꍇ̂ŁABRDY
	else
	if((int_sts0 & BITBRDY)&&(int_enb0 & BITBRDY)&&	((int_sts1 & int_enb2) & BITBRDY0)){
		printf("obt@fB\r");
		P_BRDYInterrupt(int_sts1, int_enb2);
	}

	else
	if((int_sts0 & BITNRDY)&&(int_enb0 & BITNRDY)&&	((int_sts2 & int_enb3) & BITNRDY0)){
		printf("obt@mbgfB\r");

		P_NRDYInterrupt(int_sts2, int_enb3);
	}

	else
	if((int_sts0 & BITCTRT) && (int_enb0 & BITCTRE)){
		printf("Rg[]Xe[W\r");

		int_sts0 = USB0.INTSTS0.WORD;					//CTSQ read
		USB0.INTSTS0.WORD = (USB_U16)~BITCTRT;

		switch( int_sts0 & BITCTSQ ) {
		//idle or setup stage
		case CS_IDST:
			if( TestModeFlag == USB_YES ) {
				P_USBTestModeCB();//Test Mode
			}
			switch( ReqTypeType ) {
			case STANDARD:							//standard request
				(*pbRequest0[ReqRequest])(ReqTypeRecip, ReqValue, ReqIndex, ReqLength);
				break;
			case CLASS:								//class request
				P_Class0(ReqType, ReqRequest, ReqValue, ReqIndex, ReqLength);
				break;
			case VENDOR:								//user request
				P_Vendor0(ReqType, ReqRequest, ReqValue, ReqIndex, ReqLength);
				break;
			default:									//request error
				break;
			}
			break;

		//control read data stage
		case CS_RDDS:
			P_SaveRequest();						//save request register
			switch( ReqTypeType ) {
			case STANDARD:							//standard request
				(*pbRequest1[ReqRequest])(ReqTypeRecip, ReqValue, ReqIndex, ReqLength);
				break;
			case CLASS:								//class request
				P_Class1(ReqType, ReqRequest, ReqValue, ReqIndex, ReqLength);
				break;
			case VENDOR:								//user request
				P_Vendor1(ReqType, ReqRequest, ReqValue, ReqIndex, ReqLength);
				break;
			default:									//request error
				break;
			}
			break;

		//control write data stage
		case CS_WRDS:
			P_SaveRequest();						//save request register
			switch( ReqTypeType ) {
			case STANDARD:							//standard request
				(*pbRequest2[ReqRequest])(ReqTypeRecip, ReqValue, ReqIndex, ReqLength);
				break;
			case CLASS:								//calss request
				P_Class2(ReqType, ReqRequest, ReqValue, ReqIndex, ReqLength);
				break;
			case VENDOR:								//user request
				P_Vendor2(ReqType, ReqRequest, ReqValue, ReqIndex, ReqLength);
				break;
			default:									//request error
				break;
			}
			break;

		//control write nodata status stage
		case CS_WRND:
			P_SaveRequest();						//save request register
			switch( ReqTypeType ) {
			case STANDARD:							//standard request
				(*pbRequest3[ReqRequest])(ReqTypeRecip, ReqValue, ReqIndex, ReqLength);
				break;
			case CLASS:								//class request
				P_Class3(ReqType, ReqRequest, ReqValue, ReqIndex, ReqLength);
				break;
			case VENDOR:								//user request
				P_Vendor3(ReqType, ReqRequest, ReqValue, ReqIndex, ReqLength);
				break;
			default:									//request error
				break;
			}
			USB0.DCPCTR.BIT.CCPL = 1;
			break;
		case CS_RDSS:								//control read status stage
			switch( ReqTypeType ) {
			case STANDARD:							//standard request
				(*pbRequest4[ReqRequest])(ReqTypeRecip, ReqValue, ReqIndex, ReqLength);
				break;
			case CLASS:								//class request
				P_Class4(ReqType, ReqRequest, ReqValue, ReqIndex, ReqLength);
				break;
			case VENDOR:								//user request
				P_Vendor4(ReqType, ReqRequest, ReqValue, ReqIndex, ReqLength);
				break;
			default:									//request error
				break;
			}
			USB0.DCPCTR.BIT.CCPL = 1;
			break;

		//control write status stage
		case CS_WRSS:
			switch( ReqTypeType ) {
			case STANDARD:							//standard request
				(*pbRequest5[ReqRequest])(ReqTypeRecip, ReqValue, ReqIndex, ReqLength);
				break;
			case CLASS:								//class request
				P_Class5(ReqType, ReqRequest, ReqValue, ReqIndex, ReqLength);
				break;
			case VENDOR:								//user request
				P_Vendor5(ReqType, ReqRequest, ReqValue, ReqIndex, ReqLength);
				break;
			default:									//request error
				break;
			}
			USB0.DCPCTR.BIT.CCPL = 1;
			break;

		//control sequence error
		case CS_SQER:
			usb_set_pid_stall(PIPE0);
			break;

		//illegal
		default:
			usb_set_pid_stall(PIPE0);
			break;
		}
	}

	//Processing whithout PIPE0 data
	else
	if( (int_sts0 & BITBEMP) && (int_enb0 & BITBEMP) && (int_sts3 & int_enb4) ) {
		printf("obt@GveB2\r");
		P_BEMPInterrupt(int_sts3, int_enb4);
	}

	//BRDYNRDYɋNꍇ̂ŁABRDY
	else
	if((int_sts0 & BITBRDY)&&(int_enb0 & BITBRDY)&&(int_sts1 & int_enb2)){
		printf("obt@fB2\r");
		P_BRDYInterrupt(int_sts1, int_enb2);
	}

	else
	if((int_sts0 & BITNRDY)&&(int_enb0 & BITNRDY)&&(int_sts2 & int_enb3)){
		printf("obt@mbgfB2\r");
		P_NRDYInterrupt(int_sts2, int_enb3);
	}

	//荞ݗvNÃ_~[[h3
	dumy_sts=USB0.INTSTS0.WORD;
	dumy_sts=USB0.INTSTS0.WORD;
	dumy_sts=USB0.INTSTS0.WORD;
}
///////////////////////////////////////////////////////////////////////
//P_USBInterrupt 
///////////////////////////////////////////////////////////////////////
/*
!USB0 INTSTS0=0x8080
VBUS 荞݃Xe[^X
!USB0 INTSTS0=0x10C0
!USB0 INTSTS0=0x5090
!USB0 INTSTS0=0x6899
Rg[]Xe[W
!USB0 INTSTS0=0x6491
obt@GveB
!USB0 INTSTS0=0x6892
Rg[]Xe[W
!USB0 INTSTS0=0x6890
Rg[]Xe[W
!USB0 INTSTS0=0x7090
!USB0 INTSTS0=0x6899
Rg[]Xe[W
!USB0 INTSTS0=0x6491
obt@GveB
!USB0 INTSTS0=0x6892
Rg[]Xe[W
!USB0 INTSTS0=0x6890
Rg[]Xe[W
!USB0 INTSTS0=0x7090
!USB0 INTSTS0=0x6899
Rg[]Xe[W
!USB0 INTSTS0=0x6491
obt@GveB
!USB0 INTSTS0=0x6892
Rg[]Xe[W
!USB0 INTSTS0=0x6890
Rg[]Xe[W
!USB0 INTSTS0=0x7090
!USB0 INTSTS0=0x6899
Rg[]Xe[W
!USB0 INTSTS0=0x6491
obt@GveB
!USB0 INTSTS0=0x6892
Rg[]Xe[W
!USB0 INTSTS0=0x6890
Rg[]Xe[W
!USB0 INTSTS0=0x70D0

0 0 0FACh܂̓ZbgAbvXe[W
0 0 1FRg[[hf[^Xe[W
0 1 0FRg[[hXe[^XXe[W
0 1 1FRg[Cgf[^Xe[W
1 0 0FRg[CgXe[^XXe[W
1 0 1FRg[CgiNoDatajXe[^XXe[W
1 1 0FRg[]V[PXG[
1 1 1Fݒ肵Ȃł


*/








///////////////////////////////////////////////////////////////////////
//USBW[֐
///////////////////////////////////////////////////////////////////////
//USBW[USBt@NV[hŏ

void P_ModeInit(void)
{
	usb_set_int_level(USBLVL);


	SYSTEM.PRCR.WORD=0xA50B; //veNgOFF  
	MPC.PWPR.BIT.B0WI=0; //PFSWErbgւ݂̏  
	MPC.PWPR.BIT.PFSWE=1; //PFSWX^ւ݂̏  

	PORT1.PMR.BIT.B6=0; //P16 USB0_VBUS
	PORT2.PMR.BIT.B3=0; //P23 USB0_DPUPE
	PORT2.PMR.BIT.B0=0; //P20 USB_ID
	PORT1.PMR.BIT.B4=0; //P14 USB0_DPUPE
	PORT2.PMR.BIT.B2=0; //P22 USB0_DRPD
	PORT2.PMR.BIT.B5=0; //P25 USB0_DPRPD
	PORT2.PMR.BIT.B1=0; //P21 USB0_EXICEN
	PORT2.PMR.BIT.B4=0; //P24 USB0_VBUSEN

	MPC.P16PFS.BYTE=0x11; //P16 USB0_VBUS
	MPC.P23PFS.BYTE=0x13; //P23 USB0_DPUPE
	MPC.P20PFS.BYTE=0x13; //P20 USB_ID
	MPC.P14PFS.BYTE=0x11; //P14 USB0_DPUPE
	MPC.P22PFS.BYTE=0x13; //P22 USB0_DRPD
	MPC.P25PFS.BYTE=0x13; //P25 USB0_DPRPD
	MPC.P21PFS.BYTE=0x13; //P21 USB0_EXICEN
	MPC.P24PFS.BYTE=0x13; //P24 USB0_VBUSEN

	PORT1.PMR.BIT.B6=1; //P16 USB0_VBUS
	PORT2.PMR.BIT.B3=1; //P23 USB0_DPUPE
	PORT2.PMR.BIT.B0=1; //P20 USB_ID
	PORT1.PMR.BIT.B4=1; //P14 USB0_DPUPE
	PORT2.PMR.BIT.B2=1; //P22 USB0_DRPD
	PORT2.PMR.BIT.B5=1; //P25 USB0_DPRPD
	PORT2.PMR.BIT.B1=1; //P21 USB0_EXICEN
	PORT2.PMR.BIT.B4=1; //P24 USB0_VBUSEN

	MSTP_USB0=0; //USB0W[싖

	MPC.PWPR.BIT.PFSWE=0; //PFSWErbgւ݂̏֎~  
	MPC.PWPR.BIT.B0WI=1; //PFSWX^ւ݂̏֎~  
	SYSTEM.PRCR.WORD=0xA500; //veNgON



	usb_reset_module();				//reset USB module with setting tranciever and HSE=1

	usb_init_mem();					//clear variables

	P_InitModule();					//select USB Function and Interrupt Enable	
												//Detect USB Device to attach or detach
}
///////////////////////////////////////////////////////////////////////
//USBW[֐
///////////////////////////////////////////////////////////////////////























